/***************************************************************************
 *
 * Copyright (C) 2006-200v  SMSC
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ***************************************************************************
 * File: 931xControlInterface.h
 */


#ifndef SMSC931X_CONTROL_INTERFACE_H
#define SMSC931X_CONTROL_INTERFACE_H

#include "smsc931x.h"
#include "switchReg.h"
#include "931xReg.h"


#ifdef CHIP_IS_LAN9303
#define _SPI_EXTERNAL_CLK_MODE
#endif
#define SPI_AUTO_INCREMENT		TRUE
#define SPI_AUTO_DECREMENT		FALSE

#define MAKEWORD(low, high) 	((unsigned short) (((unsigned short)((unsigned char) (low))) | ((unsigned short) ((unsigned char) (high))) << 8U))

#define MAKEDWORD(low, high)	((unsigned long)(((unsigned long)((unsigned short)(low))) | (((unsigned long)((unsigned short)(high))) << 16UL)))


/*
 ****************************************************************************
 *	Global Function Prototypes
 ****************************************************************************
 *
 */

void  HbiLanSetRegDW(const DWORD dwLanBase, const DWORD dwOffset, const DWORD dwVal);
DWORD HbiLanGetRegDW( const DWORD dwLanBase, const DWORD dwOffset);

// System CSR's using SMI
void 	SmiLanSetRegDW( const DWORD dwLanBase, const DWORD dwOffset, const DWORD dwVal);
DWORD 	SmiLanGetRegDW( const DWORD dwLanBase, const DWORD dwOffset);


//  SPI Register access
void 	SpiLanSetRegDW( const DWORD dwLanBase, const DWORD dwOffset, const DWORD dwVal);
DWORD 	SpiLanGetRegDW( const DWORD dwLanBase, const DWORD dwOffset);

BOOLEAN SpiMultipleRead( const BOOLEAN bDirection, const DWORD dwOffset,
			const DWORD dwSize, DWORD *pdwBuf);
BOOLEAN SpiMultipleWrite( const BOOLEAN bDirection, const DWORD dwOffset,
			 const DWORD dwSize, const DWORD * const pdwBuf);

//  I2C  Register access
void 	I2cLanSetRegDW( const DWORD dwLanBase, const DWORD dwOffset, const DWORD dwVal);
DWORD 	I2cLanGetRegDW( const DWORD dwLanBase, const DWORD dwOffset);

BOOLEAN I2cMasterRead(const DWORD dwOffset, const DWORD dwSize, DWORD *pdwBuf);
BOOLEAN I2cMasterWrite(const DWORD dwOffset, const DWORD dwSize, const DWORD * const pdwBuf);


WORD MiiGetRegW(const DWORD dwLanBase, const DWORD dwPhyAddress,
	       const DWORD dwMiiIndex);

void MiiSetRegW(const DWORD dwLanBase, const DWORD dwPhyAddress,
		const DWORD dwMiiIndex, const WORD wVal);



#endif /* __931SCI_H__ */
