/***************************************************************************
 *
 * Copyright (C) 2006-200v  SMSC
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ***************************************************************************
 * File: 931xReg.h
 */


#ifndef __931REG_H__
#define __931REG_H__


#include "931xReg.h"




/*
 ****************************************************************************
 ****************************************************************************          HW_CFG
 *	TX/RX FIFO Port Register (Direct Address)      TX_DATA_FIFO_PORT
 *	Offset (from Base Address)
 *	and bit definitions
 ****************************************************************************
 ****************************************************************************
 */
#define RX_DATA_FIFO					(0x00UL)
#define TX_DATA_FIFO					(0x20UL)
	#define TX_CMD_A_INT_ON_COMP_				(0x80000000UL)
	#define TX_CMD_A_INT_BUF_END_ALGN_			(0x03000000UL)
	#define TX_CMD_A_INT_4_BYTE_ALGN_			(0x00000000UL)
	#define TX_CMD_A_INT_16_BYTE_ALGN_			(0x01000000UL)
	#define TX_CMD_A_INT_32_BYTE_ALGN_			(0x02000000UL)
	#define TX_CMD_A_INT_DATA_OFFSET_			(0x001F0000UL)
	#define TX_CMD_A_INT_FIRST_SEG_				(0x00002000UL)
	#define TX_CMD_A_INT_LAST_SEG_				(0x00001000UL)
	#define TX_CMD_A_BUF_SIZE_				(0x000003FFUL)

	#define TX_CMD_B_PKT_TAG_				(0xFFFF0000UL)
	#define TX_CMD_B_ADD_CRC_DISABLE_			(0x00002000UL)
	#define TX_CMD_B_DISABLE_PADDING_			(0x00001000UL)
	#define TX_CMD_B_PKT_BYTE_LENGTH_			(0x000003FFUL)

#define RX_STATUS_FIFO_PORT				(0x40UL)
#define		RX_STS_ES_				(0x00008000UL)  // Error Status
#define		RX_STS_MCAST_				(0x00000400UL)  //Frame is multicast
#define RX_FIFO_PEEK					(0x44UL)
#define TX_STATUS_FIFO_PORT				(0x48UL)
#define TX_FIFO_PEEK					(0x4CUL)

/*
 ****************************************************************************
 ****************************************************************************
 *	Slave Interface Module Control and Status Register (Direct Address)
 *	Offset (from Base Address)
 *	and bit definitions
 ****************************************************************************
 ****************************************************************************
 */

#define ID_REV						(0x50UL)
	#define ID_REV_CHIP_ID_					(0xFFFF0000UL)	// RO	default 0x9312
	#define ID_REV_REV_ID_					(0x0000FFFFUL)	// RO

#define INT_CFG						(0x54UL)
	#define INT_CFG_INT_DEAS_				(0xFF000000UL)	// R/W
	#define INT_CFG_INT_DEAS_CLR_				(0x00004000UL)	// SC
	#define INT_CFG_INT_DEAS_STS_				(0x00002000UL)	// RO
	#define INT_CFG_IRQ_INT_				(0x00001000UL)	// RO
	#define INT_CFG_IRQ_EN_					(0x00000100UL)	// R/W
	#define INT_CFG_IRQ_POL_				(0x00000010UL)	// R/W Not Affected by SW Reset
	#define INT_CFG_IRQ_TYPE_				(0x00000001UL)	// R/W Not Affected by SW Reset

#define INT_STS						(0x58UL)
	#define INT_STS_SW_INT_								(0x80000000UL)	// R/WC
	#define INT_STS_READY_					(0x40000000UL)	// R/WC
	#define INT_STS_1588_EVNT_				(0x20000000UL)	// R/WC
	#define INT_STS_SWITCH_INT_				(0x10000000UL)	// R/WC
	#define INT_STS_PHY_INT2_				(0x08000000UL)	// R/WC
	#define INT_STS_PHY_INT1_				(0x04000000UL)	// R/WC
	#define INT_STS_TXSTOP_INT_				(0x02000000UL)	// R/WC
	#define INT_STS_RXSTOP_INT_				(0x01000000UL)	// R/WC
	#define INT_STS_RXDFH_INT_				(0x00800000UL)	// R/WC
	#define INT_STS_TX_IOC_					(0x00200000UL)	// R/WC
	#define INT_STS_RXD_INT_				(0x00100000UL)	// R/WC
	#define INT_STS_GPT_INT_				(0x00080000UL)	// R/WC
	#define INT_STS_PME_INT_				(0x00020000UL)	// R/WC
	#define INT_STS_TXSO_					(0x00010000UL)	// R/WC
	#define INT_STS_RWT_					(0x00008000UL)	// R/WC
	#define INT_STS_RXE_					(0x00004000UL)	// R/WC
	#define INT_STS_TXE_					(0x00002000UL)	// R/WC
	#define INT_STS_GPIO_					(0x00001000UL)	// RO
	#define INT_STS_TDFU_					(0x00000800UL)	// R/WC
	#define INT_STS_TDFO_					(0x00000400UL)	// R/WC
	#define INT_STS_TDFA_					(0x00000200UL)	// R/WC
	#define INT_STS_TSFF_					(0x00000100UL)	// R/WC
	#define INT_STS_TSFL_					(0x00000080UL)	// R/WC
	#define INT_STS_RXDF_INT_				(0x00000040UL)	// R/WC
	#define		INT_STS_RDFO_					(0x00000040UL)	// R/WC	     /** MO **/
	#define INT_STS_RDFL_					(0x00000020UL)	// R/WC
	#define INT_STS_RSFF_					(0x00000010UL)	// R/WC
	#define INT_STS_RSFL_					(0x00000008UL)	// R/WC

#define INT_EN						(0x5CUL)
	#define INT_EN_SW_INT_EN_				(0x80000000UL)	// R/W
	#define INT_EN_READY_EN_				(0x40000000UL)	// R/WC
	#define INT_EN_1588_EVNT_EN_				(0x20000000UL)	// R/WC
	#define INT_EN_SWITCH_INT_EN_				(0x10000000UL)	// R/WC
	#define INT_EN_PHY_INT2_EN_				(0x08000000UL)	// R/WC
	#define INT_EN_PHY_INT1_EN_				(0x04000000UL)	// R/WC
	#define INT_EN_TXSTOP_INT_EN_				(0x02000000UL)	// R/W
	#define INT_EN_RXSTOP_INT_EN_				(0x01000000UL)	// R/W
	#define INT_EN_RXDFH_INT_EN_				(0x00800000UL)	// R/W
	#define INT_EN_TIOC_INT_EN_				(0x00200000UL)	// R/W
	#define INT_EN_RXD_INT_EN_				(0x00100000UL)	// R/W
	#define INT_EN_GPT_INT_EN_				(0x00080000UL)	// R/W
	#define INT_EN_PME_INT_EN_				(0x00020000UL)	// R/W
	#define INT_EN_TXSO_EN_					(0x00010000UL)	// R/W
	#define INT_EN_RWT_EN_					(0x00008000UL)	// R/W
	#define INT_EN_RXE_EN_					(0x00004000UL)	// R/W
	#define INT_EN_TXE_EN_					(0x00002000UL)	// R/W
	#define INT_EN_GPIO_EN_					(0x00001000UL)	// R/W
	#define INT_EN_TDFU_EN_					(0x00000800UL)	// R/W
	#define INT_EN_TDFO_EN_					(0x00000400UL)	// R/W
	#define INT_EN_TDFA_EN_					(0x00000200UL)	// R/W
	#define INT_EN_TSFF_EN_					(0x00000100UL)	// R/W
	#define INT_EN_TSFL_EN_					(0x00000080UL)	// R/W
	#define INT_EN_RDFO_EN_					(0x00000040UL)	// R/W
	#define INT_EN_RDFL_EN_					(0x00000020UL)	// R/W
	#define INT_EN_RSFF_EN_					(0x00000010UL)	// R/W
	#define INT_EN_RSFL_EN_					(0x00000008UL)	// R/W
#define DMA_CFG						(0x60UL)	// reserved
#define BYTE_TEST					(0x64UL)	// RO default 0x87654321
#define FIFO_INT					(0x68UL)
	#define FIFO_INT_TX_AVAIL_LEVEL_			(0xFF000000UL)	// R/W
	#define FIFO_INT_TX_STS_LEVEL_				(0x00FF0000UL)	// R/W
	#define FIFO_INT_RX_AVAIL_LEVEL_			(0x0000FF00UL)	// R/W
	#define FIFO_INT_RX_STS_LEVEL_				(0x000000FFUL)	// R/W

#define RX_CFG						(0x6CUL)
	#define RX_CFG_RX_END_ALGN_				(0xC0000000UL)	// R/W
	#define RX_CFG_RX_END_ALGN4_				(0x00000000UL)	// R/W
	#define RX_CFG_RX_END_ALGN16_				(0x40000000UL)	// R/W
	#define RX_CFG_RX_END_ALGN32_				(0x80000000UL)	// R/W
	#define RX_CFG_RX_DMA_CNT_				(0x0FFF0000UL)	// R/W
	#define RX_CFG_RX_DUMP_					(0x00008000UL)	// R/W
	#define RX_CFG_RXDOFF_					(0x00001F00UL)	// R/W

#define TX_CFG						(0x70UL)
	#define TX_CFG_TXS_DUMP_				(0x00008000UL)	// Self Clearing
	#define TX_CFG_TXD_DUMP_				(0x00004000UL)	// Self Clearing
	#define TX_CFG_TXSAO_					(0x00000004UL)	// R/W
	#define TX_CFG_TX_ON_					(0x00000002UL)	// R/W
	#define TX_CFG_STOP_TX_					(0x00000001UL)	// Self Clearing

#define HW_CFG						(0x74UL)
	#define HW_CFG_READY_					(0x08000000UL)	// R/W
	#define HW_CFG_AMDIX_EN_P2_				(0x04000000UL)	// R/W
	#define HW_CFG_AMDIX_EN_P1_				(0x02000000UL)	// R/W
	#define HW_CFG_TTM_					(0x00200000UL)	// R/W
	#define HW_CFG_SF_					(0x00100000UL)	// R/W
	#define HW_CFG_TX_FIF_SZ_				(0x000F0000UL)	// R/W
	#define HW_CFG_TR_					(0x00003000UL)	// R/W

	#define HW_CFG_PHY_CLK_SEL_				(0x00000060UL)	// R/W
		#define HW_CFG_PHY_CLK_SEL_DISABLED_			(0x00000040UL)	// R/W
		#define HW_CFG_PHY_CLK_SEL_EXT_PHY_			(0x00000020UL)	// R/W
		#define HW_CFG_PHY_CLK_SEL_INT_PHY_			(0x00000000UL)	// R/W

	#define HW_CFG_SMI_SEL_					(0x00000010UL)	// R/W
		#define HW_CFG_SMI_SEL_EXT_PHY_				(0x00000010UL)	// R/W
		#define HW_CFG_SMI_SEL_INT_PHY_				(0x00000000UL)	// R/W

	#define  HW_CFG_EXT_PHY_DET_				(0x00000008UL)  // RO     			/** MO **/

	#define HW_CFG_PHY_ENABLE_				(0x00000004UL)	// R/W
		#define HW_CFG_PHY_ENABLE_EXT_PHY_			(0x00000004UL)	// R/W
		#define HW_CFG_PHY_ENABLE_INT_PHY_			(0x00000000UL)	// R/W
		#define HW_CFG_EXT_PHY_EN_  					(0x00000004UL)	// R/W		 /** MO **/
	#define HW_CFG_32_16_BIT_MODE_				(0x00000004UL)	// RO
	#define HW_CFG_SRST_					(0x00000001UL)	// Self Clearing

#define RX_DP_CTL					(0x78UL)
	#define RX_DP_CTL_FFWD_BUSY_				(0x80000000UL)	// S/C

#define RX_FIFO_INF					(0x7CUL)
	#define RX_FIFO_INF_RXSUSED_				(0x00FF0000UL)	// RO
	#define RX_FIFO_INF_RXDUSED_				(0x0000FFFFUL)	// RO

#define TX_FIFO_INF					(0x80UL)
	#define TX_FIFO_INF_TXSUSED_				(0x00FF0000UL)	// RO
	#define TX_FIFO_INF_TSFREE_                             (0x00FF0000UL)	// RO   			/** MO **/
	#define TX_FIFO_INF_TDFREE_				(0x0000FFFFUL)	// RO
#define PMT_CTRL					(0x84UL)
	#define PMT_CTRL_ED_STS2_				(0x00020000UL)	// R/WC
	#define PMT_CTRL_ED_STS1_				(0x00010000UL)	// R/WC
	#define PMT_CTRL_ED_EN2_				(0x00008000UL)	// R/W
	#define PMT_CTRL_ED_EN1_				(0x00004000UL)	// R/W
	#define PMT_CTRL_VPHY_RST_				(0x00000400UL)	// R/SC
	#define PMT_CTRL_WOL_EN_				(0x00000200UL)	// R/W
	#define PMT_CTRL_PME_TYPE_				(0x00000040UL)	// R/W NASR
	#define PMT_CTRL_WOL_STS_				(0x00000020UL)	// R/WC

	#define PMT_CTRL_PME_IND_				(0x00000008UL)	// R/W
	#define PMT_CTRL_PME_POL_				(0x00000004UL)	// R/W NASR
	#define PMT_CTRL_PME_EN_				(0x00000002UL)	// R/W
	#define PMT_CTRL_READY_					(0x00000001UL)	// RO


#define GPT_CFG						(0x8CUL)
	#define GPT_CFG_TIMER_EN_				(0x20000000UL)	// R/W
	#define GPT_CFG_GPT_LOAD_				(0x0000FFFFUL)	// R/W

#define GPT_CNT						(0x90UL)
	#define GPT_CNT_GPT_CNT_				(0x0000FFFFUL)	// RO

#define FPGA_REV					(0x94UL)
	#define FPGA_REV_FPGA_REV_				(0x0000FFFFUL)	// RO

#define ENDIAN						(0x98UL)	// R/W Not Affected by SW Reset

#define FREE_RUN					(0x9CUL)

#define RX_DROP						(0xA0UL)

#define PMI_DATA						(0xA4UL)
	#define PMI_DATA_MII_DATA_					(0x0000FFFFUL) //R/W

#define PMI_ACCESS						(0xA8UL)
	#define PMI_ACCESS_PHY_ADDR_					(0x0000F800UL)	// R/W
	#define PMI_ACCESS_MIIRINDA_					(0x000007C0UL)	// R/W
	#define PMI_ACCESS_MIIWnR_					(0x00000002UL)	// R/W
	#define PMI_ACCESS_MIIBZY_					(0x00000001UL)	// RO/SC

#define MAC_CSR_CMD						(0xA4UL)
	#define MAC_CSR_CMD_CSR_BUSY_					(0x80000000UL)	// Self Clearing
	#define MAC_CSR_CMD_R_NOT_W_					(0x40000000UL)	// R/W
	#define MAC_CSR_CMD_CSR_ADDR_					(0x000000FFUL)	// R/W

#define MAC_CSR_DATA						(0xA8UL)


#define AFC_CFG							(0xACUL)
	#define AFC_CFG_AFC_HI_						(0x00FF0000UL)	// R/W
	#define AFC_CFG_AFC_LO_						(0x0000FF00UL)	// R/W
	#define AFC_CFG_BACK_DUR_					(0x000000F0UL)	// R/W
	#define AFC_CFG_FCMULT_						(0x00000008UL)	// R/W
	#define AFC_CFG_FCBRD_						(0x00000004UL)	// R/W
	#define AFC_CFG_FCADD_						(0x00000002UL)	// R/W
	#define AFC_CFG_FCANY_						(0x00000001UL)	// R/W


#define TEST_REG_A						(0xC0UL)
	#define TEST_REG_A_FIFO_RP_WP_SEL_				(0x00010000UL)	// R/W
	#define TEST_REG_A_FIFO_PNT_SEL_				(0x0000C000UL)	// R/W
	#define TEST_REG_A_LPBK_TX_READ_				(0x00000100UL)	// R/W
	#define TEST_REG_A_LPBK_TX_					(0x00000080UL)	// R/W
	#define TEST_REG_A_LPBK_RX_					(0x00000040UL)	// R/W
	#define TEST_REG_A_LPBK_TXSTAT_					(0x00000020UL)	// R/W
	#define TEST_REG_A_LPBK_RXSTAT_					(0x00000010UL)	// R/W
	#define TEST_REG_A_FR_CNT_BYP_					(0x00000008UL)	// R/W
	#define TEST_REG_A_PME50M_BYP_					(0x00000004UL)	// R/W
	#define TEST_REG_A_PULSE_BYP_					(0x00000002UL)	// R/W
	#define TEST_REG_A_PS_BYP_					(0x00000001UL)	// R/W

#define TEST_REG_B						(0xFCUL)
	#define TEST_REG_B_FIFO_PTR_					(0x00FFF000UL)	// RO
	#define TEST_REG_B_DEBUG_RX_AND_ALIGN IDLE_			(0x00000800UL)	// RO
	#define TEST_REG_B_DBUG_TAG_FIFO_FULL_				(0x00000400UL)	// RO
	#define TEST_REG_B_DBUG_TAG_FIFO_EMPTY_				(0x00000200UL)	// RO
	#define TEST_REG_B_DBUG_GOT_ABORT_				(0x00000100UL)	// RO


#define TX_LPBK_DATA						(0xC4UL)
	#define TX_LPBK_DATA_READ_DATA_					(0xFFFFFFFFUL)	// R/W



/*
 ****************************************************************************
 *	                         1588 Registers
 ****************************************************************************/
#define	_1588_CLK_HI_RX_CAP_1					(0x100UL)
#define _1588_CLK_LO_RX_CAP_1					(0x104UL)
#define _1588_SEQ_ID_SRC_UUID_HI_RX_CAP_1			(0x108UL)
#define _1588_SRC_UUID_LO_RX_CAP_1				(0x10CUL)
#define _1588_CLOCK_HI_TX_CAP_1					(0x110UL)
#define _1588_CLOCK_LO_TX_CAP_1					(0x114UL)
#define _1588_SEQ_ID_SRC_UUID_HI_TX_CAP_1			(0x118UL)
#define _1588_SRC_UUID_LO_TX_CAP_1				(0x11CUL)
#define _1588_CLOCK_HI_RX_CAP_2					(0x120UL)
#define _1588_CLOCK_LO_RX_CAP_2					(0x124UL)
#define _1588_SEQ_ID_SRC_UUID_HI_RX_CAP_2			(0x128UL)
#define _1588_SRC_UUID_LO_RX_CAP_2				(0x12CUL)
#define _1588_CLOCK_HI_TX_CAP_2					(0x130UL)
#define _1588_CLOCK_LO_TX_CAP_2					(0x134UL)
#define _1588_SEQ_ID_SRC_UUID_HI_TX_CAP_2			(0x138UL)
#define _1588_SRC_UUID_LO_TX_CAP_2				(0x13CUL)
#define _1588_CLOCK_HI_RX_CAP_MII				(0x140UL)
#define _1588_CLOCK_LO_RX_CAP_MII				(0x144UL)
#define _1588_SEQ_ID_SRC_UUID_HI_RX_CAP_MII			(0x148UL)
#define _1588_SRC_UUID_LO_RX_CAP_MII				(0x14CUL)
#define _1588_CLOCK_HI_TX_CAP_MII				(0x150UL)
#define _1588_CLOCK_LO_TX_CAP_MII				(0x154UL)
#define _1588_SEQ_ID_SRC_UUID_HI_TX_CAP_MII			(0x158UL)
#define _1588_SRC_UUID_LO_TX_CAP_MII				(0x15CUL)
#define _1588_CLOCK_HI_CAP_GPIO_8				(0x160UL)
#define _1588_CLOCK_LO_CAP_GPIO_8				(0x164UL)
#define _1588_CLOCK_HI_CAP_GPIO_9				(0x168UL)
#define _1588_CLOCK_LO_CAP_GPIO_9				(0x16CUL)
#define _1588_CLK_HI						(0x170UL)
#define _1588_CLK_LO						(0x174UL)
#define _1588_CLK_ADDEND					(0x178UL)
#define _1588_CLK_TAR_HI					(0x17CUL)
#define _1588_CLK_TAR_LO					(0x180UL)
#define _1588_CLK_TAR_REL_HI					(0x184UL)
#define _1588_CLK_TAR_REL_LO					(0x188UL)
#define _1588_AUX_MAC_HI					(0x18CUL)
#define _1588_AUX_MAC_LO					(0x190UL)
#define _1588_CFG						(0x194UL)
	#define _1588_CFG_M_N_S_P2_					(0x80000000UL)	// RW
	#define _1588_CFG_MAC_PRI_EN_P2_				(0x40000000UL)	// RW
	#define _1588_CFG_MAC_ALT1_EN_P2_				(0x20000000UL)	// RW
	#define _1588_CFG_MAC_ALT2_EN_P2_				(0x10000000UL)	// RW
	#define _1588_CFG_MAC_ALT3_EN_P2_				(0x08000000UL)	// RW
	#define _1588_CFG_MAC_USR_EN_P2_				(0x04000000UL)	// RW
	#define _1588_CFG_LCK_RX_P2_					(0x02000000UL)	// RW
	#define _1588_CFG_LCK_TX_P2_					(0x01000000UL)	// RW
	#define _1588_CFG_M_N_S_P1_					(0x00800000UL)	// RW
	#define _1588_CFG_MAC_PRI_EN_P1_				(0x00400000UL)	// RW
	#define _1588_CFG_MAC_ALT1_EN_P1_				(0x00200000UL)	// RW
	#define _1588_CFG_MAC_ALT2_EN_P1_				(0x00100000UL)	// RW
	#define _1588_CFG_MAC_ALT3_EN_P1_				(0x00080000UL)	// RW
	#define _1588_CFG_MAC_USR_EN_P1_				(0x00040000UL)	// RW
	#define _1588_CFG_LCK_RX_1_					(0x00020000UL)	// RW
	#define _1588_CFG_LCK_TX_1_					(0x00010000UL)	// RW
	#define _1588_CFG_M_N_S_MII_					(0x00008000UL)	// RW
	#define _1588_CFG_MAC_PRI_EN_MII_				(0x00004000UL)	// RW
	#define _1588_CFG_MAC_ALT1_EN_MII_				(0x00002000UL)	// RW
	#define _1588_CFG_MAC_ALT2_EN_MII_				(0x00001000UL)	// RW
	#define _1588_CFG_MAC_ALT3_EN_MII_				(0x00000800UL)	// RW
	#define _1588_CFG_MAC_USR_EN_MII_				(0x00000400UL)	// RW
	#define _1588_CFG_LCK_RX_MII_					(0x00000200UL)	// RW
	#define _1588_CFG_LCK_TX_MII_					(0x00000100UL)	// RW
	#define _1588_CFG_LCK_GP_9_					(0x00000040UL)	// RW
	#define _1588_CFG_LCK_GP_8_					(0x00000020UL)	// RW
	#define _1588_CFG_GPIO_EVN_9_					(0x00000018UL)	// RW
	#define _1588_CFG_GPIO_EVN_8_					(0x00000006UL)	// RW
	#define _1588_CFG_RELD_ADD_					(0x00000001UL)	// RW

#define _1588_INT_STS_EN					(0x198UL)
	#define _1588_INT_STS_EN_MP2_RX_EN_				(0x01000000UL)	// RW
	#define _1588_INT_STS_EN_MP2_TX_EN_				(0x00800000UL)	// RW
	#define _1588_INT_STS_EN_MP1_RX_EN_				(0x00400000UL)	// RW
	#define _1588_INT_STS_EN_MP1_TX_EN_				(0x00200000UL)	// RW
	#define _1588_INT_STS_EN_MII_RX_EN_				(0x001000000L)	// RW
	#define _1588_INT_STS_EN_MII_TX_EN_				(0x00080000UL)	// RW
	#define _1588_INT_STS_EN_GP9_EN_				(0x00040000UL)	// RW
	#define _1588_INT_STS_EN_GP8_EN_				(0x00020000UL)	// RW
	#define _1588_INT_STS_EN_TMR_EN_				(0x000100000L)	// RW
	#define _1588_INT_STS_EN_MP2_RX_INT_				(0x00000100UL)	// RWC
	#define _1588_INT_STS_EN_MP2_TX_INT_				(0x00000080UL)	// RWC
	#define _1588_INT_STS_EN_MP1_RX_INT_				(0x00000040UL)	// RWC
	#define _1588_INT_STS_EN_MP1_TX_INT_				(0x00000020UL)	// RWC
	#define _1588_INT_STS_EN_MII_RX_INT_				(0x00000010UL)	// RWC
	#define _1588_INT_STS_EN_MII_TX_INT_				(0x00000008UL)	// RWC
	#define _1588_INT_STS_EN_GP9_INT_				(0x00000004UL)	// RWC
	#define _1588_INT_STS_EN_GP8_INT_				(0x00000002UL)	// RWC
	#define _1588_INT_STS_EN_TMR_INT_				(0x00000001UL)	// RWC
#define _1588_CMD						(0x19CUL)
	#define _1588_CMD_CLK_SNAP_SHOT_				(0x00000001UL)	// RW


#define MANUAL_FC_1						(0x1A0UL)
	#define MANUAL_FC_MP1_CUR_RX_FC_				(0x00000010UL)	// RO
	#define MANUAL_FC_MP1_CUR_TX_FC_				(0x00000008UL)	// RO
	#define MANUAL_FC_MP1_RX_FC_					(0x00000004UL)	// RW
	#define MANUAL_FC_MP1_TX_FC_					(0x00000002UL)	// RW
	#define MANUAL_FC_MP1_MAN_FC_					(0x00000001UL)	// RW
#define MANUAL_FC_2						(0x1A4UL)
	#define MANUAL_FC_MP2_CUR_RX_FC_				(0x00000010UL)	// RO
	#define MANUAL_FC_MP2_CUR_TX_FC_				(0x00000008UL)	// R0
	#define MANUAL_FC_MP2_RX_FC_					(0x00000004UL)	// RW
	#define MANUAL_FC_MP2_TX_FC_					(0x00000002UL)	// RW
	#define MANUAL_FC_MP2_MAN_FC_					(0x00000001UL)	// RW
#define MANUAL_FC_MII						(0x1A8UL)
	#define MANUAL_FC_MII_CUR_RX_FC_				(0x00000010UL)	// RO
	#define MANUAL_FC_MII_CUR_TC_FC_				(0x00000008UL)	// RO
	#define MANUAL_FC_MII_RX_FC_					(0x00000004UL)	// RW
	#define MANUAL_FC_MII_TX_FC_					(0x00000002UL)	// RW
	#define MANUAL_FC_MII_MAN_FC_					(0x00000001UL)	// RW

#define SWITCH_CSR_DATA						(0x1ACUL)
#define SWITCH_CSR_CMD						(0x1B0UL)
	#define SWITCH_CSR_CMD_CSR_BUSY_				(0x80000000UL)	// Self Clearing
	#define SWITCH_CSR_CMD_R_NOT_W_					(0x40000000UL)	// R/W
	#define SWITCH_CSR_CMD_AUTO_INC_				(0x20000000UL)	// R/W
	#define SWITCH_CSR_CMD_AUTO_DEC_				(0x10000000UL)	// R/W
	#define SWITCH_CSR_BYTE_EN_					(0x000F0000UL)	// R/W
	#define SWITCH_CSR_CMD_CSR_ADDR_				(0x0000FFFFUL)	// R/W

#define E2P_CMD							(0x1B4UL)
	#define E2P_CMD_EPC_BUSY_					(0x80000000UL)	// Self Clearing
	#define E2P_CMD_EPC_CMD_					(0x70000000UL)	// R/W
	#define E2P_CMD_EPC_CMD_READ_					(0x00000000UL)	// R/W
	#define E2P_CMD_EPC_CMD_EWDS_					(0x10000000UL)	// R/W
	#define E2P_CMD_EPC_CMD_EWEN_					(0x20000000UL)	// R/W
	#define E2P_CMD_EPC_CMD_WRITE_					(0x30000000UL)	// R/W
	#define E2P_CMD_EPC_CMD_WRAL_					(0x40000000UL)	// R/W
	#define E2P_CMD_EPC_CMD_ERASE_					(0x50000000UL)	// R/W
	#define E2P_CMD_EPC_CMD_ERAL_					(0x60000000UL)	// R/W
	#define E2P_CMD_EPC_CMD_RELOAD_					(0x70000000UL)	// R/W
	#define E2P_CMD_EPC_TIMEOUT_					(0x00000200UL)	// R/WC
	#define E2P_CMD_E2P_PROG_DONE_					(0x00000100UL)	// R/WC
	#define E2P_CMD_EPC_ADDR_					(0x000000FFUL)	// R/W

#define E2P_DATA						(0x1B8UL)
	#define E2P_DATA_EEPROM_DATA_					(0x000000FFUL)	// R/W
#define LED_CFG							(0x1BCUL)
	#define LED_CFG_LED_FUN_1_					(0x00000200UL)	// R/W
	#define LED_CFG_LED_FUN_0_					(0x00000100UL)	// R/W
	#define LED_CFG_LED_EN7_					(0x00000080UL)	// R/W
	#define LED_CFG_LED_EN6_					(0x00000040UL)	// R/W
	#define LED_CFG_LED_EN5_					(0x00000020UL)	// R/W
	#define LED_CFG_LED_EN4_					(0x00000010UL)	// R/W
	#define LED_CFG_LED_EN3_					(0x00000008UL)	// R/W
	#define LED_CFG_LED_EN2_					(0x00000004UL)	// R/W
	#define LED_CFG_LED_EN1_					(0x00000002UL)	// R/W
	#define LED_CFG_LED_EN0_					(0x00000001UL)	// R/W

#define VPHY_BAS_CNTRL						(0x1C0UL)
	#define VPHY_BAS_CNTRL_RST_					(0x00008000UL)	// R/WSC
	#define VPHY_BAS_CNTRL_L00PBACK_				(0x00004000UL)	// R/W
	#define VPHY_BAS_CNTRL_SS_LSB_					(0x00002000UL)	// R/W
	#define VPHY_BAS_CNTRL_AN_					(0x00001000UL)	// R/W
	#define VPHY_BAS_CNTRL_PWR_DWN_					(0x00000800UL)	// R/W
	#define VPHY_BAS_CNTRL_ISO_					(0x00000400UL)	// R/W
	#define VPHY_BAS_CNTRL_RSRT_AN_					(0x00000200UL)	// R/WSC
	#define VPHY_BAS_CNTRL_DUP_MOD_					(0x00000100UL)	// R/W
	#define VPHY_BAS_CNTRL_COL_TST_					(0x00000080UL)	// R/W
	#define VPHY_BAS_CNTRL_SS_MSB_					(0x00000040UL)	// R0
#define VPHY_BAS_STAT						(0x1C4UL)
	#define VPHY_BAS_STAT_100B_T4_					(0x00008000UL)	// RO
	#define VPHY_BAS_STAT_100B_X_FD_				(0x00004000UL)	// RO
	#define VPHY_BAS_STAT_100B_X_HD_				(0x00002000UL)	// RO
	#define VPHY_BAS_STAT_10B_X_FD_					(0x00001000UL)	// RO
	#define VPHY_BAS_STAT_10B_X_HD_					(0x00000800UL)	// RO
	#define VPHY_BAS_STAT_100B_T2_FD_				(0x00000400UL)	// RO
	#define VPHY_BAS_STAT_100B_T2_HD_				(0x00000200UL)	// RO
	#define VPHY_BAS_STAT_EXT_STS_					(0x00000100UL)	// RO
	#define VPHY_BAS_STAT_MF_PRE_SUP_				(0x00000080UL)	// RO
	#define VPHY_BAS_STAT_AN_CMP_					(0x00000040UL)	// RO
	#define VPHY_BAS_STAT_REM_FLT_					(0x00000020UL)	// RO
	#define VPHY_BAS_STAT_AN_ABIL_					(0x00000010UL)	// RO
	#define VPHY_BAS_STAT_LNK_STS_					(0x00000004UL)	// RO
	#define VPHY_BAS_STAT_JAB_DET_					(0x00000002UL)	// RO
	#define VPHY_BAS_STAT_EXT_CAP_					(0x00000001UL)	// RO
#define VPHY_BAS_ID_MSB						(0x1C8UL)
	#define VPHY_BAS_ID_MSB_PHY_ID_					(0x0000FFFFUL)	// R/W
#define VPHY_BAS_ID_LSB						(0x1CCUL)
	#define VPHY_BAS_ID_LSB_PHY_					(0x0000FC00UL)	// R/W
	#define VPHY_BAS_ID_LSB_MOD_					(0x00000030UL)	// R/W
	#define VPHY_BAS_ID_LSB_REV_					(0x0000000FUL)	// R/W
#define VPHY_AN_ADV						(0x1D0UL)
	#define VPHY_AN_ADV_NXT_PGE_					(0x00008000UL)	// RO
	#define VPHY_AN_ADV_REM_FLT_					(0x00002000UL)	// RO
	#define VPHY_AN_ADV_ASM_PAUSE_					(0x00000800UL)	// R/W
	#define VPHY_AN_ADV_PAUSE_					(0x00000400UL)	// R/W
	#define VPHY_AN_ADV_100B_T4_					(0x00000200UL)	// RO
	#define VPHY_AN_ADV_100B_X_FD_					(0x00000100UL)	// R/W
	#define VPHY_AN_ADV_100B_X_HD_					(0x00000080UL)	// R/W
	#define VPHY_AN_ADV_10B_X_FD_					(0x00000040UL)	// R/W
	#define VPHY_AN_ADV_10B_X_HD_					(0x00000020UL)	// R/W
	#define VPHY_AN_ADV_SEL_FLD_					(0x0000001FUL)	// R/W
#define VPHY_AN_LP_BASE_ABIL					(0x1D4UL)
	#define VPHY_AN_LP_BASE_ABIL_NXT_PGE_				(0x00008000UL)	// RO
	#define VPHY_AN_LP_BASE_ABIL_ACK_				(0x00004000UL)	// RO
	#define VPHY_AN_LP_BASE_ABIL_REM_FLT_				(0x00002000UL)	// RO
	#define VPHY_AN_LP_BASE_ABIL_ASM_PAUSE_				(0x00000800UL)	// RO
	#define VPHY_AN_LP_BASE_ABIL_PAUSE_ 				(0x00000400UL)	// RO
	#define VPHY_AN_LP_BASE_ABIL_100B_T4_				(0x00000200UL)	// RO
	#define VPHY_AN_LP_BASE_ABIL_100B_X_FD_				(0x00000100UL)	// RO
	#define VPHY_AN_LP_BASE_ABIL_100B_X_HD_				(0x00000080UL)	// RO
	#define VPHY_AN_LP_BASE_ABIL_10B_X_FD_				(0x00000040UL)	// RO
	#define VPHY_AN_LP_BASE_ABIL_10B_X_HD_				(0x00000020UL)	// RO
	#define VPHY_AN_LP_BASE_ABIL_SEL_FLD_				(0x0000001FUL)	// RO
#define VPHY_AN_EXP						(0x1D8UL)
	#define VPHY_AN_EXP_PAR_DET_FLT					(0x00000010UL)	// RO
	#define VPHY_AN_EXP_LNK_PRT_NXT_PGE_ABL_			(0x00000008UL)	// RO
	#define VPHY_AN_EXP_LOC_DEV_NXT_PGE_ABL_			(0x00000004UL)	// RO
	#define VPHY_AN_EXP_PGE_REC_					(0x00000002UL)	// ROLH
	#define VPHY_AN_EXP_LNK_PRT_AN_ABL_				(0x00000001UL)	// R/W
#define VPHY_SPEC_CNTRL_STAT					(0x1DCUL)
	#define VPHY_TURBO_MII_ENBL								(0x00000400UL)
	#define VPHY_SPEC_CNTRL_STAT_CUR_SPD_				(0x0000001CUL)	// RO
	#define VPHY_SPEC_CNTRL_STAT_SQE_OFF_				(0x00000001UL)	// R/W
#define GPIO_CFG						(0x1E0UL)
	#define GPIO_CFG_GPIO_INT_POL11_				(0x08000000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL10_				(0x04000000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL9_					(0x02000000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL8_					(0x01000000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL7_					(0x00800000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL6_					(0x00400000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL5_					(0x00200000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL4_					(0x00100000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL3_					(0x00080000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL2_					(0x00040000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL1_					(0x00020000UL)	// R/W
	#define GPIO_CFG_GPIO_INT_POL0_					(0x00010000UL)	// R/W
	#define GPIO_CFG_1588_OE_9_					(0x00008000UL)	// R/W
	#define GPIO_CFG_1588_OE_8_					(0x00004000UL)	// R/W
	#define GPIO_CFG_EVN_POL_9_					(0x00002000UL)	// R/W
	#define GPIO_CFG_EVN_POL_8_					(0x00001000UL)	// R/W
	#define GPIO_CFG_GPBUF11_					(0x00000800UL)	// R/W
	#define GPIO_CFG_GPBUF10_					(0x00000400UL)	// R/W
	#define GPIO_CFG_GPBUF9_					(0x00000200UL)	// R/W
	#define GPIO_CFG_GPBUF8_					(0x00000100UL)	// R/W
	#define GPIO_CFG_GPBUF7_					(0x00000080UL)	// R/W
	#define GPIO_CFG_GPBUF6_					(0x00000040UL)	// R/W
	#define GPIO_CFG_GPBUF5_					(0x00000020UL)	// R/W
	#define GPIO_CFG_GPBUF4_					(0x0000001UL)	// R/W
	#define GPIO_CFG_GPBUF3_					(0x00000008UL)	// R/W
	#define GPIO_CFG_GPBUF2_					(0x00000004UL)	// R/W
	#define GPIO_CFG_GPBUF1_					(0x00000002UL)	// R/W
	#define GPIO_CFG_GPBUF0_					(0x00000001UL)	// R/W
#define GPIO_DATA_DIR						(0x1E4UL)
	#define GPIO_DATA_DIR_DIR11_					(0x08000000UL)	// R/W
	#define GPIO_DATA_DIR_DIR10_					(0x04000000UL)	// R/W
	#define GPIO_DATA_DIR_DIR9_					(0x02000000UL)	// R/W
	#define GPIO_DATA_DIR_DIR8_					(0x01000000UL)	// R/W
	#define GPIO_DATA_DIR_DIR7_					(0x00800000UL)	// R/W
	#define GPIO_DATA_DIR_DIR6_					(0x00400000UL)	// R/W
	#define GPIO_DATA_DIR_DIR5_					(0x00200000UL)	// R/W
	#define GPIO_DATA_DIR_DIR4_					(0x00100000UL)	// R/W
	#define GPIO_DATA_DIR_DIR3_					(0x00080000UL)	// R/W
	#define GPIO_DATA_DIR_DIR2_					(0x00040000UL)	// R/W
	#define GPIO_DATA_DIR_DIR1_					(0x00020000UL)	// R/W
	#define GPIO_DATA_DIR_DIR0_					(0x00010000UL)	// R/W
	#define GPIO_DATA_DIR_DAT11_					(0x00000800UL)	// R/W
	#define GPIO_DATA_DIR_DAT10_					(0x00000400UL)	// R/W
	#define GPIO_DATA_DIR_DAT9_					(0x00000200UL)	// R/W
	#define GPIO_DATA_DIR_DAT8_					(0x00000100UL)	// R/W
	#define GPIO_DATA_DIR_DAT7_					(0x00000080UL)	// R/W
	#define GPIO_DATA_DIR_DAT6_					(0x00000040UL)	// R/W
	#define GPIO_DATA_DIR_DAT5_					(0x00000020UL)	// R/W
	#define GPIO_DATA_DIR_DAT4_					(0x00000010UL)	// R/W
	#define GPIO_DATA_DIR_DAT3_					(0x00000008UL)	// R/W
	#define GPIO_DATA_DIR_DAT2_					(0x00000004UL)	// R/W
	#define GPIO_DATA_DIR_DAT1_					(0x00000002UL)	// R/W
	#define GPIO_DATA_DIR_DAT0_					(0x00000001UL)	// R/W
#define GPIO_INT_STS_EN						(0x1E8UL)
	#define GPIO_INT_STS_EN_GPIO_11_EN_				(0x08000000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_10_EN_				(0x04000000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_9_EN_				(0x02000000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_8_EN_				(0x01000000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_7_EN_				(0x00800000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_6_EN_				(0x00400000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_5_EN_				(0x00200000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_4_EN_				(0x00100000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_3_EN_				(0x00080000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_2_EN_				(0x00040000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_1_EN_				(0x00020000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_0_EN_				(0x00010000UL)	// R/W
	#define GPIO_INT_STS_EN_GPIO_11_INT_				(0x00000800UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_10_INT_				(0x00000400UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_9_INT_				(0x00000200UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_8_INT_				(0x00000100UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_7_INT_				(0x00000080UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_6_INT_				(0x00000040UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_5_INT_				(0x00000020UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_4_INT				(0x00000010UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_3_INT_				(0x00000008UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_2_INT_				(0x00000004UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_1_INT_				(0x00000002UL)	// R/WC
	#define GPIO_INT_STS_EN_GPIO_0_INT_				(0x00000001UL)	// R/WC


#ifdef CHIP_IS_LAN9303
#define P1_MII_BASIC_CONTROL                    (0x1ECUL)
	#define P1_MII_SWITCH_LPBK                       (0x40000000UL) //R/W
	#define P1_MII_MANUL_DUPLX                       (0x01000000UL) //R/W
	#define P1_MII_TURBO_MII_ENBL                    (0x04000000UL) //R/W
	#define P1_MII_PORT_MODE                         (0x03000000UL) //R/O
	#define P1_MII_SW_COL_TEST_PORT1                 (0x00800000UL)//R/W
	#define P1_MII_RMII_CLK_DIR                      (0x00400000UL) //R/W
	#define P1_MII_RMII_TRBO_CLK_STR                 (0x00200000UL) //R/W
	#define P1_MII_SQEOFF                            (0x00020000UL)//R/W
	#define P1_MII_LPBK                              (0x00004000UL)//R/W
	#define P1_MII_SPEED_SEL_LSB                     (0x00002000UL)//R/W
	#define P1_MII_ISOLATE                           (0x00000400UL)//R/W
	#define P1_MII_DUPLX_MODE                        (0x00000100UL) //R/W
	#define P1_MII_COL_TEST                          (0x00000080UL) //R/W
#endif

#define SWITCH_MAC_ADDRH			(0x1F0UL)
#define SWITCH_MAC_ADDRL			(0x1F4UL)

#define RESET_CTL					(0x1F8UL)
	#define RESET_CTL_VPHY_RST_				(0x00000008UL)	// R/WSC
	#define RESET_CTL_PHY2_RST_				(0x00000004UL)	// R/WSC
	#define RESET_CTL_PHY1_RST_				(0x00000002UL)	// R/WSC
	#define RESET_CTL_DIGT_RST_				(0x00000001UL)	// R/WSC
#define TEST_REG_C					(0x1FCUL)
	#define TEST_REG_C_EEP_BYP_				(0x00000100UL)	// R/W
	#define TEST_REG_C_PLL_RST_				(0x00000040UL)	// R/W
	#define TEST_REG_C_AGE_EN_				(0x00000020UL)	// R/W
	#define TEST_REG_C_LED_BYP_				(0x00000010UL)	// R/W
	#define TEST_REG_C_I2C_PUL_FIL_				(0x0000000FUL)	// R/W

#define SWITCH_CSR_DIR_DAT				(0x200UL)

/*
 ****************************************************************************
 *	P O S T E D    W R I T E   C O N S I D E R A T I O N S
 ****************************************************************************
 *
 *	Many Hosts have bus interfaces that do posted writes, which is a good
 *	thing in terms of performance.  In normal usage (e.g., a Device Driver),
 *	software written for the 118 doesn't need to do anything special due
 *	to the possibility ofposted writes.  However, certain types of software
 *(e.g., low-level hardware test and diagnostic software) can fail if
 *	posting a write causes it to be delayed such that a subsequent read
 *	occurs before the side effects of the previous write have had time
 *	to complete.  One way to force any posted writes to be flushed is to
 *	perform a dummy read of any register in the 118 subsequent to write
 *	that it is desired to flush.  A side effect of the dummy read is that
 *	a delay will also be introduced, but the value of the delay will vary
 *	substantially between systems and other bus traffic, so the delay time
 *	cannot be relied upon.
 *
 *	Any register read is sufficient to flush the posted writes, but the
 *	following pseudonym is being declared to avoid polluting the source code
 *	with superfluous references to other registers.
 */
#define DUMMY_READ_REG	BYTE_TEST

/*
 ****************************************************************************
 ****************************************************************************
 *	MAC Control and Status Register (Indirect Address)
 *	Offset (through the MAC_CSR CMD and DATA port)
 ****************************************************************************
 ****************************************************************************
 *
 */
#define MAC_CR				(0x01UL)	// R/W

	/* MAC_CR - MAC Control Register */
	#define MAC_CR_RXALL_			(0x80000000UL)
	#define MAC_CR_HBDIS_			(0x10000000UL)
	#define MAC_CR_RCVOWN_			(0x00800000UL)
	#define MAC_CR_LOOPBK_			(0x00200000UL)
	#define MAC_CR_FDPX_			(0x00100000UL)
	#define MAC_CR_MCPAS_			(0x00080000UL)
	#define MAC_CR_PRMS_			(0x00040000UL)
	#define MAC_CR_INVFILT_			(0x00020000UL)
	#define MAC_CR_PASSBAD_			(0x00010000UL)
	#define MAC_CR_HFILT_			(0x00008000UL)
	#define MAC_CR_HPFILT_			(0x00002000UL)
	#define MAC_CR_LCOLL_			(0x00001000UL)
	#define MAC_CR_BCAST_			(0x00000800UL)
	#define MAC_CR_DISRTY_			(0x00000400UL)
	#define MAC_CR_PADSTR_			(0x00000100UL)
	#define MAC_CR_BOLMT_MASK_		(0x000000C0UL)
	#define MAC_CR_DFCHK_			(0x00000020UL)
	#define MAC_CR_TXEN_			(0x00000008UL)
	#define MAC_CR_RXEN_			(0x00000004UL)

#define ADDRH				(0x02UL)	// R/W mask 0x0000FFFFUL
#define ADDRL				(0x03UL)	// R/W mask 0xFFFFFFFFUL
#define HASHH				(0x04UL)	// R/W
#define HASHL				(0x05UL)	// R/W

#define MII_ACC				(0x06UL)	// R/W
	#define MII_ACC_PHY_ADDR_		(0x0000F800UL)
	#define MII_ACC_MIIRINDA_		(0x000007C0UL)
	#define MII_ACC_MII_WRITE_		(0x00000002UL)
	#define MII_ACC_MII_BUSY_		(0x00000001UL)

#define MII_DATA			(0x07UL)	// R/W mask 0x0000FFFFUL

#define FLOW				(0x08UL)	// R/W
	#define FLOW_FCPT_			(0xFFFF0000UL)
	#define FLOW_FCPASS_			(0x00000004UL)
	#define FLOW_FCEN_			(0x00000002UL)
	#define FLOW_FCBSY_			(0x00000001UL)

#define VLAN1				(0x09UL)	// R/W mask 0x0000FFFFUL
#define VLAN2				(0x0AUL)	// R/W mask 0x0000FFFFUL

#define WUFF				(0x0BUL)	// WO

#define WUCSR				(0x0CUL)	// R/W
	#define WUCSR_GUE_			(0x00000200UL)
	#define WUCSR_WUFR_			(0x00000040UL)
	#define WUCSR_MPR_			(0x00000020UL)
	#define WUCSR_WAKE_EN_			(0x00000004UL)
	#define WUCSR_MPEN_			(0x00000002UL)


/*
 ****************************************************************************
 *	Chip Specific MII Defines
 ****************************************************************************
 *
 *	Phy register offsets and bit definitions
 *
 */
#define MODE_CTRL_STS			((DWORD)17)	// Mode Control/Status Register
	#define MODE_CTRL_STS_FASTRIP_		((WORD)0x4000U)
	#define MODE_CTRL_STS_EDPWRDOWN_	((WORD)0x2000U)
	#define MODE_CTRL_STS_LOWSQEN_		((WORD)0x0800U)
	#define MODE_CTRL_STS_MDPREBP_		((WORD)0x0400U)
	#define MODE_CTRL_STS_FARLOOPBACK_	((WORD)0x0200U)
	#define MODE_CTRL_STS_FASTEST_		((WORD)0x0100U)
	#define MODE_CTRL_STS_REFCLKEN_		((WORD)0x0010U)
	#define MODE_CTRL_STS_PHYADBP_		((WORD)0x0008U)
	#define MODE_CTRL_STS_FORCE_G_LINK_	((WORD)0x0004U)
	#define MODE_CTRL_STS_ENERGYON_		((WORD)0x0002U)

#define INT_SOURCE_FLAG			((DWORD)29)

#define INT_SOURCE_MASK			((DWORD)30)
	#define INT_SOURCE_MASK_ENERGYON_	((WORD)0x0080U)
	#define INT_SOURCE_MASK_LINKDOWN_	((WORD)0x0010U)

/*
 *******************************************************************************************************
 *	                         PHY Port1/2 Registers Offset
 *******************************************************************************************************/

#define PHY_CTL					(0x00UL)
#define PHY_STS					(0x01UL)
#define PHY_ID_MSB				(0x02UL)
#define PHY_ID_LSB				(0x03UL)
#define PHY_AN_ADV				(0x04UL)
#define PHY_AN_ABIL				(0x05UL)
#define PHY_AN_EXP				(0x06UL)
#define REG7					(0x07UL)
#define REG8					(0x08UL)
#define REG9					(0x09UL)
#define REG10					(0x0AUL)
#define REG11					(0x0BUL)
#define REG12					(0x0CUL)
#define REG13					(0x0DUL)
#define REG14					(0x0EUL)
#define PHY_EXT_STS				(0x0FUL)
#define PHY_SIL_REV				(0x10UL)
#define PHY_CNTL_STS				(0x11UL)
#define PHY_SPC_MODES				(0x12UL)
#define REG19					(0x13UL)
#define PHY_TST_CNTL				(0x14UL)
#define PHY_TST_READ1				(0x15UL)
#define PHY_TST_READ2				(0x16UL)
#define PHY_TST_WRITE				(0x17UL)
#define REG24					(0x18UL)
#define REG25					(0x19UL)
#define REG26					(0x1AUL)
#define PHY_SPC_CNTL_STS_IND			(0x1BUL)
#define PHY_SPC_TEST_ABIL			(0x1CUL)
#define PHY_INT_SRC				(0x1DUL)
#define PHY_INT_MSK				(0x1EUL)
#define PHY_SPC_CNTL_STS			(0x1FUL)



/*
 ****************************************************************************
*	Chip Specific MII Defines   	** MO *
 ****************************************************************************
 *
 *	Phy register offsets and bit definitions
 *
 */
// #define LAN9118_PHY_ID	(0x00C0001C)

#define PHY_BCR		                ((DWORD)0U)
#define PHY_BCR_RESET_		        ((WORD)0x8000U)
#define PHY_BCR_LOOPBACK_		    ((WORD)0x4000U)
#define PHY_BCR_SPEED_SELECT_	    ((WORD)0x2000U)
#define PHY_BCR_AUTO_NEG_ENABLE_    ((WORD)0x1000U)
#define PHY_BCR_POWER_DOWN          ((WORD)0x0800U) // not applicable to V-PHY
#define PHY_BCR_ISOLATE             ((WORD)0x0400U) // only Leo mode Phy mode
#define PHY_BCR_RESTART_AUTO_NEG_	((WORD)0x0200U)
#define PHY_BCR_DUPLEX_MODE_		((WORD)0x0100U)

#define PHY_BSR		((DWORD)1U)
#define PHY_BSR_LINK_STATUS_	((WORD)0x0004U)
#define PHY_BSR_REMOTE_FAULT_	((WORD)0x0010U)
#define PHY_BSR_AUTO_NEG_COMP_	((WORD)0x0020U)

#define PHY_ID_1	((DWORD)2U)
#define PHY_ID_2	((DWORD)3U)

#define PHY_ANEG_ADV    ((DWORD)4U)
#define PHY_ANEG_ADV_PAUSE_ ((WORD)0x0C00)
#define PHY_ANEG_ADV_ASYMP_	((WORD)0x0800)
#define PHY_ANEG_ADV_SYMP_	((WORD)0x0400)
#define PHY_ANEG_ADV_10H_	((WORD)0x20)
#define PHY_ANEG_ADV_10F_	((WORD)0x40)
#define PHY_ANEG_ADV_100H_	((WORD)0x80)
#define PHY_ANEG_ADV_100F_	((WORD)0x100)
#define PHY_ANEG_ADV_SPEED_	((WORD)0x1E0)

#define PHY_ANEG_LPA	((DWORD)5U)
#define PHY_ANEG_LPA_ASYMP_		((WORD)0x0800)
#define PHY_ANEG_LPA_SYMP_		((WORD)0x0400)
#define PHY_ANEG_LPA_100FDX_	((WORD)0x0100)
#define PHY_ANEG_LPA_100HDX_	((WORD)0x0080)
#define PHY_ANEG_LPA_10FDX_		((WORD)0x0040)
#define PHY_ANEG_LPA_10HDX_		((WORD)0x0020)

#define PHY_MODE_CTRL_STS		((DWORD)17)	// Mode Control/Status Register
#define MODE_CTRL_STS_FASTRIP_		((WORD)0x4000U)
#define MODE_CTRL_STS_EDPWRDOWN_	((WORD)0x2000U)
#define MODE_CTRL_STS_LOWSQEN_		((WORD)0x0800U)
#define MODE_CTRL_STS_MDPREBP_		((WORD)0x0400U)
#define MODE_CTRL_STS_FARLOOPBACK_	((WORD)0x0200U)
#define MODE_CTRL_STS_FASTEST_		((WORD)0x0100U)
#define MODE_CTRL_STS_REFCLKEN_		((WORD)0x0010U)
#define MODE_CTRL_STS_PHYADBP_		((WORD)0x0008U)
#define MODE_CTRL_STS_FORCE_G_LINK_	((WORD)0x0004U)
#define MODE_CTRL_STS_ENERGYON_		((WORD)0x0002U)


#define PHY_INT_SRC_ENERGY_ON_			((WORD)0x0080U)
#define PHY_INT_SRC_ANEG_COMP_			((WORD)0x0040U)
#define PHY_INT_SRC_REMOTE_FAULT_		((WORD)0x0020U)
#define PHY_INT_SRC_LINK_DOWN_			((WORD)0x0010U)

#define PHY_INT_MASK		((DWORD)30)
#define PHY_INT_MASK_ENERGY_ON_		((WORD)0x0080U)
#define PHY_INT_MASK_ANEG_COMP_		((WORD)0x0040U)
#define PHY_INT_MASK_REMOTE_FAULT_	((WORD)0x0020U)
#define PHY_INT_MASK_LINK_DOWN_		((WORD)0x0010U)

#define PHY_SPECIAL			((DWORD)31)
#define PHY_SPECIAL_SPD_	((WORD)0x001CU)
#define PHY_SPECIAL_SPD_10HALF_		((WORD)0x0004U)
#define PHY_SPECIAL_SPD_10FULL_		((WORD)0x0014U)
#define PHY_SPECIAL_SPD_100HALF_	((WORD)0x0008U)
#define PHY_SPECIAL_SPD_100FULL_	((WORD)0x0018U)






#define MAC_REG_MAC_CR          (0)
#define MAC_REG_ADDRH           (1)
#define MAC_REG_ADDRL           (2)
#define MAC_REG_HASHH           (3)
#define MAC_REG_HASHL           (4)
#define MAC_REG_MII_ACC         (5)
#define MAC_REG_MII_DATA        (6)
#define MAC_REG_FLOW            (7)
#define MAC_REG_VLAN1           (8)
#define MAC_REG_VLAN2           (9)
#define MAC_REG_WUFF            (10)
#define MAC_REG_WUCSR           (11)
#endif /* __931REG_H__ */
