/***************************************************************************
*
* Copyright (C) 2004-2005  SMSC
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
***************************************************************************
* File: ioctl_118.h
*/

#ifndef IOCTL_118_H
#define IOCTL_118_H

#define DRIVER_VERSION	(0x00000134UL)

#define SMSC931X_DRIVER_SIGNATURE	(0x82745BACUL+DRIVER_VERSION)
#define SMSC931X_APP_SIGNATURE		(0x987BEF28UL+DRIVER_VERSION)

#define SMSC931X_IOCTL				(SIOCDEVPRIVATE + 0xB)

#define COMMAND_BASE				(0x974FB832UL)

#define COMMAND_GET_SIGNATURE		(COMMAND_BASE+0)

#define COMMAND_LAN_GET_REG			(COMMAND_BASE+1)
#define COMMAND_LAN_SET_REG			(COMMAND_BASE+2)

#define COMMAND_MAC_GET_REG			(COMMAND_BASE+3)
#define COMMAND_MAC_SET_REG			(COMMAND_BASE+4)

#define COMMAND_PHY_GET_REG			(COMMAND_BASE+5)
#define COMMAND_PHY_SET_REG			(COMMAND_BASE+6)

#define COMMAND_DUMP_LAN_REGS		(COMMAND_BASE+7)
#define LAN_REG_ID_REV			(0)
#define LAN_REG_INT_CFG			(1)
#define LAN_REG_INT_STS			(2)
#define LAN_REG_INT_EN			(3)
#define LAN_REG_BYTE_TEST		(4)
#define LAN_REG_FIFO_INT		(5)
#define LAN_REG_RX_CFG			(6)
#define LAN_REG_TX_CFG			(7)
#define LAN_REG_HW_CFG			(8)
#define LAN_REG_RX_DP_CTRL		(9)
#define LAN_REG_RX_FIFO_INF		(10)
#define LAN_REG_TX_FIFO_INF		(11)
#define LAN_REG_PMT_CTRL		(12)
#define LAN_REG_GPIO_CFG		(13)
#define LAN_REG_GPT_CFG			(14)
#define LAN_REG_GPT_CNT			(15)
#define LAN_REG_FPGA_REV		(16)
#define LAN_REG_ENDIAN			(17)
#define LAN_REG_FREE_RUN		(18)
#define LAN_REG_RX_DROP			(19)
#define LAN_REG_MAC_CSR_CMD		(21)
#define LAN_REG_MAC_CSR_DATA	(22)
#define LAN_REG_AFC_CFG			(23)
#define LAN_REG_E2P_CMD			(24)
#define LAN_REG_E2P_DATA		(25)

#define COMMAND_DUMP_MAC_REGS		(COMMAND_BASE+8)
#define MAC_REG_MAC_CR			(0)
#define MAC_REG_ADDRH			(1)
#define MAC_REG_ADDRL			(2)
#define MAC_REG_HASHH			(3)
#define MAC_REG_HASHL			(4)
#define MAC_REG_MII_ACC			(5)
#define MAC_REG_MII_DATA		(6)
#define MAC_REG_FLOW			(7)
#define MAC_REG_VLAN1			(8)
#define MAC_REG_VLAN2			(9)
#define MAC_REG_WUFF			(10)
#define MAC_REG_WUCSR			(11)

#define COMMAND_DUMP_PHY_REGS		(COMMAND_BASE+9)
#define PHY_REG_0				(0)
#define PHY_REG_1				(1)
#define PHY_REG_2				(2)
#define PHY_REG_3				(3)
#define PHY_REG_4				(4)
#define PHY_REG_5				(5)
#define PHY_REG_6				(6)
#define PHY_REG_16				(7)
#define PHY_REG_17				(8)
#define PHY_REG_18				(9)
#define PHY_REG_20				(10)
#define PHY_REG_21				(11)
#define PHY_REG_22				(12)
#define PHY_REG_23				(13)
#define PHY_REG_27				(14)
#define PHY_REG_28				(15)
#define PHY_REG_29				(16)
#define PHY_REG_30				(17)
#define PHY_REG_31				(18)

#define COMMAND_DUMP_EEPROM			(COMMAND_BASE+10)

#define COMMAND_GET_MAC_ADDRESS		(COMMAND_BASE+11)
#define COMMAND_SET_MAC_ADDRESS		(COMMAND_BASE+12)
#define COMMAND_LOAD_MAC_ADDRESS	(COMMAND_BASE+13)
#define COMMAND_SAVE_MAC_ADDRESS	(COMMAND_BASE+14)
#define COMMAND_SET_DEBUG_MODE		(COMMAND_BASE+15)

#define COMMAND_SET_POWER_MODE		(COMMAND_BASE+16)
#define COMMAND_GET_POWER_MODE		(COMMAND_BASE+17)

#define COMMAND_SET_LINK_MODE		(COMMAND_BASE+18)
#define COMMAND_GET_LINK_MODE		(COMMAND_BASE+19)
#define COMMAND_GET_CONFIGURATION	(COMMAND_BASE+20)
#define COMMAND_DUMP_TEMP			(COMMAND_BASE+21)
#define COMMAND_READ_BYTE			(COMMAND_BASE+22)
#define COMMAND_READ_WORD			(COMMAND_BASE+23)
#define COMMAND_READ_DWORD			(COMMAND_BASE+24)
#define COMMAND_WRITE_BYTE			(COMMAND_BASE+25)
#define COMMAND_WRITE_WORD			(COMMAND_BASE+26)
#define COMMAND_WRITE_DWORD			(COMMAND_BASE+27)
#define COMMAND_CHECK_LINK			(COMMAND_BASE+28)

//the following codes are intended for cmd9118 only
//  they are not intended to have any use in the driver
#define COMMAND_RUN_SERVER			(COMMAND_BASE+29)
#define COMMAND_RUN_TUNER			(COMMAND_BASE+30)

#define COMMAND_GET_FLOW_PARAMS		(COMMAND_BASE+31)
#define COMMAND_SET_FLOW_PARAMS		(COMMAND_BASE+32)

#define COMMAND_DUMP_SWITCH_REGS	(COMMAND_BASE+33)
#define COMMAND_SWITCH_GET_REG      (COMMAND_BASE+34)
#define COMMAND_SWITCH_SET_REG      (COMMAND_BASE+35)

#define COMMAND_GET_LEO_REG         (COMMAND_BASE+36)
#define COMMAND_SET_LEO_REG         (COMMAND_BASE+37)
#define COMMAND_GET_LINK_SPEED 	    (COMMAND_BASE+38)
//////////////////////////////////////////////
///     The following are MIB data
//////////////////////////////////////////////////
#define COMMAND_GET_MIB               (COMMAND_BASE+40)

/** COMMANDs TO GET ETHER_LIKE_MIB          */
#define COMMAND_GET_DOT3_STAT_TBL               (COMMAND_BASE+41)
#define COMMAND_GET_DOT3HC_STAT_TBL             (COMMAND_BASE+42)
#define COMMAND_GET_DOT3_CTRL_TBL               (COMMAND_BASE+43)
#define COMMAND_GET_DOT3_PAUSE_TBL              (COMMAND_BASE+44)
/** COMMAND To GET RMON MIB          */
#define COMMAND_GET_RMON_STAT_TBL               (COMMAND_BASE+ 45)

/** IF-MIB comands  **/
#define COMMAND_GET_IF_TBL             (COMMAND_BASE+50)
#define COMMAND_GET_IF_XTBL            (COMMAND_BASE+51)
/*** 802.3 MAC MIB Commands **/
#define COMMAND_GET_IEE8023_STAT_TBL   (COMMAND_BASE+52)
/** BRIDGE MIB (RFC4188) */
#define COMMAND_GET_BRIDGE_STAT_TBL    (COMMAND_BASE+53)
/**RMON MIB   */
#define COMMAND_GET_RMON_TBL           (COMMAND_BASE+60)


/**  Continue from 70**/



#define COMMAND_ENABLE_STP               	(COMMAND_BASE+ 70)
#define COMMAND_DISABLE_STP              	(COMMAND_BASE+ 71)

/**  DON'T CHANGE THE ORDER OF THOSE, MAPPED to RSTP STATE in smsc931x.h**/

#define COMMAND_PORT_STATE_BLOCKING     (COMMAND_BASE+ 72)
#define COMMAND_PORT_STATE_LISTENING    (COMMAND_BASE+ 73)
#define COMMAND_PORT_STATE_LEARNING     (COMMAND_BASE+ 74)
#define COMMAND_PORT_STATE_FORWARDING   (COMMAND_BASE+ 75)
#define COMMAND_PORT_STATE_DISABLE      (COMMAND_BASE+ 76)
#define COMMAND_PORT_STATE_ENABLE       (COMMAND_BASE+ 77)
#define COMMAND_PORT_LINK_ON            (COMMAND_BASE+ 78)
#define COMMAND_PORT_LINK_OFF           (COMMAND_BASE+ 79)

/**  ALR and VLAN**/
#define COMMAND_DUMP_ALR                (COMMAND_BASE+ 80)
#define COMMAND_SET_ALR                 (COMMAND_BASE+ 81)
#define COMMAND_DEL_ALR                 (COMMAND_BASE+ 82)
#define COMMAND_ADD_ENTRY_IN_ALR        (COMMAND_BASE+ 83)
#define COMMAND_ENBL_DISBL_SHRTAGE_TIMR (COMMAND_BASE+ 84)

/**
  ******************************************
  * PTP Support
  ******************************************
 **/

/**      1 -     PTP CLOCK SETUP  **/

#define COMMAND_PTP_ENABLE                  (COMMAND_BASE+ 85)
#define COMMAND_PTP_DISABLE                 (COMMAND_BASE+ 86)
#define COMMAND_PTP_SET_MAC_ADDRESS         (COMMAND_BASE+ 87)
    /**Get RX Time Stamp : Sync Stamp*/
#define COMMAND_PTP_GET_RX_SYNC_STAMP       (COMMAND_BASE+ 89)
    /**Get TX Time Stamp : Sync Stamp*/
#define COMMAND_PTP_GET_TX_DELAY_REQ_STAMP  (COMMAND_BASE+ 90)
    /** Get Rx Sequence Id and UUID**/
#define COMMAND_PTP_GET_RX_SEQID_UUID       (COMMAND_BASE+ 91)

/**  Set clock **/
#define COMMAND_PTP_SET_CLK_PREFERENCE      (COMMAND_BASE+ 92)
/**  Get clock **/
#define COMMAND_PTP_GET_CLK_PREFERENCE      (COMMAND_BASE+ 93)
/**  Clock Adjustment  */
#define COMMAND_PTP_SET_CLK_ADDENDUM        (COMMAND_BASE+ 94)
#define COMMAND_PTP_GET_CLK_ADDENDUM        (COMMAND_BASE+ 95)
 /**  Timer using PTP Clock **/
#define COMMAND_PTP_SET_CLOCK_TARGET        (COMMAND_BASE+ 96)
#define COMMAND_PTP_SET_CLOCK_TARGET_RELOAD (COMMAND_BASE+ 97)
/** Port Setup - master/slave **/
#define COMMAND_PTP_SET_PORT_MODE           (COMMAND_BASE+ 99)
/** PTP MAC used **/
#define COMMAND_PTP_SET_PORT_MAC            (COMMAND_BASE+ 100)
/** **/
#define COMMAND_PTP_RELOAD_TARGET_CLOCK     (COMMAND_BASE+ 101)
/** **/
#define  COMMAND_PTP_SEND_MSG               (COMMAND_BASE+ 102)
/** **/
#define  COMMAND_DUMP_1588_REGS             (COMMAND_BASE+ 103)


/**
  ******************************************
  * IGMP  Support
  ******************************************
 **/

#define COMMAND_IGMP_ENABLE                 (COMMAND_BASE+ 105)
#define COMMAND_IGMP_DISABLE                (COMMAND_BASE+ 106)
#define COMMAND_IGMP_SEND_MSG               (COMMAND_BASE+ 107)

/* EEPROM COMMANDS */
#define COMMAND_WRITE_EEPROM                (COMMAND_BASE+ 108)
#define COMMAND_READ_EEPROM                 (COMMAND_BASE+ 109)

/* VLAN COMMANDS */
#define COMMAND_VLAN_ENABLE                (COMMAND_BASE+ 111)
#define COMMAND_VLAN_DISABLE               (COMMAND_BASE+ 112)
#define COMMAND_VLANONLY_ENABLE	           (COMMAND_BASE+ 113)
#define COMMAND_VLANONLY_DISABLE           (COMMAND_BASE+ 114)
#define COMMAND_VLANMEMBER_ADD             (COMMAND_BASE+ 115)
#define COMMAND_VLANMEMBER_DEL             (COMMAND_BASE+ 116)

/* DA Priority Enable Commands */
#define  COMMAND_DAPRIO_ENABLE			   (COMMAND_BASE + 117)
#define  COMMAND_DAPRIO_DISABLE            (COMMAND_BASE + 118)

#define  COMMAND_TURBOMODE_ENBL				(COMMAND_BASE + 119)
#define  COMMAND_TURBOMODE_DSBL             (COMMAND_BASE + 120)
/**
  ******************************************
  * MLD  Support
  ******************************************
 **/
#define COMMAND_MLD_ENABLE                 (COMMAND_BASE+ 121)
#define COMMAND_MLD_DISABLE                (COMMAND_BASE+ 122)

/** ===========================================================
*     IOCTL and MESSAGE Fromat
*
* ============================================================
*/


#define IOCTL_DATA_SIZE     0x1000
typedef struct _SMSC931X_IOCTL_DATA {
    unsigned long dwSignature;
    unsigned long dwCommand;
    unsigned long Data[IOCTL_DATA_SIZE];
    char Strng1[30];
    char Strng2[10];
} SMSC931X_IOCTL_DATA, *PSMSC931X_IOCTL_DATA;


/////Communication between devices
#define DEV_PROTOCOL_SIZE   200
#define SKB_TYPE_IS_STP     0x8274
typedef struct  {
    unsigned long signature;
    unsigned long command;
    unsigned long Data[DEV_PROTOCOL_SIZE];

} DeviceProtocol;

int getVPhyLinkSpeed(int i);
#endif

