/*
 ****************************************************************************
 *  File:  jmprsetup.cpp
 *
 *	Copyright 2007 Standard Microsystems Corporation.  All rights reserved.
 *
 *
 ****************************************************************************
 *	cgs  6/2/2007
 *		Initial writing by Carl Schooley
 ****************************************************************************
 */
#include <linux/delay.h>
#include "931xTypes.h"	/* Platform dependent headers */
#include "jmprsetup.h"

//#define inp0         (BYTE)0
//#define inp1         (BYTE)1

#define outp0        (BYTE)2
#define outp1        (BYTE)3

//#define polp0        (BYTE)4
//#define polp1        (BYTE)5

#define cfgp0        (BYTE)6
#define cfgp1        (BYTE)7

#ifdef _LAN9303
#define STRPS_I2C_ADDR		(BYTE)0x77
#define STRP_SET1_OFFSET	0x50UL
#define STRP_SET2_OFFSET	0x54UL
extern void I2cHwInit(void);
extern void SpiHwInit(void);

static PIN_STATE_TABLE Strap_set1[] = {
//	Pin Name				BIT							LEO_PIN STATE
// Soft Straps
{ "LED_EN             ",	LED_EN,						HIGH 			},
{ "LED_FUNC0          ",	LED_FUNC0,					LOW 			},
{ "LED_FUNC1          ",	LED_FUNC1,					LOW 			},

{ "AUTO_MDIX1         ",	AUTO_MDIX1,					HIGH 			},
{ "MANUAL_MDIX1       ",	MANUAL_MDIX1,				LOW 			},
{ "AUTO_NEG1          ",	AUTO_NEG1,					HIGH 			},
{ "LINK_SPEED1        ",	LINK_SPEED1,				HIGH 			},
{ "LINK_DPLX1         ",	LINK_DPLX1,				    LOW /*HIGH*/	},
{ "BP_EN1             ",	BP_EN1,					    HIGH 			},
{ "FD_FC1             ",	FD_FC1,					    HIGH 			},
{ "MANUAL_FC1         ",	MANUAL_FC1,				    LOW /*HIGH*/	},

{ "AUTO_MDIX2         ",	AUTO_MDIX2,					HIGH 			},
{ "MANUAL_MDIX2       ",	MANUAL_MDIX2,				LOW 			},
{ "AUTO_NEG2          ",	AUTO_NEG2,					HIGH 			},
{ "LINK_SPEED2        ",	LINK_SPEED2,				HIGH 			},
{ "LINK_DPLX2         ",	LINK_DPLX2,				    HIGH 			},
{ "BP_EN2             ",	BP_EN2,					    HIGH 			},
{ "FD_FC2             ",	FD_FC2,					    HIGH 			},
{ "MANUAL_FC2         ",	MANUAL_FC2,				    LOW /*HIGH*/	},

{ "LINK_SPEED0        ",	LINK_SPEED0,				HIGH 			},
{ "LINK_DPLX_POL0     ",	LINK_DPLX_POL0,			    HIGH 			},
{ "BP_EN0             ",	BP_EN0,					    HIGH 			},
{ "FD_FC0             ",	FD_FC0,					    HIGH 			},
{ "MANUAL_FC0         ",	MANUAL_FC0,				    LOW /*HIGH*/	},

{ "SQE_TEST_DIS       ",	SQE_TEST_DIS,			    LOW /*HIGH*/	},

// Hard Straps
{ "MNG_MODE0          ",	MNG_MODE0,			    	HIGH 			},
{ "MNG_MODE1          ",	MNG_MODE1,			    	LOW 			},
{ "EEPROM_SIZE        ",	EEPROM_SIZE,		    	HIGH 			},
{ "P0_MODE0           ",	P0_MODE0,			    	LOW 			},
{ "P0_MODE1           ",	P0_MODE1,			    	LOW 			},
{ "P0_MODE2           ",	P0_MODE2,	    			LOW 			},
{ "P0_RMII_CLK_DIR    ",	P0_RMII_CLK_DIR,	    	LOW /*HIGH*/	}
};

static PIN_STATE_TABLE Strap_set2[] = {
//	Pin Name				BIT							LEO_PIN STATE
// Hard Straps
{ "P1_MII_DIS         ",	P1_MII_DIS,					LOW 			},
{ "P1_MODE0           ",	P1_MODE0,			    	HIGH 			},
{ "P1_MODE1           ",	P1_MODE1,			    	HIGH 			},
{ "P1_MODE2           ",	P1_MODE2,	    			HIGH 			},
{ "P1_RMII_CLK_DIR    ",	P1_RMII_CLK_DIR,	    	LOW /*HIGH*/	},
{ "PHY_ADDR_SEL       ",	PHY_ADDR_SEL,	    		LOW 			},
{ "LED0_POL           ",	LED0_POL,	    			LOW 			},
{ "LED1_POL           ",	LED1_POL,	    			LOW 			},
{ "LED2_POL           ",	LED2_POL,	    			LOW 			},
{ "LED3_POL           ",	LED3_POL,	    			LOW 			},
{ "LED4_POL           ",	LED4_POL,	    			LOW 			},
{ "LED5_POL           ",	LED5_POL,	    			LOW 			},
{ "P0_ALDEB_MAC_EN    ",	P0_ALDEB_MAC_EN,   			LOW 			},

{ "P0_DPLX_PIN        ",	P0_DPLX_PIN,   				HIGH 			},
{ "P1_DPLX_PIN        ",	P1_DPLX_PIN,   				HIGH 			},
{ "SEL_INT_DPLX_PIN0  ",	SEL_INT_DPLX_PIN0, 			HIGH 			},
{ "SEL_INT_DPLX_PIN1  ",	SEL_INT_DPLX_PIN1, 			HIGH 			},
{ "P0_MII_PORT_SEL    ",	P0_MII_PORT_SEL,			LOW 			}, // PHY = 1, MAC = 0
{ "P1_MII_PORT_SEL    ",	P1_MII_PORT_SEL,			LOW 			}, // PHY = 1, MAC = 0
{ "INT_TMII_EN0       ",	INT_TMII_EN0,   			LOW 			},
{ "INT_TMII_EN1       ",	INT_TMII_EN1,   			LOW 			},

{ "RESV_STRAP_09      ",	RESV_STRAP_09,   			LOW 			},
{ "RESV_STRAP_10      ",	RESV_STRAP_10,   			LOW 			},
{ "RESV_STRAP_11      ",	RESV_STRAP_11,   			LOW 			},
{ "RESV_STRAP_12      ",	RESV_STRAP_12,   			LOW 			},
{ "RESV_STRAP_13      ",	RESV_STRAP_13,   			LOW 			},
{ "RESV_STRAP_14      ",	RESV_STRAP_14,   			LOW 			},
{ "RESV_STRAP_15      ",	RESV_STRAP_15,   			LOW 			},
{ "RESV_STRAP_16      ",	RESV_STRAP_16,   			LOW 			},
{ "RESV_STRAP_17      ",	RESV_STRAP_17,   			LOW 			},
{ "RESV_STRAP_18      ",	RESV_STRAP_18,   			LOW 			},

{ "I2C_SW_RST         ",	I2C_SW_RST,   				LOW 			}
};

static void InitLeoDefaultStraps(void);
#endif



#ifdef _LAN9303
extern BOOLEAN I2cMasterRead(const DWORD dwOffset, const DWORD dwSize, DWORD *pdwBuf);
extern BOOLEAN I2cMasterWrite(const DWORD dwOffset, const DWORD dwSize, const DWORD * const pdwBuf);
#endif

void ResetHydraLeo(void)
{
	#ifdef _LAN9303
	DWORD dwTemp;

	if(!I2cMasterRead( STRP_SET2_OFFSET, 1UL, &dwTemp))
	{
		printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__,__LINE__);
		return;
	}

	// Set I2C_SW_RST bit
	dwTemp |= I2C_SW_RST;
	if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
	{
		printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__,__LINE__);
		return;
	}

	//Delay1mS(2UL);
	 mdelay(2);
	// Reset I2C_SW_RST bit
	dwTemp &= (~I2C_SW_RST);
	if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
	{
		printk("ERROR: I2cMasterWrite failed after setting reset bit in %s %d\n", __FUNCTION__, __LINE__);
		return;
	}

//	Delay1mS(50UL);
	mdelay(50);
	#else
  	#endif
}


#ifdef _LAN9303
/************************************************************************************************/
void InitLeoDefaultStraps(void)
{
	int i;
	DWORD dwTemp1 = 0UL;
	DWORD dwTemp2 = 0UL;

	for (i=0; i<32; i++)
	{
		if (Strap_set1[i].bLeoPinState == HIGH)
		{
			dwTemp1 |= Strap_set1[i].dwBit;
		}

		if (Strap_set2[i].bLeoPinState == HIGH)
		{
			dwTemp2 |= Strap_set2[i].dwBit;
		}
	}

	if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp1))
	{
		printk("ERROR: I2cMasterWrite failed in writing to STRP_SET1_OFFSET in %s %d\n", __FUNCTION__, __LINE__);
		return;
	}

	if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp2))
	{
		printk("ERROR: I2cMasterWrite failed in writing to STRP_SET2_OFFSET in %s %d\n", __FUNCTION__, __LINE__);
		return;
	}
}

/************************************************************************************************/
void SwitchP1MiiMode(const BYTE bMiiMode)
{
	DWORD dwTemp;

	if(!I2cMasterRead( STRP_SET2_OFFSET, 1UL, &dwTemp))
	{
		printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__,__LINE__);
		return;
	}

	// Clear P1 Mode Control bits
	dwTemp &= (~(P1_MODE0 + P1_MODE1 + P1_MODE2 + P1_MII_PORT_SEL));
	switch (bMiiMode)
	{
		case P1_MII_MAC_MODE:
			dwTemp |= P1_MII_PORT_SEL;
			break;

		case P1_MII_PHY_MODE:
			dwTemp |= P1_MODE0;
			break;

		case P1_RMII_PHY_MODE:
			dwTemp |= P1_MODE2;
			break;

		case P1_INTERNAL_PHY_MODE:
			dwTemp |= (P1_MODE0 + P1_MODE1 + P1_MODE2);
			break;
	}

	if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
	{
		printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__,__LINE__);
		return;
	}

	ResetHydraLeo();
}
#endif

/************************************************************************************************/
void InitLeoJmprs(const BYTE bLeoMode)
{
	DWORD dwTemp;
		I2cHwInit();

    switch(bLeoMode)
    {
    	case LEO_MAC_SPI:
    	case LEO_PHY_SPI:
    		   SpiHwInit();
        break;
    	default:
    		break;
    }

	InitLeoDefaultStraps();

	switch (bLeoMode)
	{
		case LEO_MAC_SMI:
			#ifdef _LAN9303

			if(!I2cMasterRead( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Clear MNG_MODE bits
			dwTemp &= (~(MNG_MODE0 + MNG_MODE1));
			dwTemp |= MNG_MODE0; // SMI

			// Clear P0_MODE bits
			dwTemp &= (~(P0_MODE0 + P0_MODE1 + P0_MODE2)); // MAC Mode

			if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			if(!I2cMasterRead( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Clear P0_ALDEB_MAC_EN bit
			dwTemp &= (~P0_ALDEB_MAC_EN);

			// Enable P0 PHY port
			dwTemp |= P0_MII_PORT_SEL;

			if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			printk("\nSetting up jumpers for MAC SMI mode...\n");

			#else
			#endif
			break;

		case LEO_MAC_I2C:
			#ifdef _LAN9303

			if(!I2cMasterRead( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Clear MNG_MODE bits
			dwTemp &= (~(MNG_MODE0 + MNG_MODE1));
			dwTemp |= MNG_MODE1; // I2C

			// Clear P0_MODE bits
			dwTemp &= (~(P0_MODE0 + P0_MODE1 + P0_MODE2)); // MAC Mode

			if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d \n", __FUNCTION__, __LINE__);
				return;
			}

			if(!I2cMasterRead( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Set P0_ALDEB_MAC_EN bit
			dwTemp |= P0_ALDEB_MAC_EN;

			// Enable P0 PHY port
			dwTemp |= P0_MII_PORT_SEL;

			if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			printk("\nSetting up jumpers for MAC I2C mode...\n");

			#else
			#endif
			break;

		case LEO_MAC_SPI:
			#ifdef _LAN9303

			if(!I2cMasterRead( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Set MNG_MODE bits
			dwTemp |= (MNG_MODE0 + MNG_MODE1); // SPI

			// Clear P0_MODE bits
			dwTemp &= (~(P0_MODE0 + P0_MODE1 + P0_MODE2)); // MAC Mode

			if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			if(!I2cMasterRead( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Set P0_ALDEB_MAC_EN bit
			dwTemp |= P0_ALDEB_MAC_EN;

			// Enable P0 PHY port
			dwTemp |= P0_MII_PORT_SEL;

			if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			printk("\nSetting up jumpers for MAC SPI mode...\n");

			#else
			#endif
			break;

		case LEO_PHY_SMI:
			#ifdef _LAN9303

			if(!I2cMasterRead( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Clear MNG_MODE bits
			dwTemp &= (~(MNG_MODE0 + MNG_MODE1));
			dwTemp |= MNG_MODE0; // SMI

			// Clear P0_MODE bits
			dwTemp &= (~(P0_MODE0 + P0_MODE1 + P0_MODE2));
			dwTemp |= P0_MODE0; // PHY Mode

			if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			if(!I2cMasterRead( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Clear P0_ALDEB_MAC_EN bit
			dwTemp &= (~P0_ALDEB_MAC_EN);

			if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			printk("\nSetting up jumpers for PHY SMI mode...\n");

			#else
			#endif
			break;

		case LEO_PHY_I2C:
			#ifdef _LAN9303

			if(!I2cMasterRead( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Clear MNG_MODE bits
			dwTemp &= (~(MNG_MODE0 + MNG_MODE1));
			dwTemp |= MNG_MODE1; // I2C

			// Clear P0_MODE bits
			dwTemp &= (~(P0_MODE0 + P0_MODE1 + P0_MODE2));
			dwTemp |= P0_MODE0; // PHY Mode

			if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			if(!I2cMasterRead( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Clear P0_ALDEB_MAC_EN bit
			dwTemp &= (~P0_ALDEB_MAC_EN);

			if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			printk("\nSetting up jumpers for PHY I2C mode...\n");

			#else
			#endif
			break;

		case LEO_PHY_SPI:
			#ifdef _LAN9303

			if(!I2cMasterRead( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Set MNG_MODE bits
			dwTemp |= (MNG_MODE0 + MNG_MODE1); // SPI

			// Clear P0_MODE bits
			dwTemp &= (~(P0_MODE0 + P0_MODE1 + P0_MODE2));
			dwTemp |= P0_MODE0; // PHY Mode

			if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			if(!I2cMasterRead( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			// Clear P0_ALDEB_MAC_EN bit
			dwTemp &= (~P0_ALDEB_MAC_EN);

			if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
			{
				printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
				return;
			}

			printk("\nSetting up jumpers for PHY SPI mode...\n");

			#else
			#endif
			break;

		default:
			break;
	}

	ResetHydraLeo();

}

/************************************************************************************************/
void ChangeSpeedDuplex(const BOOLEAN fLeoMacSpeed, const BOOLEAN fLeoMacDuplex)
{
	#ifdef _LAN9303
	DWORD dwTemp;

	if (fLeoMacSpeed && fLeoMacDuplex) // 100 FD
	{
		if(!I2cMasterRead( STRP_SET1_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}

		dwTemp |= LINK_DPLX_POL0; // FD
		dwTemp |= LINK_SPEED0; // 100 Mbps

		if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}
	}
	else if (fLeoMacSpeed && !fLeoMacDuplex) // 100 HD
	{
		if(!I2cMasterRead( STRP_SET1_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}

		dwTemp &= (~LINK_DPLX_POL0); // HD
		dwTemp |= LINK_SPEED0; // 100 Mbps

		if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}
	}
	else if (!fLeoMacSpeed && fLeoMacDuplex) // 10 FD
	{
		if(!I2cMasterRead( STRP_SET1_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}

		dwTemp |= LINK_DPLX_POL0; // FD
		dwTemp &= (~LINK_SPEED0); // 10 Mbps

		if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}
	}
	else // 10 HD
	{
		if(!I2cMasterRead( STRP_SET1_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}

		dwTemp &= (~LINK_DPLX_POL0); // HD
		dwTemp &= (~LINK_SPEED0); // 10 Mbps

		if(!I2cMasterWrite( STRP_SET1_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}
	}

	ResetHydraLeo();
	#else
	#endif
}


/************************************************************************************************/
void SwitchPhyAddressMode(const DWORD dwSwitchMode, const DWORD dwVphyAddr)
{
	#ifdef _LAN9303
	DWORD dwTemp;

	if (!dwVphyAddr)
	{
		if(!I2cMasterRead( STRP_SET2_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}

		dwTemp &= (~PHY_ADDR_SEL); // VPHY=0, PHY1=1, PHY2=2

		if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}
	}
	else
	{
		if(!I2cMasterRead( STRP_SET2_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterRead failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}

		dwTemp |= PHY_ADDR_SEL; // VPHY=1, PHY1=2, PHY2=3

		if(!I2cMasterWrite( STRP_SET2_OFFSET, 1UL, &dwTemp))
		{
			printk("ERROR: I2cMasterWrite failed in %s %d\n", __FUNCTION__, __LINE__);
			return;
		}
	}

	ResetHydraLeo();
	#else
	#endif
}
