/*
 ****************************************************************************
 *  File:  jmprsetup.h
 *
 *	Copyright 2007 Standard Microsystems Corporation.  All rights reserved.
 *
 *	Header file for setting pin states.
 *
 ****************************************************************************
 *	cgs  6/2/2007
 *		Initial writing by Carl Schooly
 ****************************************************************************
 */
#define _LAN9303

#ifdef _LAN9303
#define LED_EN				      0x00000001UL
#define LED_FUNC0                 0x00000002UL
#define LED_FUNC1                 0x00000004UL
#define AUTO_MDIX1                0x00000008UL
#define MANUAL_MDIX1              0x00000010UL
#define AUTO_NEG1                 0x00000020UL
#define LINK_SPEED1               0x00000040UL
#define LINK_DPLX1                0x00000080UL
#define BP_EN1                    0x00000100UL
#define FD_FC1                    0x00000200UL
#define MANUAL_FC1                0x00000400UL
#define AUTO_MDIX2                0x00000800UL
#define MANUAL_MDIX2              0x00001000UL
#define AUTO_NEG2                 0x00002000UL
#define LINK_SPEED2               0x00004000UL
#define LINK_DPLX2                0x00008000UL
#define BP_EN2                    0x00010000UL
#define FD_FC2                    0x00020000UL
#define MANUAL_FC2                0x00040000UL
#define LINK_SPEED0               0x00080000UL
#define LINK_DPLX_POL0            0x00100000UL
#define BP_EN0                    0x00200000UL
#define FD_FC0                    0x00400000UL
#define MANUAL_FC0                0x00800000UL
#define SQE_TEST_DIS              0x01000000UL
#define MNG_MODE0                 0x02000000UL
#define MNG_MODE1                 0x04000000UL
#define EEPROM_SIZE               0x08000000UL
#define P0_MODE0                  0x10000000UL
#define P0_MODE1                  0x20000000UL
#define P0_MODE2                  0x40000000UL
#define P0_RMII_CLK_DIR           0x80000000UL

#define P1_MII_DIS                0x00000001UL
#define P1_MODE0                  0x00000002UL
#define P1_MODE1                  0x00000004UL
#define P1_MODE2                  0x00000008UL
#define P1_RMII_CLK_DIR           0x00000010UL
#define PHY_ADDR_SEL              0x00000020UL
#define LED0_POL                  0x00000040UL
#define LED1_POL                  0x00000080UL
#define LED2_POL                  0x00000100UL
#define LED3_POL                  0x00000200UL
#define LED4_POL                  0x00000400UL
#define LED5_POL                  0x00000800UL
#define P0_ALDEB_MAC_EN           0x00001000UL
#define P0_DPLX_PIN               0x00002000UL
#define P1_DPLX_PIN               0x00004000UL
#define SEL_INT_DPLX_PIN0         0x00008000UL
#define SEL_INT_DPLX_PIN1         0x00010000UL
#define P0_MII_PORT_SEL           0x00020000UL
#define P1_MII_PORT_SEL           0x00040000UL
#define INT_TMII_EN0              0x00080000UL
#define INT_TMII_EN1              0x00100000UL
#define RESV_STRAP_09             0x00200000UL
#define RESV_STRAP_10             0x00400000UL
#define RESV_STRAP_11             0x00800000UL
#define RESV_STRAP_12             0x01000000UL
#define RESV_STRAP_13             0x02000000UL
#define RESV_STRAP_14             0x04000000UL
#define RESV_STRAP_15             0x08000000UL
#define RESV_STRAP_16             0x10000000UL
#define RESV_STRAP_17             0x20000000UL
#define RESV_STRAP_18             0x40000000UL
#define I2C_SW_RST                0x80000000UL

#define P1_MII_MAC_MODE			(BYTE)0x00
#define P1_MII_PHY_MODE			(BYTE)0x01
#define P1_RMII_PHY_MODE		(BYTE)0x02
#define P1_INTERNAL_PHY_MODE	(BYTE)0x03

#else
// Port 74 equates
#define MII_MODE	(BYTE)0x01
#define MNG_MODE_1	(BYTE)0x02
#define MNG_MODE_0	(BYTE)0x04
#define MAN_FC_MII	(BYTE)0x08
#define FD_EN_MII	(BYTE)0x10
#define BP_EN_MII	(BYTE)0x20
#define DUP_POL_MII	(BYTE)0x40
#define SPEED_MII	(BYTE)0x80
#define MAN_FC_2	(BYTE)0x01
#define FD_FC_2		(BYTE)0x02
#define BP_EN_2		(BYTE)0x04
#define DUPLEX_2	(BYTE)0x08
#define SPEED_2		(BYTE)0x10
#define AUTO_NEG_2	(BYTE)0x20
#define AUTO_MDIX_2	(BYTE)0x40
#define LED_EN		(BYTE)0x80
// Port 75 equates
#define LED_FUN_1		(BYTE)0x01
#define LED_FUN_0		(BYTE)0x02
#define MAN_FC_1		(BYTE)0x04
#define FD_FC_1			(BYTE)0x08
#define BP_EN_1			(BYTE)0x10
#define DUPLEX_1		(BYTE)0x20
#define SPEED_1			(BYTE)0x40
#define AUTO_NEG_1		(BYTE)0x80
#define AUTO_MDIX_1		(BYTE)0x01
#define nI2C_HYDRA		(BYTE)0x02
#define nI2C_CON_UP_DAT	(BYTE)0x04
#define nI2C_MII_187_EN	(BYTE)0x08
#define nI2C_MII_CON_EN	(BYTE)0x10
#define nI2C_EECS0		(BYTE)0x20
#define nI2C_EECS1		(BYTE)0x40
#define nI2C_EECS2		(BYTE)0x80
// Port 76 equates
#define I2C_GPIO0		(BYTE)0x01
#define I2C_GPIO1		(BYTE)0x02
#define I2C_GPIO2		(BYTE)0x04
#define I2C_GPIO3		(BYTE)0x08
#define I2C_GPIO4		(BYTE)0x10
#define I2C_GPIO5		(BYTE)0x20
#define I2C_GPIO6		(BYTE)0x40
#define I2C_GPIO7		(BYTE)0x80
#define I2C_GPIO8		(BYTE)0x01
#define I2C_GPIO9		(BYTE)0x02
#define I2C_GPIO10		(BYTE)0x04
#define I2C_GPIO11		(BYTE)0x08
#define TESTMODE		(BYTE)0x10
#define PLL_BYPASS_EN	(BYTE)0x20
#define LEO_nHYDRA		(BYTE)0x40
#define LEO_EN_SI_SDA	(BYTE)0x80


// Port 77 equates
#define D32_nd16_PHY_ADR_SEL	(BYTE)0x01
#define PHY_ADR_SEL_S0			(BYTE)0x02
#define AUTO_MDIX_nSCS			(BYTE)0x04
#define AUTO_MDIX_SCK_SCL		(BYTE)0x08
#define FIFO_SEL_MII_DUPLEX		(BYTE)0x10
#define nTHERM					(BYTE)0x20
#define nALERT					(BYTE)0x40
#define nMASTER_I2C_ON			(BYTE)0x80
#define nSLAVE_I2C_ON			(BYTE)0x01
#define E2PROM_TYPE				(BYTE)0x02
#define E2PROM_SIZE0			(BYTE)0x04
#define E2PROM_SIZE1			(BYTE)0x08
#define HB_FSEL_SW				(BYTE)0x10
#define HB_ENDSEL_SW			(BYTE)0x20
#define nMII_MDIP_MDC_TO_HB		(BYTE)0x40
#define RESET_FROM_I2C			(BYTE)0x80
#endif

#define PIN 					1
#define POUT 					0
#define PORT1 					(BYTE)1
#define PORT0 					(BYTE)0
#define HIGH 					(BYTE)1
#define LOW 					(BYTE)0

#define LEO_MAC_SMI				(BYTE)1
#define LEO_MAC_I2C				(BYTE)2
#define LEO_MAC_SPI				(BYTE)3
#define LEO_PHY_SMI				(BYTE)4
#define LEO_PHY_I2C				(BYTE)5
#define LEO_PHY_SPI				(BYTE)6

#ifdef _LAN9303
void SwitchP1MiiMode(const BYTE bMiiMode);
#else
void InitHydraJmprs(void);
void SwitchTo16BitMode(void);
#endif

void ResetHydraLeo(void);
void InitLeoJmprs(const BYTE bLeoMode);
void ChangeSpeedDuplex(const BOOLEAN fLeoMacSpeed, const BOOLEAN fLeoMacDuplex);
void SwitchPhyAddressMode(const DWORD dwSwitchMode, const DWORD dwVphyAddr);

typedef struct _PIN_STATE_TABLE
{
#ifdef _LAN9303
	char	szName[40];
	DWORD	dwBit;
	BYTE	bLeoPinState;
#else
	char	szName[40];
	BYTE	bBit;
	BYTE	bLeoIo;
	BYTE	bLeoPinState;
	BYTE	bHydraIo;
	BYTE	bHydraPinState;
#endif
}PIN_STATE_TABLE;

