/***************************************************************************
 *
 * Copyright (C) 2006-200v  SMSC
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ***************************************************************************
 * File: mibStats.h
 */

#ifndef MIB_STATS_H
#define MIB_STATS_H

#ifdef HYDRA_MODE
    #include  "lan9312Config.h"
#else
    #include "lan9313Config.h"
#endif

typedef unsigned long  U32;

typedef struct counter64 {
    U32          high;
    U32          low;
}U64;

typedef U32  oid;

#define MAX_OID_LEN	    128 /* max subid's in an oid */


// Ether-Like MIB Structures  are below.

typedef struct dot3StatsTable_data_s {
		U32         dot3StatsIndex;

        /*
        * dot3StatsAlignmentErrors(2)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsAlignmentErrors;

            /*
        * dot3StatsFCSErrors(3)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsFCSErrors;

            /*
        * dot3StatsSingleCollisionFrames(4)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsSingleCollisionFrames;

            /*
        * dot3StatsMultipleCollisionFrames(5)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsMultipleCollisionFrames;

            /*
        * dot3StatsSQETestErrors(6)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsSQETestErrors;

            /*
        * dot3StatsDeferredTransmissions(7)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsDeferredTransmissions;

            /*
        * dot3StatsLateCollisions(8)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsLateCollisions;

            /*
        * dot3StatsExcessiveCollisions(9)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsExcessiveCollisions;

            /*
        * dot3StatsInternalMacTransmitErrors(10)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsInternalMacTransmitErrors;

            /*
        * dot3StatsCarrierSenseErrors(11)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsCarrierSenseErrors;

            /*
        * dot3StatsFrameTooLongs(13)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsFrameTooLongs;

            /*
        * dot3StatsInternalMacReceiveErrors(16)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
            */
        U32          dot3StatsInternalMacReceiveErrors;


        /*
         * dot3StatsSymbolErrors(18)/COUNTER/ASN_COUNTER/U32(U32)//l/A/w/e/r/d/h
        */
        U32          dot3StatsSymbolErrors;

        /*
         * dot3StatsDuplexStatus(19)/INTEGER/ASN_INTEGER/long(U32)//l/A/w/E/r/d/h
        */
        U32          dot3StatsDuplexStatus;

        /*
        * dot3StatsRateControlAbility(20)/TruthValue/ASN_INTEGER/long(U32)//l/A/w/E/r/d/h
        */
        U32          dot3StatsRateControlAbility;

        /*
        * dot3StatsRateControlStatus(21)/INTEGER/ASN_INTEGER/long(U32)//l/A/w/E/r/d/h
        */
        U32          dot3StatsRateControlStatus;

 } Dot3StatsTable_data;

 typedef  struct dot3CollTable_data_s {
    /*
     * Index values
    */
     // long            ifIndex;
     long            dot3CollCount;

    /*
     * Column values
    */
     U32          dot3CollFrequencies;

 } Dot3CollTable_data;

 typedef struct dot3ControlTable_data_s {
    /*
     * Index values
    */
    //  long            dot3StatsIndex;

    /*
     * Column values
    */
     unsigned char    dot3ControlFunctionsSupported;   // Read Only
     U32              dot3ControlInUnknownOpcodes;    // Read Only
     U64              dot3HCControlInUnknownOpcodes;   // Read Only

 }Dot3ControlTable_data;

 typedef struct dot3PauseTable_data_s {
    /*
     * Index values
    */
    //  long            dot3StatsIndex;

    /*
     * Column values
    */
     long          dot3PauseAdminMode;  // R/W
     long          dot3PauseOperMode;   // read only
     U32           dot3InPauseFrames;   // read only
     U32           dot3OutPauseFrames;  // Read only
     U64           dot3HCInPauseFrames;
     U64           dot3HCOutPauseFrames;

 } Dot3PauseTable_data;

#define PAUSE_ADMIN_MODE_DSBLD            1
#define PAUSE_ADMIN_MODE_ENBLTX			  2
#define PAUSE_ADMIN_MODE_ENBLRX           3
#define PAUSE_ADMIN_MODE_ENBLTXANDRX      4

#define PAUSE_OPER_MODE_DSBLD             1
#define PAUSE_OPER_MODE_ENBLTX            2
#define PAUSE_OPER_MODE_ENBLRX			  3
#define PAUSE_OPER_MODE_ENBLTXANDRX       4

 typedef struct dot3HCStatsTable_data_s {
    /*
     * Index values
    */
    //  long            dot3StatsIndex;

    /*
     * Column values
    */
     U64             dot3HCStatsAlignmentErrors;
     U64             dot3HCStatsFCSErrors;
     U64             dot3HCStatsInternalMacTransmitErrors;
     U64             dot3HCStatsFrameTooLongs;
     U64             dot3HCStatsInternalMacReceiveErrors;
     U64             dot3HCStatsSymbolErrors;

 } Dot3HCStatsTable_data;
/***
 * IEEE802.3 Clause 30 MIB
 * **/
 typedef struct IEEE802_3StatsTable_data_s {
	 U32 aFramesTransmittedOk;
	 U32 aSingleCollisionFrames;
	 U32 aMultipleCollisionFrames;
	 U32 aFramesReceivedOk;
	 U32 aFramesCheckSequeneErrors;
	 U32 aAlignmnetErrors;
	 U32 aOctetsTransmittedOk;
	 U32 aFrameswithDefferedXmissions;
	 U32 aLateCollisions;
	 U32 aFramesAbortedDueToXSColls;
	 U32 aFramesLostDueToIntMACXmitError;
	 U32 aCarrierSenseErrors;
	 U32 aOctetsRecievedOK;
	 U32 aFramesLostDuetoIntMACRcvError;
	 U32 aMulticastFramesXmittedOK;
	 U32 aBroadcastFramesXmittedOK;
	 U32 aFramesWithExcessiveDefferal;
	 U32 aMulticastFramesReceivedOK;
	 U32 aBroadcastFramesReceivedOK;
	 U32 alnRangeLengthErrors;
	 U32 aOutRofRangeLengthField;
	 U32 aFrameTooLongErrors;
	 U32 aCollisionFrames;
	 U32 aSQETestErrors;
	 U32 aSymbolErrorDuringCarrier;
	 U32 aMACControlFramesTransmitted;
	 U32 aMACControlFramesReceived;
	 U32 aUnsupportedOpcodesReceived;
	 U32 aPAUSEMACCtrlFramesTransmitted;
	 U32 aPAUSEMACCtrlFramesReceived;
 }IEEE802_3StatsTable_data;


 /**    BRIDGE MIB (RFC 4188)
  **/
 typedef struct bridge_MIB_s {
	 U32 dot1dBasePortDelayExceededDiscards;
	 U32 dot1dBasePortMtuExceededDiscards;
	 U32 dot1dTpLearnedEntryDiscards;
	 U32 dot1dTpPortInFrames;
	 U32 dot1dTpPortOutFrames;
	 U32 dot1dTpPortInDiscards;
 }Bridge_Stats_data;

 /**    ERMON Like MIB.
   **/

 typedef struct etherStatsTable_data_s {
    /*
  * Index values
     */
 // long            etherStatsIndex;

    /*
 * Column values
    */

 //  oid             etherStatsDataSource[MAX_OID_LEN];
 //  U32          etherStatsDataSource_len;
 //  oid             old_etherStatsDataSource[MAX_OID_LEN];
 //  U32          old_etherStatsDataSource_len;
    U32          etherStatsDropEvents;
    U32          etherStatsOctets;
    U32          etherStatsPkts;
    U32          etherStatsBroadcastPkts;
    U32          etherStatsMulticastPkts;
    U32          etherStatsCRCAlignErrors;
    U32          etherStatsUndersizePkts;
    U32          etherStatsOversizePkts;
    U32          etherStatsFragments;
    U32          etherStatsJabbers;
    U32          etherStatsCollisions;
    U32          etherStatsPkts64Octets;
    U32          etherStatsPkts65to127Octets;
    U32          etherStatsPkts128to255Octets;
    U32          etherStatsPkts256to511Octets;
    U32          etherStatsPkts512to1023Octets;
    U32          etherStatsPkts1024to1518Octets;
#if 0
 char            etherStatsOwner[MAX_OID_LEN];
 U32          etherStatsOwner_len;
 char            old_etherStatsOwner[MAX_OID_LEN];
 U32          old_etherStatsOwner_len;
 long            etherStatsStatus;
 long            old_etherStatsStatus;
#endif

 } EtherStatsTable_data;

 /** IF-MIB stats**/

 typedef struct ifTable_data_s {
     //long            ifIndex;
     //char         ifDescr[MAX_OID_LEN];
     //U32          ifDescr_len;
     long         ifType;
     long         ifMtu;     // 1500
     U32          ifSpeed;  // Read only
     char         ifPhysAddress[MAX_OID_LEN];
     U32          ifPhysAddress_len;
     long         ifAdminStatus; //1 for up 2 for down
     long         old_ifAdminStatus;
     long         ifOperStatus;
     U32          ifLastChange;          //
     U32          ifInOctets;
     U32          ifInUcastPkts;
     U32          ifInNUcastPkts;       // Braodcast + Mcast
     U32          ifInDiscards;        // discarded but no error
     U32          ifInErrors;
     U32          ifInUnknownProtos;  // Unknow ethertype/VLAN/...etc
     U32          ifOutOctets;
     U32          ifOutUcastPkts;
     U32          ifOutNUcastPkts;    // Broadcast + Mcast
     U32          ifOutDiscards;
     U32          ifOutErrors;
     U32          ifOutQLen;          /**  length of egress queue in packets **/

 }IfTable_data;

typedef struct ifXTable_Data_s {
     U32          ifInMulticastPkts;
     U32          ifInBroadcastPkts;
     U32          ifOutMulticastPkts;
     U32          ifOutBroadcastPkts;
     U64          ifHCInOctets;
     U64          ifHCInUcastPkts;
     U64          ifHCInMulticastPkts;
     U64          ifHCInBroadcastPkts;
     U64          ifHCOutOctets;
     U64          ifHCOutUcastPkts;
     U64          ifHCOutMulticastPkts;
     U64          ifHCOutBroadcastPkts;
     long         ifLinkUpDownTrapEnable;
     long         old_ifLinkUpDownTrapEnable;
     U32          ifHighSpeed;
     long         ifPromiscuousMode;
     long         old_ifPromiscuousMode;
     long         ifConnectorPresent;
     U32          ifCounterDiscontinuityTime;

 } IfXTable_Data;
#endif  //MIB_STATS_H
