/***************************************************************************
*
* Copyright (C) 2004-2005  SMSC
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
***************************************************************************
* File: ptpdrv.c
*   see readme.txt for programmers guide
*
*
* Made a seperate file for all PTP functions. PTP hardware block is not implemented
* in LAN9303, So to reduce the code size and un necessary confusion PTP blocks are
* sepereated out of the smsc931x.c
*/


/** **********************************************
 *
 *   IEEE 1588 or  PTP Block
 *
 ************************************************
 */
#if 0
#include <linux/config.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/slab.h>
#include <linux/ioport.h>
#include <linux/errno.h>
// #include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/delay.h>
#include <linux/mii.h>
//#include <linux/timer.h>
#include <asm/irq.h>
#include <asm/dma.h>
#include <asm/bitops.h>
#include <linux/version.h>


#include <linux/time.h>
#ifdef FULLY_MANAGED
#include <linux/netlink.h>
    #include <linux/if_vlan.h>
#include "snoop_msg.h"
#endif

#ifdef HYDRA_MODE
    #include "lan9312Config.h"
#else
    #include "lan9313Config.h"
#endif
#include "switchReg.h"
#include "mibStats.h"
#include "931xReg.h"
#include "smsc931x.h"
#include "931xControlInterface.h"
#include "ioctl_118.h"
#endif
#include "ptp_msg.h"
const unsigned char PTP_MAC_ADDRESS[4][6] = { {0x01, 0x00, 0x5e, 0x00, 0x01, 0x81},
                                              {0x01, 0x00, 0x5e, 0x00, 0x01, 0x82},
                                              {0x01, 0x00, 0x5e, 0x00, 0x01, 0x83},
                                              {0x01, 0x00, 0x5e, 0x00, 0x01, 0x84} };
BOOLEAN isPTPPacket(PPRIVATE_DATA privateData, const unsigned char *pDest);

void switch_start_ptp(PPRIVATE_DATA privateData);
void sendPtpTestMsg( PPRIVATE_DATA privateData, const char *data, DWORD len);
void switch_stop_ptp(PPRIVATE_DATA privateData);
void ptpAddSkpToRxQueue(PPRIVATE_DATA privateData , struct sk_buff *skb);

    /**   Read Time Stamp on RX on receive of Sync or Delay req  per port**/
int ptpGetRxSyncDelayReqTimeStamp(PPRIVATE_DATA privateData, DWORD port, DWORD *clkHi, DWORD *clkLow);
int ptpGetRxSyncDelayReqSequenceAndUUID(PPRIVATE_DATA privateData, DWORD port, DWORD *SeqIdUUIDH, DWORD *UUIDLow);

    /**   Read Time Stamp on TX of Sync Delay req  per port**/
int ptpGetTxSyncDelayReqTimeStamp(PPRIVATE_DATA privateData, DWORD port, DWORD *clkHi, DWORD *clkLow);

    /**   Read GPIO TIME STAMP **/
typedef enum {
    GPIO_8 = 8,
    GPIO_9
} PTP_GPIO;


   /**   Read 1588 CLOCK **/
int ptpSetPTPClock(PPRIVATE_DATA privateData,  DWORD clkHi, DWORD clkLow);
int ptpGetPTPClock(PPRIVATE_DATA privateData,  DWORD *clkHi, DWORD *clkLow);
 /**   Read/Set  1588 CLOCK Addendum **/
int ptpSetClkAddendum(PPRIVATE_DATA privateData,  DWORD addendum);
int ptpGetClkAddendum(PPRIVATE_DATA privateData,  DWORD *addendum);

int ptpSetPTPtargetClock(PPRIVATE_DATA privateData,  DWORD hi, DWORD low);

int ptpSetPTPtargetReloadClock(PPRIVATE_DATA privateData,  DWORD hi, DWORD low);
   /** Auxiliary MAC  **/
int ptpSetPTPAuxMacAddress(PPRIVATE_DATA privateData,  WORD hi, DWORD low);

  /** PTP Config Register  **/
typedef enum {
    PORT_SALVE= 1,
    PORT_MASTER,
} PTP_PORT_MODE;
 int ptpSetPtpPortMode(PPRIVATE_DATA privateData, DWORD port, PTP_PORT_MODE mode);

typedef enum {
    PORT_MAC_PRIMARY= 14,
    PORT_MAC_ALTERNATE_1 = 13,
    PORT_MAC_ALTERNATE_2 =12,
    PORT_MAC_ALTERNATE_3 = 11,
    PORT_MAC_USER_DEFINED = 10
} PTP_PORT_MAC;

typedef enum {
    PTP_MAC_PRIMARY_ID= 0,
    PTP_MAC_ALTERNATE_1_ID,
    PTP_MAC_ALTERNATE_2_ID,
    PTP_MAC_ALTERNATE_3_ID,
    PTP_MAC_USER_DEFINED_ID
} PTP_MAC_ID;


int ptpSetPtpPortMAC(PPRIVATE_DATA privateData, DWORD port, PTP_PORT_MAC portMac);

typedef enum {
    PTP_PULSE_MODE = 0,
    PTP_TOGGLE_MODE = 1,
    PTP_TIMER_INT_MODE =2,
    PTP_UNDEF_MODE = 3,
} PTP_GPIO_CLOCK_EVENT_MODE;

typedef enum {
    PTP_ADD_MODE = 0,
    PTP_RELOAD_MODE = 1,
} PTP_RELOAD_ADD_CLOCK_MODE;
int ptpReloadAddTargetClock(PPRIVATE_DATA privateData, PTP_RELOAD_ADD_CLOCK_MODE reloadAddMode);
void sendPtpMsgToManager( PPRIVATE_DATA privateData, const char *data, DWORD datalen, int portNumber);

void Rx_ProcessPtpPacket(unsigned long data);
DECLARE_TASKLET(PTP_Tasklet,Rx_ProcessPtpPacket,0);
BOOLEAN execPTPCommand(PPRIVATE_DATA privateData, PSMSC931X_IOCTL_DATA ioctlData);



void ptpAddSkpToRxQueue(PPRIVATE_DATA privateData, struct sk_buff *skb)
{
    // Take lock
    spin_lock_irq(&(privateData->ptpQueueLock));
    WriteQueue(&(privateData->PtpQueue), skb);
    // release lock
    spin_unlock_irq(&(privateData->ptpQueueLock));
}


BOOLEAN execPTPCommand(PPRIVATE_DATA privateData, PSMSC931X_IOCTL_DATA ioctlData)
{
	BOOLEAN success=FALSE;
	switch(ioctlData->dwCommand)
	{
         /** THIS PTP stuff here **/
        case COMMAND_DUMP_1588_REGS:
        if( privateData->LanInitialized ) {
            DWORD dwOffset;
		    DWORD dwIntFlags=0;

            VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
            for (dwOffset = _1588_CLK_HI_RX_CAP_1; dwOffset <= _1588_CMD; dwOffset += 4)
	            ioctlData->Data[(dwOffset - _1588_CLK_HI_RX_CAP_1)/4]=LanGetDirectRegDW(dwOffset);
            Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);
            success=TRUE;
        } else {
            SMSC_WARNING(" LAN Not Initialized");
            SMSC_WARNING("  Use ifconfig to bring interface UP");
        }
        break;

        case COMMAND_PTP_ENABLE:
            switch_start_ptp(privateData);
            success=TRUE;
            break;
        case COMMAND_PTP_DISABLE:
            switch_stop_ptp(privateData);
            success=TRUE;
            break;
        case COMMAND_PTP_SET_MAC_ADDRESS:
            if( privateData->LanInitialized) {
                /** ioctlData->Data[1] contains HI 16 bits of MAC **/
                /** ioctlData->Data[0] 32 bits low MAC address **/
                ptpSetPTPAuxMacAddress(privateData, ioctlData->Data[1], ioctlData->Data[0]);
                success=TRUE;
            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
                 }
            break;

             /**Get RX Time Stamp : Sync Stamp*/
        case COMMAND_PTP_GET_RX_SYNC_STAMP:
            if( privateData->LanInitialized) {
                /** ioctlData->Data[0] = port Number **/
                /**  ioctlData->Data[1] = Clock HI**/
                /**  ioctlData->Data[2] = Clock Low **/
                if (!ptpGetRxSyncDelayReqTimeStamp(privateData, ioctlData->Data[0],
                    &ioctlData->Data[1], &ioctlData->Data[2]) ) {
                    success=TRUE;
                } else {
                    SMSC_WARNING("  Unable to Read Time Stamp for Rx Sync/Delay req");
                }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
        case COMMAND_PTP_GET_TX_DELAY_REQ_STAMP:
            if( privateData->LanInitialized) {
                /** ioctlData->Data[0] = port Number **/
                /**  ioctlData->Data[1] = Clock HI**/
                /**  ioctlData->Data[2] = Clock Low **/
                if (!ptpGetTxSyncDelayReqTimeStamp(privateData, ioctlData->Data[0],
                     &ioctlData->Data[1], &ioctlData->Data[2]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to Read Time Stamp for Rx Sync/Delay req");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
         /** Get Rx Sequence Id and UUID**/
        case COMMAND_PTP_GET_RX_SEQID_UUID:
            if( privateData->LanInitialized) {
                /** ioctlData->Data[0] = port Number **/
                /**  ioctlData->Data[1] = Clock HI**/
                /**  ioctlData->Data[2] = Clock Low **/
                if (!ptpGetRxSyncDelayReqSequenceAndUUID(privateData, ioctlData->Data[0],
                     &ioctlData->Data[1], &ioctlData->Data[2]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to Read Time Stamp for Rx Sync/Delay req");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
                    /**  Set clock **/
        case  COMMAND_PTP_SET_CLK_PREFERENCE:
            if( privateData->LanInitialized) {
                /**  Clock HI = ioctlData->Data[0]**/
                /**  Clock Low = ioctlData->Data[1]**/
                if (!ptpSetPTPClock(privateData, ioctlData->Data[0], ioctlData->Data[1]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to Write 1588 clock");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
                    /**  Get clock **/
        case  COMMAND_PTP_GET_CLK_PREFERENCE:
            if( privateData->LanInitialized) {
                /**  ioctlData->Data[0] = Clock HI**/
                /**  ioctlData->Data[1] = Clock Low **/
                if (!ptpGetPTPClock(privateData, &ioctlData->Data[0], &ioctlData->Data[1]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to Read 1588 clock");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
                    /**  Clock Adjustment  */
        case  COMMAND_PTP_SET_CLK_ADDENDUM:
            if( privateData->LanInitialized) {
                /**  ioctlData->Data[0] = Clock Addendum**/
                if (!ptpSetClkAddendum(privateData, ioctlData->Data[0]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to set clock addendum");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
        case  COMMAND_PTP_GET_CLK_ADDENDUM:
            if( privateData->LanInitialized) {
                /**  ioctlData->Data[0] = Clock Addendum**/
                if (!ptpGetClkAddendum(privateData, &ioctlData->Data[0]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to read clock addendum");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
                    /**  Timer using PTP Clock **/
        case  COMMAND_PTP_SET_CLOCK_TARGET:
            if( privateData->LanInitialized) {
                /**  ioctlData->Data[0] = Clock Hi**/
                /**  ioctlData->Data[1] = Clock Lo**/
                if (!ptpSetPTPtargetClock(privateData, ioctlData->Data[0], ioctlData->Data[1]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to set clock target");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;

        case  COMMAND_PTP_SET_CLOCK_TARGET_RELOAD:
            if( privateData->LanInitialized) {
                /**  ioctlData->Data[0] = Clock Hi**/
                /**  ioctlData->Data[1] = Clock Lo**/
                if (!ptpSetPTPtargetReloadClock(privateData, ioctlData->Data[0], ioctlData->Data[1]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to set clock target reload");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
                    /** Port Setup - master/slave **/
        case  COMMAND_PTP_SET_PORT_MODE:
            if( privateData->LanInitialized) {
                /** ioctlData->Data[0] = port Number **/
                /**  ioctlData->Data[1] = Port Mode (PORT_SALVE, PORT_MASTER)**/
                if (!ptpSetPtpPortMode(privateData, ioctlData->Data[0], ioctlData->Data[1]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to set port mode");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
                    /** PTP MAC used **/
        case  COMMAND_PTP_SET_PORT_MAC:
            if( privateData->LanInitialized) {
                /** ioctlData->Data[0] = port Number **/
                /**  ioctlData->Data[1] = Port MAC address type (PTP_PORT_MAC) **/

		//printk("going to call ptpSEtPtpPortMAC \n");
                if (!ptpSetPtpPortMAC(privateData, ioctlData->Data[0], ioctlData->Data[1]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to set port MAC");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
                    /** **/
        case  COMMAND_PTP_RELOAD_TARGET_CLOCK:
            if( privateData->LanInitialized) {
                /** ioctlData->Data[0] = Reload/Add Mode **/
                if (!ptpReloadAddTargetClock(privateData, ioctlData->Data[0]) ) {
                         success=TRUE;
                     } else {
                         SMSC_WARNING("  Unable to set Reload/Add target clock");
                     }

            } else {
                SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;

        case COMMAND_PTP_SEND_MSG:
            if(privateData->LanInitialized) {
                sendPtpTestMsg( privateData, (const char *) (&ioctlData->Data[1]),ioctlData->Data[0]);
                success=TRUE;
                } else {
                    SMSC_WARNING( "MAC Not Initialized or Invalid port index (%lu)",ioctlData->Data[0]);
                    SMSC_WARNING("  Use ifconfig to bring interface UP");
            }
            break;
        default:
        {
        	SMSC_WARNING("UNKOWN PTP COMMAND\n");
        	break;
        }
    }
	return success;
}



void Rx_ProcessPtpPacket (unsigned long data)
{
// Process PTP packet
    struct sk_buff *skb = NULL;
    int portNumber = 0;
    SMSC_ASSERT(thisModulePrivate != NULL);

    // Dequeue all packets from STP queue and send them to
    // PTP
    do {
        spin_lock_irq(&(thisModulePrivate->ptpQueueLock));
        skb=  skb_dequeue(&thisModulePrivate->PtpQueue);
        spin_unlock_irq(&(thisModulePrivate->ptpQueueLock));
        if ( skb)
        {
            portNumber =  atomic_read(&(skb->users));
            //SMSC_TRACE("DRV: sending PTP Packet to PTP manager");
            sendPtpMsgToManager( thisModulePrivate, skb->data,skb->len,portNumber);

            dev_kfree_skb(skb);
        }

        else
        {
            break;
        }
    } while (skb != NULL);

}



BOOLEAN isPTPPacket(PPRIVATE_DATA privateData, const unsigned char *pDest)
{
    PTAG_FORMAT    pFormat;
    int i;
    DWORD regValue, regValue1;


    pFormat = (PTAG_FORMAT) (pDest);

    // Check default MAC addresses for PTP frame
    for ( i = 0; i < 4; i ++) {

        if ( memcmp(pFormat->dstMac,PTP_MAC_ADDRESS[i],6) == 0)  {
            //SMSC_TRACE("!!!!!!!!!! PTP Packet !!!!!!!!!!!!!!\n");
            return TRUE;
        }
    }

	// Check User defined PTP Mac Address if it is enabled
	{
    DWORD dwIntFlags=0;

    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    regValue = LanGetRegDW(_1588_CFG);
    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);
    if ( regValue == 0xFFFFFFFF)
        regValue = 0;

    if ( (regValue & _1588_CFG_MAC_USR_EN_P1_) || (regValue & _1588_CFG_MAC_USR_EN_P2_) ) {
        unsigned char tmpMacBuf[6];

        VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
        regValue = LanGetRegDW(_1588_AUX_MAC_LO);
        regValue1 = LanGetRegDW(_1588_AUX_MAC_HI);
        Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);

        memcpy(tmpMacBuf, &regValue, 4);
        memcpy(&tmpMacBuf[4], &regValue1, 2);
        if ( memcmp(pFormat->dstMac,tmpMacBuf,6) == 0)  {
            //SMSC_TRACE("!!!!!!!!!! USER Defined PTP Packet !!!!!!!!!!!!!!\n");
            return TRUE;
        } else {
            return FALSE;
        }

    } else {
        return FALSE;
    }
    }
}


int ptpMgrTransmitData(PPRIVATE_DATA privateData, PTP_GENERAL_MSG_T *ptpMsg)
{

    struct nlmsghdr *nlh = NULL;
    int ret = 0;
    int dataSize = 0;
    void	*data;
    struct sk_buff	*skb;
    int len = 0;

    SMSC_ASSERT(privateData);
    dataSize = sizeof(PTP_GENERAL_MSG_T);  /* payload*/
    len = NLMSG_SPACE(dataSize);     /* Msg Hdr plud payload */
    skb = alloc_skb(len, GFP_KERNEL);

    if (skb) {

        nlh = NLMSG_PUT(skb, 0, 0, ptpMsg->header.cmd_type, len - sizeof(*nlh));

        data = NLMSG_DATA(nlh);
        NETLINK_CB(skb).dst_group = 0;  /* unicast */

        memcpy(data, ptpMsg, dataSize );
        ret = netlink_unicast(privateData->nls, skb, privateData->ptp_deamon_pid,MSG_DONTWAIT);
        if (ret <= 0 ) {
	 kfree_skb(skb);
        SMSC_ERROR ("Error Sending Net Link Message");
	goto nlmsg_failure;
        }
        SMSC_TRACE("DRV to PID %d dataSize=%d, MSG Size=%d, size Tx = %d",
                   privateData->ptp_deamon_pid, dataSize, len, ret);

    }
nlmsg_failure:
        kfree(ptpMsg);
        return ret;

}

void sendPtpMsgToManager( PPRIVATE_DATA privateData, const char *data, DWORD datalen, int portNumber)
{
    PTP_GENERAL_MSG_T *ptpMsg;
    DWORD len;

    if (!privateData->ptpStarted) {
        SMSC_ERROR(" PTP is not Initialized");
        return;
    }

    if (privateData->ptp_deamon_pid == 0) {
        SMSC_WARNING(" No PID to send PTP MSG to");
        return;
    }

    ptpMsg =  kmalloc(sizeof(PTP_GENERAL_MSG_T),GFP_KERNEL);
    if ( ptpMsg) {
        len =  (datalen > MAX_PROTO_LEN) ? MAX_PROTO_LEN : datalen;

        memset (ptpMsg, 0, sizeof (PTP_GENERAL_MSG_T) ) ;

        ptpMsg->header.cmd_type = PTP_MSG;
        ptpMsg->header.sender_pid = privateData->ptp_deamon_pid ;
        ptpMsg->header.port = portNumber;


        memcpy (ptpMsg->body.protoMsg, data, len);
        ptpMsg->header.msg_len = len;   // we are sending only 4 bytes of data
        ptpMgrTransmitData( privateData, ptpMsg);
    }
}

void sendPtpTestMsg( PPRIVATE_DATA privateData, const char *data, DWORD datalen)
{
    PTP_GENERAL_MSG_T *ptpMsg;
    DWORD len;

    if (!privateData->ptpStarted) {
        SMSC_ERROR(" PTP is not Initialized");
        return;
    }
    ptpMsg =  kmalloc(sizeof(PTP_GENERAL_MSG_T),GFP_KERNEL);
    if ( ptpMsg) {
        len =  (datalen > MAX_PROTO_LEN) ? MAX_PROTO_LEN : datalen;

        memset (ptpMsg, 0, sizeof (PTP_GENERAL_MSG_T) ) ;

        ptpMsg->header.cmd_type = PTP_MSG;
        ptpMsg->header.sender_pid = privateData->ptp_deamon_pid ;
        ptpMsg->header.port = 0;


        memcpy (ptpMsg->body.protoMsg, data, len);
        ptpMsg->header.msg_len = len;   // we are sending only 4 bytes of data
        ptpMgrTransmitData( privateData, ptpMsg);
    }

}



void ptp_rx_msg_ready (struct sock *sk, int len)
{
    if (thisModulePrivate != NULL) {
        if (thisModulePrivate->ptp_thread ) {
	        //SMSC_TRACE("NetLink MSG Ready");
            complete(&(thisModulePrivate->ptp_ready));
        }
    }
}
int  ptp_process_msg(void *data)
{
    struct sk_buff *skb = NULL;
    struct nlmsghdr *nlh = NULL;
    PTP_GENERAL_MSG_T  *ptpMsg;

    int err = 0;

    PPRIVATE_DATA  privateData = (PPRIVATE_DATA) (data);

    if ( privateData != NULL) {
        privateData->ptp_thread = current;

        privateData->nls= netlink_kernel_create(NETLINK_PTP_MSG,1,
                ptp_rx_msg_ready, THIS_MODULE);

        if ( privateData->nls == NULL) {
            SMSC_ERROR("Unable to create netlink socket ");
            goto ERROR;
        }

        SMSC_TRACE("NetLink Socket Created in ptp_process_msg() ");

        while  (1) {

            wait_for_completion(&(privateData->ptp_ready));

            if (!privateData->ptpStarted) {
                SMSC_WARNING("PTP is disabled..");
                //break;
                goto PTP_EXIT;
            }
            SMSC_TRACE("NetLink Socket Activity.... ");
            skb = skb_recv_datagram( privateData->nls, 0, 0, &err);
            if (!err)  {

                nlh = (struct nlmsghdr *)skb->data;
                ptpMsg =  (PTP_GENERAL_MSG_T  *) NLMSG_DATA(nlh);
                /*pid of sending process */
                privateData->ptp_deamon_pid = nlh->nlmsg_pid;


                if (ptpMsg->header.msg_len) {
                    SMSC_TRACE(" received netlink message payload:%s == from PID =%d\n",
                           ptpMsg->body.protoMsg,nlh->nlmsg_pid);
                    SMSC_TRACE(" Msg Length:%d, Dest. Port:%d\n",
                           ptpMsg->header.msg_len,ptpMsg->header.port);
                }


			    if(ptpMsg->header.cmd_type==PTP_MSG)
			    {
			        int xmitResult;
			        //skb->mac.raw=skb->data;
			        skb->len = ptpMsg->header.msg_len;
			        skb->dev=privateData->switchDev[ptpMsg->header.port];
			        skb->data += NLMSG_LENGTH(0)+ sizeof(PTP_MSG_HEADER_T);
			        skb->priority=0;
		            /*	skb->protocol=eth_type_trans(skb,skb->dev);
			        skb->dev->name
			        SMSC_TRACE("skb->len %d,skb->protocol %x",skb->len, skb->protocol);*/
                	//dumpSkb(skb);
                	xmitResult = dev_queue_xmit(skb);
			        SMSC_TRACE("dev_queue_xmit(skb)= %x,skb->dev->name %s\n"
					   ,xmitResult,skb->dev->name);
			    }
			    else
			    {
			        dev_kfree_skb(skb);
             		/**  Free  SKB**/
			    }
            }
        }
    }

ERROR:
    SMSC_ERROR("ERROR in NetLink Thread  EXIT");
PTP_EXIT:
    kill_proc(privateData->ptp_thread_pid, SIGTERM, 1);
    privateData->ptp_thread_pid  = 0;
    privateData->ptp_thread = NULL;
    if ( privateData->nls) {
        sock_release(privateData->nls->sk_socket);
        privateData->nls = NULL;
    }

    return 0;

}
void switch_start_ptp (PPRIVATE_DATA privateData)
{
    if (!privateData->ptpStarted) {
        DWORD dwRegVal;

        init_completion(&(  privateData->ptp_ready));
        privateData->ptp_thread_pid = kernel_thread(ptp_process_msg, (void *)(privateData), 0);
        privateData->ptpStarted = TRUE;

        // PPS Signal
        dwRegVal = LanGetRegDW(GPIO_CFG);
        dwRegVal |= GPIO_CFG_1588_OE_9_;
        LanSetRegDW(GPIO_CFG, dwRegVal);
        dwRegVal = LanGetRegDW(_1588_CFG);
        dwRegVal &= (~_1588_CFG_GPIO_EVN_9_);
        dwRegVal |= 8; // bits[4:3]: 01 causes the GPIO9 to toggle
        LanSetRegDW(_1588_CFG, dwRegVal);
        SMSC_TRACE("GPIO_CFG=0x%08lX, 1588_CFG=0x%08lX",LanGetRegDW(GPIO_CFG), LanGetRegDW(_1588_CFG));

        SMSC_TRACE("Starting PTP Thread: pid =%d ",(int) (privateData->ptp_thread_pid) );
    }
}

void switch_stop_ptp (PPRIVATE_DATA privateData)
{
    privateData->ptpStarted = FALSE;
    if (thisModulePrivate->ptp_thread )
        complete(&(thisModulePrivate->ptp_ready));
    SMSC_TRACE("Stoping PTP Thread: pid =%d ",(int) (privateData->ptp_thread_pid) );

}
    /**   Read Time Stamp on RX on receive of Sync or Delay req  per port**/
int ptpGetRxSyncDelayReqTimeStamp(PPRIVATE_DATA privateData, DWORD port, DWORD *hi, DWORD *low)
{
    if ( port < 3 ) {
        DWORD regOffsetH =  _1588_CLK_HI_RX_CAP_1 + port*0x20;
        DWORD regOffsetL =  _1588_CLK_LO_RX_CAP_1 + port*0x20;

        *low = LanGetRegDW(regOffsetL);
        *hi  = LanGetRegDW(regOffsetH);

        // clear interrupt status
        if (port == 2) {// MII port
            LanSetRegDW(_1588_INT_STS_EN, _1588_INT_STS_EN_MII_RX_INT_);
        } else {
            LanSetRegDW(_1588_INT_STS_EN, (_1588_INT_STS_EN_MP1_RX_INT_ << (2*port)));
        }
    }
    else {
        SMSC_WARNING("Invalid Port Number (%lu)", port);
    }
    return 0;
}
int ptpGetRxSyncDelayReqSequenceAndUUID(PPRIVATE_DATA privateData, DWORD port, DWORD *SeqIdUUIDH, DWORD *UUIDLow)
{
    if ( port < 3 ) {
        DWORD seqIdUUIDHigh =  _1588_SEQ_ID_SRC_UUID_HI_RX_CAP_1 + port*0x20;
        DWORD uuidLow       =  _1588_SRC_UUID_LO_RX_CAP_1 + port*0x20;

        *UUIDLow            =  LanGetRegDW(uuidLow);
        *SeqIdUUIDH         =  LanGetRegDW(seqIdUUIDHigh);

    }
    else {
        SMSC_WARNING("Invalid Port Number (%lu)", port);
    }
    return 0;
}

    /**   Read Time Stamp on TX of Sync Delay req  per port**/
int ptpGetTxSyncDelayReqTimeStamp(PPRIVATE_DATA privateData, DWORD port, DWORD *clkHi, DWORD *clkLow)
{
    if ( port < 3 ) {
        DWORD txClkHi =  _1588_CLOCK_HI_TX_CAP_1 + port*0x20;
        DWORD txClkLi =  _1588_CLOCK_LO_TX_CAP_1 + port*0x20;

        *clkLow       =  LanGetRegDW(txClkLi);
        *clkHi        =  LanGetRegDW(txClkHi);

        // clear interrupt status
        if (port == 2) {// MII port
            LanSetRegDW(_1588_INT_STS_EN, _1588_INT_STS_EN_MII_TX_INT_);
        } else {
            LanSetRegDW(_1588_INT_STS_EN, (_1588_INT_STS_EN_MP1_TX_INT_ << (2*port)));
        }
    }
    else {
        SMSC_WARNING("Invalid Port Number (%lu)", port);
    }
    return 0;
}


   /**   Read 1588 CLOCK **/
int ptpGetPTPClock(PPRIVATE_DATA privateData,  DWORD *clkHi, DWORD *clkLow)
{
    DWORD dwIntFlags=0;
    int i;

    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    // Take a snapshot of 1588 clock
    LanSetRegDW(_1588_CMD, _1588_CMD_CLK_SNAP_SHOT_);
    for (i = 0; i < 40; i++ )
        if (!( LanGetRegDW(_1588_CMD) & _1588_CMD_CLK_SNAP_SHOT_ ))
            goto _READ_1588_CLOCK;

    SMSC_WARNING("timeout waiting for snapshot bit to clear. 1588_CMD = 0x%08lX",
            LanGetRegDW(_1588_CMD) );
    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);
    return -1;

_READ_1588_CLOCK:
    *clkLow =  LanGetRegDW(_1588_CLK_LO);
    *clkHi =   LanGetRegDW(_1588_CLK_HI);
    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);

    return 0;
}

   /**   Read 1588 CLOCK **/
int ptpSetPTPClock(PPRIVATE_DATA privateData,  DWORD clkHi, DWORD clkLow)
{
    DWORD dwIntFlags=0;

    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    LanSetRegDW(_1588_CLK_LO, clkLow);
    LanSetRegDW(_1588_CLK_HI, clkHi);
    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);

    return 0;
}

  /**   Set 1588 CLOCK  Addendum**/
int ptpSetClkAddendum(PPRIVATE_DATA privateData,  DWORD addendum)
{
    DWORD dwIntFlags=0;

    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    LanSetRegDW(_1588_CLK_ADDEND, addendum);
    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);

    return 0;
}
int ptpGetClkAddendum(PPRIVATE_DATA privateData,  DWORD *addendum)
{
    DWORD dwIntFlags=0;

    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    *addendum = LanGetRegDW(_1588_CLK_ADDEND);
    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);

    return 0;

}



int ptpSetPTPtargetClock(PPRIVATE_DATA privateData,  DWORD clkHi, DWORD clkLow)
{
    DWORD dwIntFlags=0;

    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    LanSetRegDW(_1588_CLK_TAR_LO, clkLow);
    LanSetRegDW(_1588_CLK_TAR_HI, clkHi);
    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);

    return 0;
}


int ptpSetPTPtargetReloadClock(PPRIVATE_DATA privateData,  DWORD clkHi, DWORD clkLow)
{
    DWORD dwIntFlags=0;

    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    LanSetRegDW(_1588_CLK_TAR_REL_LO , clkLow);
    LanSetRegDW(_1588_CLK_TAR_REL_HI, clkHi);
    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);

    return 0;
}
   /** Auxiliary MAC  **/
int ptpSetPTPAuxMacAddress(PPRIVATE_DATA privateData,  WORD macHi, DWORD macLow)
{
    DWORD dwIntFlags=0;
    DWORD MacHi, MacLo;

    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    if (macLow==0xffffffff && macHi==0xffff)
    {
      SMSC_ERROR ("PTP user defined address is broadcast!!!");
      Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);
      return 0;
    }

    MacLo = ntohl(LanGetRegDW(_1588_AUX_MAC_LO));
    MacHi = (DWORD)ntohs((WORD)(LanGetRegDW(_1588_AUX_MAC_HI) & 0xFFFF));
    if (MacLo || MacHi) { // Initialized
      Switch_remove_Static_ALR(privateData, MacLo, MacHi, 0); // Remove ALR entry
    }
    LanSetRegDW(_1588_AUX_MAC_LO , macLow );
    LanSetRegDW(_1588_AUX_MAC_HI, macHi & 0xFFFF);
    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);

    return 0;
}



int ptpSetPtpPortMode(PPRIVATE_DATA privateData, DWORD  port, PTP_PORT_MODE mode)
{
    DWORD  ptpConfigReg = _1588_CFG;
    DWORD  dwIntFlags=0;

    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    /** Read Config reg**/
    unsigned ptpConfigValue = LanGetRegDW(ptpConfigReg);

    if ( port < 3) {
    	DWORD portMasterMap;

	    /** Remapping the port number **/
	    port = (port + 1) % 3;
        portMasterMap =  1 <<  ( port*8 + 15);
        switch (mode) {
            case  PORT_SALVE:
                /** Clear Master bit for the port **/
                ptpConfigValue &= ~ portMasterMap;
                break;
            case PORT_MASTER:
                /** Set Master bit for the port **/
                ptpConfigValue |= portMasterMap;
                default :
                break;
        }
        LanSetRegDW(ptpConfigReg , ptpConfigValue );
    }

    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);

    return 0;
}

int ptpSetPtpPortMAC(PPRIVATE_DATA privateData, DWORD  port, PTP_PORT_MAC portMac)
{
    unsigned ptpConfigReg = _1588_CFG;
    DWORD  dwIntFlags=0;
    ALREntryProp entryProp={0};
    unsigned int enbl_ptp_macAddr;
    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    /** Read Config reg**/
    unsigned ptpConfigValue = LanGetRegDW(ptpConfigReg );
    DWORD portMacMap;
    DWORD MacHi=0xFFFFFFFF, MacLo=0xFFFFFFFF;
    int i;

    if ( port < 3) {
	    /** Remapping the port number **/
	    port = (port + 1) % 3;
/*#ifdef ENABLE_ALL_PTP_DOMAINS*/
        // Assign all PTP addresses to port1 & port2
        for (i=0; i<4; i++) {
          MacLo = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[i][3],PTP_MAC_ADDRESS[i][2]), (DWORD)MAKEWORD(PTP_MAC_ADDRESS[i][1], PTP_MAC_ADDRESS[i][0]));
          MacHi = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[i][5],PTP_MAC_ADDRESS[i][4]), 0);
          entryProp.port = 6;
          Switch_Add_Static_ALR(privateData, MacLo, MacHi, &entryProp); // forward to Port1 & Port2
        }
        MacLo = ntohl(LanGetRegDW(_1588_AUX_MAC_LO));
        MacHi = (DWORD)ntohs((WORD)(LanGetRegDW(_1588_AUX_MAC_HI) & 0xFFFF));
        if (!((!MacLo && !MacHi) || // initialized
             (MacLo==0xffffffff && MacHi==0xffff))) { // Initialized w/ Non-Broadcast Address
          entryProp.port = 6;
          Switch_Add_Static_ALR(privateData, MacLo, MacHi, &entryProp); // forward to Port1 & Port2
        }
/*#endif*/

        switch (portMac) {
            case PORT_MAC_PRIMARY:
		 //printk("Setting the PORT_MAC_PRIMARY \n");
                // _DFLT Mac Address
                MacLo = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[0][3],PTP_MAC_ADDRESS[0][2]), (DWORD)MAKEWORD(PTP_MAC_ADDRESS[0][1], PTP_MAC_ADDRESS[0][0]));
                MacHi = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[0][5],PTP_MAC_ADDRESS[0][4]), 0);
                entryProp.port = 0;
                Switch_Add_Static_ALR(privateData, MacLo, MacHi,&entryProp); // forward to CPU port (MII)
                enbl_ptp_macAddr = PTP_MAC_PRIMARY_ID;
                break;
            case PORT_MAC_ALTERNATE_1:
                // _ALT1 Mac Address
		 //printk("Setting the PORT_MAC_ALTERNATE_1\n");
                MacLo = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[1][3],PTP_MAC_ADDRESS[1][2]), (DWORD)MAKEWORD(PTP_MAC_ADDRESS[1][1], PTP_MAC_ADDRESS[1][0]));
                MacHi = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[1][5],PTP_MAC_ADDRESS[1][4]), 0);
                entryProp.port =0;
                Switch_Add_Static_ALR(privateData, MacLo, MacHi, &entryProp); // forward to CPU port (MII)
                enbl_ptp_macAddr = PTP_MAC_ALTERNATE_1_ID;
                break;
            case PORT_MAC_ALTERNATE_2:
                // _ALT2 Mac Address
		// printk("Setting the PORT_MAC_ALTERNATE_2\n");
                MacLo = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[2][3],PTP_MAC_ADDRESS[2][2]), (DWORD)MAKEWORD(PTP_MAC_ADDRESS[2][1], PTP_MAC_ADDRESS[2][0]));
                MacHi = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[2][5],PTP_MAC_ADDRESS[2][4]), 0);
                entryProp.port =0;
                Switch_Add_Static_ALR(privateData, MacLo, MacHi, &entryProp); // forward to CPU port (MII)
                enbl_ptp_macAddr = PTP_MAC_ALTERNATE_2_ID;
                break;
            case PORT_MAC_ALTERNATE_3:
                // _ALT3 Mac Address
		 //printk("Setting the PORT_MAC_ALTERNATE_3\n");
                MacLo = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[3][3],PTP_MAC_ADDRESS[3][2]), (DWORD)MAKEWORD(PTP_MAC_ADDRESS[3][1], PTP_MAC_ADDRESS[3][0]));
                MacHi = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[3][5],PTP_MAC_ADDRESS[3][4]), 0);
		//printk("MACLO = 0x%x, MACHi=0x%x\n",MacLo, MacHi);
                entryProp.port =0;
                Switch_Add_Static_ALR(privateData, MacLo, MacHi,&entryProp); // forward to CPU port (MII)
                enbl_ptp_macAddr = PTP_MAC_ALTERNATE_3_ID;
                break;
            case PORT_MAC_USER_DEFINED:
		//printk("Setting the PORT_MAC_USER_DEFINED \n");
                if (!((!MacLo && !MacHi) || // initialized
                     (MacLo == 0xffffffff && MacHi == 0xffff))) { // Initialized w/ Non-Broadcast Address
                  entryProp.port =0;
                  Switch_Add_Static_ALR(privateData, MacLo, MacHi, &entryProp); // forward to CPU port (MII)
                }
                enbl_ptp_macAddr = PTP_MAC_USER_DEFINED_ID;
                break;
            default :
                goto _SetPtpPortMACExit;
                break;
        }
        for (i=0; i<4; i++) {
          if(i != enbl_ptp_macAddr) /* Enable the filter for other PTP MAC addresses */
          {
        	  MacLo = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[i][3],PTP_MAC_ADDRESS[i][2]), (DWORD)MAKEWORD(PTP_MAC_ADDRESS[i][1], PTP_MAC_ADDRESS[i][0]));
          	  MacHi = MAKEDWORD (MAKEWORD(PTP_MAC_ADDRESS[i][5],PTP_MAC_ADDRESS[i][4]), 0);
          	  Switch_Enbl_Fltr_on_ALR(privateData, MacLo, MacHi); // forward to Port1 & Port2
          }
        }
        if(enbl_ptp_macAddr < PTP_MAC_USER_DEFINED_ID)
        {
        	MacLo = ntohl(LanGetRegDW(_1588_AUX_MAC_LO));
        	MacHi = (DWORD)ntohs((WORD)(LanGetRegDW(_1588_AUX_MAC_HI) & 0xFFFF));
        	if (!((!MacLo && !MacHi) || // initialized
        			(MacLo==0xffffffff && MacHi==0xffff))) { // Initialized w/ Non-Broadcast Address
        		Switch_Enbl_Fltr_on_ALR(privateData, MacLo, MacHi); // forward to Port1 & Port2
        	}
        }
    }

    // Clear previous setting...
    portMacMap = 0x7c00 <<  port*8;
    ptpConfigValue &=~ portMacMap;
    portMacMap =  1 <<  ( port*8 + portMac);
    ptpConfigValue |= portMacMap;
    LanSetRegDW(ptpConfigReg , ptpConfigValue );

_SetPtpPortMACExit:
    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);
    return 0;
}



int ptpReloadAddTargetClock(PPRIVATE_DATA privateData, PTP_RELOAD_ADD_CLOCK_MODE reloadAddMode)
{
    unsigned ptpConfigReg = _1588_CFG;
    DWORD  dwIntFlags=0;
    VL_KEY keyCode=Vl_WaitForLock(&(privateData->PtpAccessLock),&dwIntFlags);
    /** Read Config reg**/
    unsigned ptpConfigValue = LanGetRegDW(ptpConfigReg );

    // Clear previous setting...
    if ((reloadAddMode == PTP_ADD_MODE) ||
        (reloadAddMode == PTP_RELOAD_MODE)) {
        ptpConfigValue &= (~1);
        ptpConfigValue |= reloadAddMode;
        LanSetRegDW(ptpConfigReg , ptpConfigValue );
    }

    Vl_ReleaseLock(&(privateData->PtpAccessLock),keyCode,&dwIntFlags);

    return 0;
}



