/***************************************************************************
 *
 * Copyright (C) 2006-200v  SMSC
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ***************************************************************************
 * File: mibStats.h
 */

#ifndef SH3_POLARIS_H
#define SH3_POLARIS_H


#define GPIO_HI	TRUE
#define GPIO_LO	FALSE


/************************/
/*         LED          */
/************************/
/* 01.04.16 CommentOut	*/
/* (JG) 1/5/04 Use this port to monitor validation code for 11x. */
#define	LEDREG	(*(volatile unsigned short *)0xB0C00000UL)

/************************/
/*       3.MMU          */
/************************/
#define	PTEH	(*(volatile unsigned long *)0xFFFFFFF0UL)
#define	PTEL	(*(volatile unsigned long *)0xFFFFFFF4UL)
#define	TTB		(*(volatile unsigned long *)0xFFFFFFF8UL)
#define	TEA		(*(volatile unsigned long *)0xFFFFFFFCUL)
#define	MMUCR	(*(volatile unsigned long *)0xFFFFFFE0UL)

/************************/
/*       4.EXP          */
/************************/
#define	TRA		(*(volatile unsigned long *)0xFFFFFFD0UL)
#define	EXPEVT	(*(volatile unsigned long *)0xFFFFFFD4UL)
#define	INTEVT	(*(volatile unsigned long *)0xFFFFFFD8UL)
#define	INTEVT2	(*(volatile unsigned long *)0xA4000000UL)

/**************************/
/*       5.CACHE          */
/**************************/
#ifdef CCR
#undef CCR
#endif
#define	CCR		(*(volatile unsigned long *)0xFFFFFFECUL)

#define	CCR_CF_		0x08UL		// Cache Flush Bit

#define	CCR2	(*(volatile unsigned long *)0xA40000B0UL)

/*
 ****************************************************************************
 *	Cache stuff
 ****************************************************************************
 *
 */
//#define CACHE_LINE_BYTES		16UL	//Cache size = 16bytes, for Platform.H
//use PLATFORM_CACHE_LINE_BYTES instead
//
//#define CACHE_PHYSADDR_MASK		0x1FFFFC00UL
#ifdef CACHE_PHYSADDR_MASK
#undef  CACHE_PHYSADDR_MASK
#endif
#define CACHE_PHYSADDR_MASK		0xFFFFFC00UL

#ifdef CACHE_OC_ADDRESS_ARRAY
#undef CACHE_OC_ADDRESS_ARRAY
#endif
#define CACHE_OC_ADDRESS_ARRAY		0xF0000000UL
#define CACHE_OC_ENTRY_MASK		0x00000FF0UL
#define CACHE_OC_ASSOC_BIT_		0x00000008UL

/**************************/
/*       6.X/YMemory      */
/**************************/


/**************************/
/*       7.INTC           */
/**************************/
#define	ICR0		(*(volatile unsigned short *)0xFFFFFEE0UL)
#define	ICR1		(*(volatile unsigned short *)0xA4000010UL)

#define  ICR1_IRQ_MASK               0x3

#define	ICR2		(*(volatile unsigned short *)0xA4000012UL)
#define	ICR3		(*(volatile unsigned short *)0xA4000228UL)
#define	PINTER		(*(volatile unsigned short *)0xA4000014UL)
#define	IPRA		(*(volatile unsigned short *)0xFFFFFEE2UL)
#define	IPRB		(*(volatile unsigned short *)0xFFFFFEE4UL)
#define	IPRC		(*(volatile unsigned short *)0xA4000016UL)
#define	IPRD		(*(volatile unsigned short *)0xA4000018UL)
#define	IPRE		(*(volatile unsigned short *)0xA400001AUL)
#define	IPRF		(*(volatile unsigned short *)0xA4000220UL)
#define	IPRG		(*(volatile unsigned short *)0xA4000222UL)
#define	IRR0		(*(volatile unsigned char *)0xA4000004UL)
#define	IRR1		(*(volatile unsigned char *)0xA4000006UL)
#define	IRR2		(*(volatile unsigned char *)0xA4000008UL)
#define	IRR3		(*(volatile unsigned short *)0xA4000224UL)
#define	IRR4		(*(volatile unsigned short *)0xA4000226UL)

/**************************/
/*       8.UBC            */
/**************************/
#define	BARA		(*(volatile unsigned long *)0xFFFFFFB0UL)
#define	BAMRA		(*(volatile unsigned long *)0xFFFFFFB4UL)
#define	BBRA		(*(volatile unsigned short *)0xFFFFFFB8UL)

#define	BARB		(*(volatile unsigned long *)0xFFFFFFA0UL)
#define	BAMRB		(*(volatile unsigned long *)0xFFFFFFA4UL)
#define	BBRB		(*(volatile unsigned short *)0xFFFFFFA8UL)
#define	BDRB		(*(volatile unsigned long *)0xFFFFFF90UL)
#define	BDMRB		(*(volatile unsigned long *)0xFFFFFF94UL)
#define	BRCR		(*(volatile unsigned long *)0xFFFFFF98UL)

#define	BETR		(*(volatile unsigned short *)0xFFFFFF9CUL)
#define	BRSR		(*(volatile unsigned long *)0xFFFFFFACUL)
#define	BRDR		(*(volatile unsigned long *)0xFFFFFFBCUL)

#define	BASRA		(*(volatile unsigned char *)0xFFFFFFE4UL)
#define	BASRB		(*(volatile unsigned char *)0xFFFFFFE8UL)

/**************************/
/*       9.Low Power      */
/**************************/
#define	STBCR		(*(volatile unsigned char *)0xFFFFFF82UL)
#define	STBCR2		(*(volatile unsigned char *)0xFFFFFF88UL)
#define	STBCR3		(*(volatile unsigned char *)0xA4000230UL)
#define	SRSTR		(*(volatile unsigned char *)0xA4000232UL)

/**************************/
/*      10.CPG            */
/**************************/
#define	FRQCR		(*(volatile unsigned short *)0xFFFFFF80UL)

#define	WTCNT_R		(*(volatile unsigned char *)0xFFFFFF84UL)
#define	WTCNT_W		(*(volatile unsigned short *)0xFFFFFF84UL)
#define	WTCSR_R		(*(volatile unsigned char *)0xFFFFFF86UL)
#define	WTCSR_W		(*(volatile unsigned short *)0xFFFFFF86UL)

/**************************/
/*      11.EXCPG          */
/**************************/
#define	EXCPGCR		(*(volatile unsigned char *)0xA4000236UL)

/**************************/
/*      12.BSC            */
/**************************/
#define	BCR1		(*(volatile unsigned short *)0xFFFFFF60UL)
#define	BCR2		(*(volatile unsigned short *)0xFFFFFF62UL)
#define	WCR1		(*(volatile unsigned short *)0xFFFFFF64UL)
#define	WCR2		(*(volatile unsigned short *)0xFFFFFF66UL)
 /* Bus Wait State Control Definitions */
#define	WAIT_STATES_0		0x0
#define	WAIT_STATES_1		0x1
#define	WAIT_STATES_2		0x2
#define	WAIT_STATES_3		0x3
#define	WAIT_STATES_4		0x4
#define	WAIT_STATES_6		0x5
#define	WAIT_STATES_8		0x6
#define	WAIT_STATES_10		0x7

 /* Bit map in WCR2 */
#define	AREA_0				0
#define	AREA_2				2
#define	AREA_3				3
#define	AREA_4				4
#define	AREA_5				5
#define	AREA_6				6

#define	AREA0_WAIT_CTRL_	0x0007
#define	AREA2_WAIT_CTRL_	0x0018
#define	AREA3_WAIT_CTRL_	0x0060
#define	AREA4_WAIT_CTRL_	0x0380
#define	AREA5_WAIT_CTRL_	0x1C00
#define	AREA6_WAIT_CTRL_	0xE000

#define	MCR			(*(volatile unsigned short *)0xFFFFFF68UL)
#define	PCR			(*(volatile unsigned short *)0xFFFFFF6CUL)
#define	RTCSR		(*(volatile unsigned short *)0xFFFFFF6EUL)
#define	RTCNT		(*(volatile unsigned short *)0xFFFFFF70UL)
#define	RTCOR		(*(volatile unsigned short *)0xFFFFFF72UL)
#define	RFCR		(*(volatile unsigned short *)0xFFFFFF74UL)

#define	SDMR		(*(volatile unsigned char *)0xFFFFE880UL)

/**************************/
/*      13.LBSC           */
/**************************/
/*
	Refer BCR1, BCR2, WCR1, WCR2, MCR
*/

/**************************/
/*      14.DMAC           */
/**************************/
/*
	Chanel 0
*/
#define	SAR0		(*(volatile unsigned long *)0xA4000020UL)
#define	DAR0		(*(volatile unsigned long *)0xA4000024UL)
#define	DMATCR0		(*(volatile unsigned long *)0xA4000028UL)
#define	CHCR0		(*(volatile unsigned long *)0xA400002CUL)

/*
	Chanel 1
*/
#define	SAR1		(*(volatile unsigned long *)0xA4000030UL)
#define	DAR1		(*(volatile unsigned long *)0xA4000034UL)
#define	DMATCR1		(*(volatile unsigned long *)0xA4000038UL)
#define	CHCR1		(*(volatile unsigned long *)0xA400003CUL)

/*
	Chanel 2
*/
#define	SAR2		(*(volatile unsigned long *)0xA4000040UL)
#define	DAR2		(*(volatile unsigned long *)0xA4000044UL)
#define	DMATCR2		(*(volatile unsigned long *)0xA4000048UL)
#define	CHCR2		(*(volatile unsigned long *)0xA400004CUL)

/*
	Chanel 3
*/
#define	SAR3		(*(volatile unsigned long *)0xA4000050UL)
#define	DAR3		(*(volatile unsigned long *)0xA4000054UL)
#define	DMATCR3		(*(volatile unsigned long *)0xA4000058UL)
#define	CHCR3		(*(volatile unsigned long *)0xA400005CUL)

/* Bit map of CHCRx */
#define	DMAC_ENBL_		0x00000001UL
#define	XFER_END_		0x00000002UL
#define	INT_ENBL_		0x00000004UL

#define	XMIT_SIZE_		0x00000018UL
#define	XMIT_BYTE		0x00000000UL
#define	XMIT_WORD		0x00000008UL
#define	XMIT_DWORD		0x00000010UL
#define	XMIT_QDWORD		0x00000018UL

#define	XMIT_MODE_		0x00000020UL

#define	XMIT_RESRC_		0x00000F00UL
#define	AUTO_REQ		0x00000400UL

#define	SRC_ADDR_MODE_	0x00003000UL
#define	FIXED_SRC_ADDR	0x00000000UL
#define	INC_SRC_ADDR	0x00001000UL
#define	DEC_SRC_ADDR	0x00002000UL

#define	DST_ADDR_MODE_	0x0000C000UL
#define	FIXED_DST_ADDR	0x00000000UL
#define	INC_DST_ADDR	0x00004000UL
#define	DEC_DST_ADDR	0x00008000UL

/*
	Common
*/
#define	DMAOR		(*(volatile unsigned short *)0xA4000060UL)
#define	DMA_MSTR_EN_	0x0001
#define	NMI_FLAG_		0x0002
#define	ADDR_ERR_FLAG_	0x0004

#define	CHRAR		(*(volatile unsigned short *)0xA400022AUL)

/**************************/
/*      15.TMU            */
/**************************/
/*
	Common
*/
#define	TSTR		(*(volatile unsigned char *)0xFFFFFE92UL)
#define STR2_		0x04
#define STR1_		0x02
#define STR0_		0x01

/*
	Chanel 0
*/
#define	TCOR0		(*(volatile unsigned long *)0xFFFFFE94UL)
#define	TCNT0		(*(volatile unsigned long *)0xFFFFFE98UL)
#define	TCR0		(*(volatile unsigned short *)0xFFFFFE9CUL)
#define PCLK_DIV4_		0x0000
#define PCLK_DIV16_	0x0001
#define PCLK_DIV64_	0x0002
#define PCLK_DIV256_	0x0003
#define RTCCLK_		0x0004

/*
	Chanel 1
*/
#define	TCOR1		(*(volatile lunsigned ong *)0xFFFFFEA0UL)
#define	TCNT1		(*(volatile unsigned long *)0xFFFFFEA4UL)
#define	TCR1		(*(volatile unsigned short *)0xFFFFFEA8UL)

/*
	Chanel 2
*/
#define	TCOR2		(*(volatile unsigned long *)0xFFFFFEACUL)
#define	TCNT2		(*(volatile unsigned long *)0xFFFFFEB0UL)
#define	TCR2		(*(volatile unsigned short *)0xFFFFFEB4UL)

/**************************/
/*      16.RTC            */
/**************************/
#define	R64CNT		(*(volatile unsigned char *)0xFFFFFEC0UL)
#define	RSECCNT		(*(volatile unsigned char *)0xFFFFFEC2UL)
#define	RMINCNT		(*(volatile unsigned char *)0xFFFFFEC4UL)
#define	RHRCNT		(*(volatile unsigned char *)0xFFFFFEC6UL)
#define	RWKCNT		(*(volatile unsigned char *)0xFFFFFEC8UL)

#define	RDAYCNT		(*(volatile unsigned char *)0xFFFFFECAUL)
#define	RMONCNT		(*(volatile unsigned char *)0xFFFFFECCUL)

#define	RYRCNT		(*(volatile unsigned char *)0xFFFFFECEUL)
#define	RSECAR		(*(volatile unsigned char *)0xFFFFFED0UL)
#define	RMINAR		(*(volatile unsigned char *)0xFFFFFED2UL)
#define	RHRAR		(*(volatile unsigned char *)0xFFFFFED4UL)

#define	RWKAR		(*(volatile unsigned char *)0xFFFFFED6UL)
#define	RDAYAR		(*(volatile unsigned char *)0xFFFFFED8UL)
#define	RMONAR		(*(volatile unsigned char *)0xFFFFFEDAUL)
#define	RCR1		(*(volatile unsigned char *)0xFFFFFEDCUL)
#define	RCR2		(*(volatile unsigned char *)0xFFFFFEDEUL)

/**************************/
/*      17.SCI            */
/**************************/
#define	SCSMR	(*(volatile unsigned char *)0xFFFFFE80UL)
#define	SCBRR	(*(volatile unsigned char *)0xFFFFFE82UL)
#define	SCSCR	(*(volatile unsigned char *)0xFFFFFE84UL)
#define	SCTDR	(*(volatile unsigned char *)0xFFFFFE86UL)
#define SCSSR	(*(volatile unsigned char *)0xFFFFFE88UL)
#define	SCRDR	(*(volatile unsigned char *)0xFFFFFE8AUL)

#define	SCPDR	(*(volatile unsigned char *)0xA4000136UL)

/**************************/
/*      18.SmartC         */
/**************************/
#define	SMART_SCSMR		(*(volatile unsigned char *)0xFFFFFE80UL)
#define	SMART_SCBRR		(*(volatile unsigned char *)0xFFFFFE82UL)
#define	SMART_SCSCR		(*(volatile unsigned char *)0xFFFFFE84UL)
#define	SMART_SCTDR		(*(volatile unsigned char *)0xFFFFFE86UL)
#define SMART_SCSSR		(*(volatile unsigned char *)0xFFFFFE88UL)
#define	SMART_SCRDR		(*(volatile unsigned char *)0xFFFFFE8AUL)
#define	SMART_SCSCMR	(*(volatile unsigned char *)0xFFFFFE8CUL)

/**************************/
/*      19.SCIF2          */
/**************************/
#define	SCSMR2		(*(volatile unsigned char *)0xA4000150UL)
#define	SCBRR2		(*(volatile unsigned char *)0xA4000152UL)
#define	SCSCR2		(*(volatile unsigned char *)0xA4000154UL)
#define	SCSFDR2		(*(volatile unsigned char *)0xA4000156UL)
#define	SCSSR2		(*(volatile unsigned short *)0xA4000158UL)
#define	SCFRDR2		(*(volatile unsigned char *)0xA400015AUL)
#define	SCFCR2		(*(volatile unsigned char *)0xA400015CUL)
#define	SCFDR2		(*(volatile unsigned short *)0xA400015EUL)

#define	SCIRDR2		(*(volatile unsigned short *)0xA400023AUL)

/**************************/
/*      20.SIOF           */
/**************************/
#define	SIMDR		(*(volatile unsigned short *)0xA40000C0UL)
#define	SISCR		(*(volatile unsigned short *)0xA40000C2UL)
#define	SITDAR		(*(volatile unsigned short *)0xA40000C4UL)
#define	SIRDAR		(*(volatile unsigned short *)0xA40000C6UL)
#define	SICDAR		(*(volatile unsigned short *)0xA40000C8UL)
#define	SICTR		(*(volatile unsigned short *)0xA40000CCUL)
#define	SIFCTR		(*(volatile unsigned short *)0xA40000D0UL)
#define	SISTR		(*(volatile unsigned short *)0xA40000D4UL)
#define	SIIER		(*(volatile unsigned short *)0xA40000D6UL)
#define	SITDR		(*(volatile unsigned long *)0xA40000E0UL)
#define	SIRDR		(*(volatile unsigned long *)0xA40000E4UL)
#define	SITCR		(*(volatile unsigned long *)0xA40000E8UL)
#define	SIRCR		(*(volatile unsigned long *)0xA40000ECUL)

/**************************/
/*      21.AFEIF          */
/**************************/
#define	ACTR1	(*(volatile unsigned short *)0xA4000180UL)
#define	ACTR2	(*(volatile unsigned short *)0xA4000182UL)
#define	ASTR1	(*(volatile unsigned short *)0xA4000184UL)
#define	ASTR2	(*(volatile unsigned short *)0xA4000186UL)
#define	MRCR	(*(volatile unsigned short *)0xA4000188UL)
#define	MPCR	(*(volatile unsigned short *)0xA400018AUL)
#define	DPNQ	(*(volatile unsigned short *)0xA400018CUL)
#define	RCNT	(*(volatile unsigned short *)0xA400018EUL)
#define	ACDR	(*(volatile unsigned short *)0xA4000190UL)
#define	ASDR	(*(volatile unsigned short *)0xA4000192UL)
#define	TDFP	(*(volatile unsigned long *)0xA4000194UL)
#define	RDFP	(*(volatile unsigned long *)0xA4000198UL)

/**************************/
/*      22.USBPMPXC       */
/**************************/
#define	EXPFC	(*(volatile unsigned char *)0xA4000234UL)

/**************************/
/*      23.USBF           */
/**************************/
#define	USB_FUNC_IFR0	(*(volatile unsigned char *)0xA4000240UL)

#define	USB_FUNC_IFR1	(*(volatile unsigned char *)0xA4000241UL)
#define	USB_FUNC_EPDR0I	(*(volatile unsigned char *)0xA4000242UL)
#define	USB_FUNC_EPDR0O	(*(volatile unsigned char *)0xA4000243UL)
#define	USB_FUNC_TRG	(*(volatile unsigned char *)0xA4000244UL)
#define	USB_FUNC_FCLR	(*(volatile unsigned char *)0xA4000245UL)

#define	USB_FUNC_EPSZ0O	(*(volatile unsigned char *)0xA4000246UL)
#define	USB_FUNC_EPDR0S	(*(volatile unsigned char *)0xA4000247UL)
#define	USB_FUNC_DASTS	(*(volatile unsigned char *)0xA4000248UL)

#define	USB_FUNC_EPDR2	(*(volatile unsigned char *)0xA4000249UL)
#define	USB_FUNC_ISR0	(*(volatile unsigned char *)0xA400024AUL)
#define	USB_FUNC_EPSTL	(*(volatile unsigned char *)0xA400024BUL)

#define	USB_FUNC_IER0	(*(volatile unsigned char *)0xA400024CUL)
#define	USB_FUNC_IER1	(*(volatile unsigned char *)0xA400024DUL)

#define	USB_FUNC_EPDR1	(*(volatile unsigned char *)0xA400024EUL)
#define	USB_FUNC_EPSZ1	(*(volatile unsigned char *)0xA400024FUL)
#define	USB_FUNC_ISR1	(*(volatile unsigned char *)0xA4000250UL)

#define	USB_FUNC_DMAR	(*(volatile unsigned char *)0xA4000251UL)
#define	USB_FUNC_EPDR3	(*(volatile unsigned char *)0xA4000252UL)

/**************************/
/*      24.USBH           */
/**************************/
#define	USB_HOST_REVR		(*(volatile unsigned long *)0xA4000280UL)
#define	USB_HOST_CTR		(*(volatile unsigned long *)0xA4000284UL)

#define	USB_HOST_CMDSR		(*(volatile unsigned long *)0xA4000288UL)

#define	USB_HOST_IRPSR		(*(volatile unsigned long *)0xA400028CUL)

#define	USB_HOST_IRPER		(*(volatile unsigned long *)0xA4000290UL)
#define	USB_HOST_IRPDR		(*(volatile unsigned long *)0xA4000294UL)
#define	USB_HOST_HCCAR		(*(volatile unsigned long *)0xA4000298UL)
#define	USB_HOST_PCUREDR	(*(volatile unsigned long *)0xA400029CUL)
#define	USB_HOST_CTRHDEDR	(*(volatile unsigned long *)0xA40002A0UL)

#define	USB_HOST_CTRCUREDR	(*(volatile unsigned long *)0xA40002A4UL)

#define	USB_HOST_BULKHDED	(*(volatile unsigned long *)0xA40002A8UL)

#define	USB_HOST_BULKCUREDR	(*(volatile unsigned long *)0xA40002ACUL)
#define	USB_HOST_DONRHDEDR	(*(volatile unsigned long *)0xA40002B0UL)
#define	USB_HOST_FMTNERVR	(*(volatile unsigned long *)0xA40002B4UL)
#define	USB_HOST_FRMREMINGR	(*(volatile unsigned long *)0xA40002B8UL)
#define	USB_HOST_FMNUMBR	(*(volatile unsigned long *)0xA40002BCUL)

#define	USB_HOST_PDSTRR		(*(volatile unsigned long *)0xA40002C0UL)

#define	USB_HOST_LSTSHDR	(*(volatile unsigned long *)0xA40002C4UL)

#define	USB_HOST_RHDESCAR	(*(volatile unsigned long *)0xA40002C8UL)
#define	USB_HOST_RHDESCBR	(*(volatile unsigned long *)0xA40002CCUL)
#define	USB_HOST_RHSR		(*(volatile unsigned long *)0xA40002D0UL)
#define	USB_HOST_RHPTSR1	(*(volatile unsigned long *)0xA40002D4UL)
#define	USB_HOST_RHPTSR2	(*(volatile unsigned long *)0xA40002D8UL)

/**************************/
/*      25.LCD            */
/**************************/
#define	LDICKR		(*(volatile unsigned short *)0xA4000C00UL)
#define	LDMTR		(*(volatile unsigned short *)0xA4000C02UL)
#define	LDDFR		(*(volatile unsigned short *)0xA4000C04UL)
#define	LDSMR		(*(volatile unsigned short *)0xA4000C06UL)
#define	LDSARU		(*(volatile unsigned long *)0xA4000C08UL)
#define	LDSARL		(*(volatile unsigned long *)0xA4000C0CUL)
#define	LDLAOR		(*(volatile unsigned short *)0xA4000C10UL)
#define	LDPALCR		(*(volatile unsigned short *)0xA4000C12UL)

#define	LDPR00		(*(volatile unsigned long *)0xA4000800UL)

#define	LDHCNR		(*(volatile unsigned short *)0xA4000C14UL)
#define	LDHSYNR		(*(volatile unsigned short *)0xA4000C16UL)
#define	LDVDLNR		(*(volatile unsigned short *)0xA4000C18UL)
#define	LDVTLNR		(*(volatile unsigned short *)0xA4000C1AUL)
#define	LDVSYNR		(*(volatile unsigned short *)0xA4000C1CUL)
#define	LDACLNR		(*(volatile unsigned short *)0xA4000C1EUL)
#define	LDINTR		(*(volatile unsigned short *)0xA4000C20UL)
#define	LDPMMR		(*(volatile unsigned short *)0xA4000C24UL)
#define	LDPSPR		(*(volatile unsigned short *)0xA4000C26UL)
#define	LDCNTR		(*(volatile unsigned short *)0xA4000C28UL)

/**************************/
/*      26.IOMPX          */
/**************************/
#define	PACR		(*(volatile unsigned short *)0xA4000100UL)
#define	PBCR		(*(volatile unsigned short *)0xA4000102UL)
#define	PCCR		(*(volatile unsigned short *)0xA4000104UL)
#define	PDCR		(*(volatile unsigned short *)0xA4000106UL)
#define	PECR		(*(volatile unsigned short *)0xA4000108UL)
#define	PFCR		(*(volatile unsigned short *)0xA400010AUL)
#define	PGCR		(*(volatile unsigned short *)0xA400010CUL)
#define	PHCR		(*(volatile unsigned short *)0xA400010EUL)
#define	PJCR		(*(volatile unsigned short *)0xA4000110UL)
#define	PKCR		(*(volatile unsigned short *)0xA4000112UL)
#define	PLCR		(*(volatile unsigned short *)0xA4000114UL)
#define SCPCR		(*(volatile unsigned short *)0xA4000116UL)
#define	PMCR		(*(volatile unsigned short *)0xA4000118UL)

/**************************/
/*      27.I/O PORT       */
/**************************/
#define	PADR		(*(volatile unsigned char *)0xA4000120UL)
#define	PBDR		(*(volatile unsigned char *)0xA4000122UL)
#define	PCDR		(*(volatile unsigned char *)0xA4000124UL)
#define	PDDR		(*(volatile unsigned char *)0xA4000126UL)
#define	PEDR		(*(volatile unsigned char *)0xA4000128UL)
#define	PFDR		(*(volatile unsigned char *)0xA400012AUL)
#define	PGDR		(*(volatile unsigned char *)0xA400012CUL)
#define	PHDR		(*(volatile unsigned char *)0xA400012EUL)
#define	PJDR		(*(volatile unsigned char *)0xA4000130UL)
#define	PKDR		(*(volatile unsigned char *)0xA4000132UL)
#define	PLDR		(*(volatile unsigned char *)0xA4000134UL)
//#define	SCPDR		(*(volatile unsigned char *)0xA4000136UL)
#define	PMDR		(*(volatile unsigned char *)0xA4000138UL)

/**************************/
/*      28.A/D            */
/**************************/
#define	ADDRAH		(*(volatile unsigned char *)0xA4000080UL)
#define	ADDRAL		(*(volatile unsigned char *)0xA4000082UL)
#define	ADDRBH		(*(volatile unsigned char *)0xA4000084UL)
#define	ADDRBL		(*(volatile unsigned char *)0xA4000086UL)
#define	ADDRCH		(*(volatile unsigned char *)0xA4000088UL)
#define	ADDRCL		(*(volatile unsigned char *)0xA400008AUL)
#define	ADDRDH		(*(volatile unsigned char *)0xA400008CUL)
#define	ADDRDL		(*(volatile unsigned char *)0xA400008EUL)
#define	ADCSR		(*(volatile unsigned char *)0xA4000090UL)
#define	ADCR		(*(volatile unsigned char *)0xA4000092UL)

/**************************/
/*      29.D/A            */
/**************************/
#define	DADR0		(*(volatile unsigned char *)0xA40000A0UL)
#define	DADR1		(*(volatile unsigned char *)0xA40000A2UL)
#define	DACR		(*(volatile unsigned char *)0xA40000A4UL)

/**************************/
/*      30.PCC            */
/**************************/
#define	PCC0ISR		(*(volatile unsigned char *)0xA40000E0UL)
#define	PCC0GCR		(*(volatile unsigned char *)0xA40000E2UL)
#define	PCC0CSCR	(*(volatile unsigned char *)0xA40000E4UL)
#define	PCC0CSCIER	(*(volatile unsigned char *)0xA40000E6UL)

/**************************/
/*      31.HUDI           */
/**************************/
#define	SDBPR		()
#define	SDIR		(*(volatile unsigned short *)0xA4000200UL)
#define	SDBSR		()

#define LAN_IRQ PLATFORM_IRQ

#define CpuToPhysicalAddr(cpuAddr) ((DWORD)cpuAddr)

/*
 ****************************************************************************
 *	SPI Access Registers Reader/Writers
 ****************************************************************************
 *
 */

/* Define GPIO bit map */
#define GPIO0				0x01
#define GPIO1				0x02
#define GPIO2				0x04
#define GPIO3				0x08
#define GPIO4				0x10
#define GPIO5				0x20
#define GPIO6				0x40
#define GPIO7				0x80

#define	GPIO_BASE			0xA4000000UL
#define	UART_BASE			0xA4000150UL


// Base address
#define UNCACHED_CSBASE		(0xA0000000UL)
#define CS_ADDR_INC		(0x04000000UL)	// CS's are 64 MB apart
#define I2C_CS				(2UL)		// Area 2 (#CS2)

#define I2C_CSBASE		(UNCACHED_CSBASE + (CS_ADDR_INC * I2C_CS))

/*
 ****************************************************************************
 *  I2C definitions
 ****************************************************************************
 *
 */

 #define I2CSTA                 0UL
 #define I2CTO                  0UL
 #define I2CDAT                 1UL
 #define I2CADR                 2UL
 #define I2CCON                 3UL
     #define I2CCON_AA_         (BYTE)0x80
     #define I2CCON_ENSIO_      (BYTE)0x40
     #define I2CCON_STA_        (BYTE)0x20
     #define I2CCON_STO_        (BYTE)0x10
     #define I2CCON_SI_         (BYTE)0x08
         #define I2CCON_330KHZ_SCLK_    (BYTE)0x00

 #define LEO_I2C_ADDR           (BYTE)0x0A
#define LEO_I2C_STRAP_ADDR      (BYTE)0x77
 #define I2C_READ_COMMAND       (BYTE)0x01
 #define I2C_WRITE_COMMAND      (BYTE)0x00

 #define I2C_SPI_MAX_RETRY          5000UL


/*
 ****************************************************************************
 *  SPI definitions
 ****************************************************************************
 *
 */
#define SCSSR_TDRE_            (BYTE)0x80    // Not valid transmit data
#define SCSSR_RDRF_            (BYTE)0x40    // Valid Rx Data
#define SCSSR_ORER_            (BYTE)0x20    // RX Overrun
#define SCSSR_FER_             (BYTE)0x10    // RX Framig error

#define SCSSR_PER_             (BYTE)0x08    // Parity Error, Async mod e only.

 #ifndef _SPI_EXTERNAL_CLK_MODE
 #define SCSSR_TEND_                    (BYTE)0x04
 #endif




 #define SCSCR_TE           (BYTE)0x20
 #define SCSCR_RE           (BYTE)0x10

 #define SPI_READ_CMD           (BYTE)0x03
 #define SPI_READ_INC_CMD       (BYTE)0x07
 #define SPI_READ_DEC_CMD       (BYTE)0x0B
 #define SPI_WRITE_CMD          (BYTE)0x02
 #define SPI_WRITE_INC_CMD      (BYTE)0x06
 #define SPI_WRITE_DEC_CMD      (BYTE)0x0A

 #define SetSpiCs()     (GpioOut(0UL, GPIO0, GPIO_HI))
#define ClearSpiCs()    (GpioOut(0UL, GPIO0, GPIO_LO))

#define EnableSpiTx()   (SCSCR |= SCSCR_TE)
#define DisableSpiTx()  (SCSCR &= (~SCSCR_TE))
#define EnableSpiRx()   (SCSCR |= SCSCR_RE)
#define DisableSpiRx()  (SCSCR &= (~SCSCR_RE))



void GpioOut(const DWORD dwGpioBase, const int iBitCombo, const BOOLEAN fBitValue);
void SpiHwInit(void);
void EnableGPIO(void);
BYTE I2cGetRegB(const DWORD dwI2cBase, const DWORD dwOffset);
void I2cSetRegB(const DWORD dwI2cBase, const DWORD dwOffset, const BYTE bVal);
void I2cHwInit(void);

#endif
