/***************************************************************************
 *
 * Copyright (C) 2005-2006  SMSC
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ***************************************************************************
 * File: switchReg.h
 */
#ifndef SWITCH_REG_H
#define SWITCH_REG_H

///////////////////////////////////////////////////////////////
//
// Switch MAC RX and MAC RX STATTS for MII, port 0 and port 1
//
//     Those are accesses through SWITCH_CSR_CMD and SWITCH_CSR_DATA
/////////////////////////////////////////////////////////////
//
#define MII_OFFSET                    (0x0L)
#define PORT1_OFFSET                  (0x400L)
#define PORT2_OFFSET                  (0x800L)


/////////////////////////////////////////////////////


///////////////////////////////////////////////////

/*
 *******************************************************************************************************
 *	                         Switch Core Registers
 *******************************************************************************************************/


#define GLB_ID					(0x0UL)
#define	GLB_ID_DEV_TYP_			(0x00FF0000UL)	// RO
#define	GLB_ID_CHP_VER_			(0x0000FF00UL)	// RO
#define	GLB_ID_REV_NUM_			(0x000000FFUL)	// RO

#define GLB_RST					(0x1UL)
#define	GLB_RST_SW_RST_			(0x00000001UL)	// W0 must be manually set
													// and cleared does not read back
#define GLB_IMR					(0x4UL)
#define	GLB_IMR_BM_EN_			(0x00000040UL)	// RW
#define	GLB_IMR_SWE_EN_			(0x00000020UL)	// RW
#define	GLB_IMR_MP2_EN_			(0x00000004UL)	// RW
#define	GLB_IMR_MP1_EN			(0x00000002UL)	// RW
#define	GLB_IMR_MII_EN_			(0x00000001UL)	// RW

#define GLB_IPR					(0x5UL)
#define	GLB_IPR_BM_				(0x00000040UL)	// RC
#define	GLB_IPR_SWE_			(0x00000020UL)	// RC
#define	GLB_IPR_MP2_			(0x00000004UL)	// RC
#define	GLB_IPR_MP1_			(0x00000002UL)	// RC
#define	GLB_IPR_MII_			(0x00000001UL)	// RC

#define GLB_ISR					(0x6UL)     // RESERVED


/****************************** MAC_MII *************************************/
#define MII_VER_ID				(0x400UL)
#define	MII_VER_ID_DEV_TYP_	            	        (0x00000F00UL)	// RO
#define	MII_VER_ID_CHP_VER_		                (0x000000F0UL)	// RO
#define	MII_VER_ID_REV_NUM_	                    	(0x0000000FUL)	// RO
#define MII_RX_CFG				(0x401UL)
#define	MII_RX_CFG_PASS_ANY_                    	(0x00000080UL)	// RW
#define	MII_RX_CFG_JUM_2K_	                     	(0x00000008UL)	// RW
#define	MII_RX_CFG_REJ_MAC_TYP_                 	(0x00000002UL)	// RW
#define	MII_RX_CFG_RX_EN_	                      	(0x00000001UL)	// RW
#define MII_RX_UNDSZE_CNT	              	(0x410UL)
#define MII_RX_64_CNT			            (0x411UL)
#define MII_RX_65_TO_127_CNT	            (0x412UL)
#define MII_RX_128_TO_255_CNT           	(0x413UL)
#define MII_RX_256_TO_511_CNT           	(0x414UL)
#define MII_RX_512_TO_1023_CNT          	(0x415UL)
#define MII_RX_1024_TO_MAX_CNT          	(0x416UL)
#define MII_RX_OVRSZE_CNT	              	(0x417UL)
#define MII_RX_PKTOK_CNT	               	(0x418UL)
#define MII_RX_CRCERR_CNT	              	(0x419UL)
#define MII_RX_MULCST_CNT	              	(0x41AUL)
#define MII_RX_BRDCST_CNT	              	(0x41BUL)
#define MII_RX_PAUSE_CNT		            (0x41CUL)
#define MII_RX_FRAG_CNT			            (0x41DUL)
#define MII_RX_JABB_CNT		               	(0x41EUL)
#define MII_RX_ALIGN_CNT	               	(0x41FUL)
#define MII_RX_PKTLEN_CNT	              	(0x420UL)
#define MII_RX_GOOD_PKTLEN_CNT          	(0x421UL)
#define MII_RX_SYMBL_CNT	               	(0x422UL)
#define MII_RX_CTLFRM_CNT	              	(0x423UL)

#define MII_TX_CFG		            	(0x440UL)
#define	MII_TX_CFG_XIFG_CFG_                    	(0x0000007CUL)	// RW
#define	MII_TX_CFG_TX_PAD_EN_                   	(0x00000002UL)	// RW
#define	MII_TX_CFG_TX_EN_	                      	(0x00000001UL)	// RW
#define MII_TX_FC_STNGS		               	(0x441UL)
#define	MII_TX_FC_STNGS_XBLK_RST_               	(0x00030000UL)	// RW
#define	MII_TX_FC_STNGS_XTIM_VAL_               	(0x0000FFFFUL)	// RW
#define MII_TX_UNDRUN_CNT			(0x450UL) // RESERVED
#define MII_TX_DEFER_CNT			(0x451UL)
#define MII_TX_PAUSE_CNT			(0x452UL)
#define MII_TX_PKTOK_CNT			(0x453UL)
#define MII_TX_64_CNT				(0x454UL)
#define MII_TX_65_TO_127_CNT	           	(0x455UL)
#define MII_TX_128_TO_255_CNT	          	(0x456UL)
#define MII_TX_256_TO_511_CNT	          	(0x457UL)
#define MII_TX_512_TO_1023_CNT	         	(0x458UL)
#define MII_TX_1024_TO_MAX_CNT	         	(0x459UL)
#define MII_TX_UNDSZE_CNT			(0x45AUL)
#define MII_TX_PKTLEN_CNT			(0x45CUL)
#define MII_TX_BRDCST_CNT			(0x45DUL)
#define MII_TX_MULCST_CNT			(0x45EUL)
#define MII_TX_LATECOL_CNT			(0x45FUL)
#define MII_TX_EXCCOL_CNT			(0x460UL)
#define MII_TX_SNGLECOL_CNT			(0x461UL)
#define MII_TX_MULTICOL_CNT			(0x462UL)
#define MII_TX_TOTALCOL_CNT			(0x463UL)

#define MII_IMR					(0x480UL)
#define MII_IPR					(0x481UL)
#define MII_ISR					(0x482UL) // RESERVED





#define SE_ALR_CMD				(0x1800UL)
	#define	SE_ALR_CMD_RST_WR_		           (0x00000004UL)	// RW
	#define	SE_ALR_CMD_RST_RD_		           (0x00000002UL)	// RW
	#define	SE_ALR_CMD_GET_NXT_		           (0x00000001UL)	// RW

#define SE_ALR_WR_DAT_0		               (0x1801UL)
	#define	SE_ALR_WR_DAT_0_WR_DAT_	           (0xFFFFFFFFUL)	// RW

#define SE_ALR_WR_DAT_1		       (0x1802UL)
	#define	SE_ALR_WR_DAT_1_WR_DAT_	           (0xFFFFFFFFUL)	// RW

#define SE_ALR_RD_DAT_0		               (0x1805UL)
	#define	SE_ALR_RD_DAT_0_RD_DAT_            (0xFFFFFFFFUL)	// RW

#define SE_ALR_RD_DAT_1		       (0x1806UL)
#ifndef CHIP_IS_LAN9303
	#define	SE_ALR_RD_DAT_1_VLD_	                   	(0x01000000UL)	// RW
	#define	SE_ALR_RD_DAT_1_OVF_	                   	(0x00800000UL)	// RW
	#define	SE_ALR_RD_DAT_1_STC_	                   	(0x00400000UL)	// RW
	#define	SE_ALR_RD_DAT_1_PUR_	                   	(0x00200000UL)	// RW
	#define	SE_ALR_RD_DAT_1_PRI_	                   	(0x00180000UL)	// RW
	#define	SE_ALR_RD_DAT_1_SEL_                   		(0x00040000UL)	// RW
	#define	SE_ALR_RD_DAT_1_IDX_DP_	                	(0x00030000UL)	// RW
	#define	SE_ALR_RD_DAT_1_RD_DAT_	                	(0x0000FFFFUL)	// RW
#else
	#define SE_ALR_RD_DAT_1_VLD_                        (0x04000000UL)	//RW
	#define SE_ALR_RD_DAT_1_OVF_						(0x02000000UL)	//RW
	#define SE_ALR_RD_DAT_1_STC_                        (0x01000000UL)	//RW
	#define SE_ALR_RD_DAT_1_PUR_						(0x00800000UL)	//RW
	#define	SE_ALR_RD_DAT_1_PRI_ENBL_	                (0x00400000UL)	// RW
	#define	SE_ALR_RD_DAT_1_PRI_	                   	(0x00380000UL)	// RW
	#define	SE_ALR_RD_DAT_1_SEL_                   		(0x00040000UL)	// RW
	#define	SE_ALR_RD_DAT_1_IDX_DP_	                	(0x00030000UL)	// RW
	#define	SE_ALR_RD_DAT_1_RD_DAT_	                	(0x0000FFFFUL)	// RW
#endif
#define SE_ALR_STS				(0x1808UL)
	#define	SE_ALR_STS_INI_DONE_	                   	(0x00000002UL)	// RW
	#define	SE_ALR_STS_ALR_STS_	            		(0x00000001UL)	// RW

#define SE_ALR_CFG		            	(0x1809UL)
	#define	SE_ALR_CFG_ALR_INIT_	                   	(0x00000002UL)	// RW
	#define	SE_ALR_CFG_ALR_ALRTST_	                 	(0x00000001UL)	// RW


#define SE_VLAN_CMD		           	(0x180BUL)
#define	SE_VLAN_CMD_RD_N_WR_	                   	(0x00000020UL)	// RW
#define	SE_VLAN_CMD_PV_N_VL_	                   	(0x00000010UL)	// RW
#define	SE_VLAN_CMD_TBL_ADDR_	                  	(0x0000000FUL)	// RW
#define SE_VLAN_WR_DAT		        	(0x180CUL)
#define	SE_VLAN_WR_DAT_WR_DAT	                  	(0xFFFFFFFFUL)	// RW
#define SE_VLAN_RD_DAT		        	(0x180EUL)
#define	SE_VLAN_RD_DAT_RD_DAT	                  	(0xFFFFFFFFUL)	// RW
#define SE_VLAN_STS				(0x1810UL)
#define	SE_VLAN_STS_VLAN_STS_	                  	(0x00000001UL)	// R

#define SE_TBL_CMD				(0x1811UL)
#define	SE_TBL_CMD_RD_N_WR_		           	       (0x00000080UL)	// RW
#define	SE_TBL_CMD_TBL_ADDR_	                   (0x0000003FUL)	// RW
#define SE_TBL_WR_DAT		         	  (0x1812UL)
#define	SE_TBL_WR_DAT_WR_DAT	                   (0x00000007UL)	// RW
#define SE_TBL_RD_DAT		         	  (0x1813UL)
#define	SE_TBL_RD_DAT_RD_DAT            		   (0x00000007UL)	// RW
#define SE_TBL_STS				          (0x1814UL)
#define	SE_TBL_STS_TBL_STS_	            		   (0x00000001UL)	// R

#define SE_GLOBAL_INGRSS_CFG	          (0x1840UL)
#ifdef CHIP_IS_LAN9303
		/* Disable VLAN and ENABLE Port based  vid */
		#define SE_RX_CFG_VLAN_DSBL_					 (0x00008000UL)
		/* When Set, the priorty from teh VLAN Tag is enabled as a transmit
		 * 	priority queue choice */
		#define SE_RX_CFG_USE_TAG_EN_               (0x00004000UL)
#endif
		#define SE_RX_CFG_SNOOP_ECHO_EN_                 (0x00002000UL)
		#define	SE_RX_CFG_IGMP_MII_EN_				(0x00000400UL)	// RW
        #define	SE_RX_CFG_MLD_EN_			        (0x00000100UL)	// RW
        #define	SE_RX_CFG_IGMP_EN_				(0x00000080UL)	// RW
        #define	SE_RX_CFG_PTRN_SRCH_EN_		       		(0x00000040UL)	// RW
        #define	SE_RX_CFG_DA_H_PRI_			       	(0x00000020UL)	// RW
        #define	SE_RX_CFG_FLTR_MCST_		       		(0x00000010UL)	// RW
        #define	SE_RX_CFG_DRP_UNKN_			       	(0x00000008UL)	// RW
        #define	SE_RX_CFG_USE_PREC_			       	(0x00000004UL)	// RW
        #define	SE_RX_CFG_PRI_VL_H_IP_		       		(0x00000002UL)	// RW
        #define	SE_RX_CFG_VLAN_EN_			       	(0x00000001UL)	// RW


#define SE_EN_INGRS				         (0x1841UL)
#define	SE_EN_INGRS_VLAN_BASE_                      (0x00003F40UL)	// RW
#define	SE_EN_INGRS_LRN_EN_ 	                   	(0x00000038UL)	// RW
#define	SE_EN_INGRS_INGRS_EN_	                  	(0x00000007UL)	// RW
#define SE_ADMIT_O_VL		         	   (0x1842UL)
#define	SE_ADMIT_O_VL_ADMITOVL_                 	(0x00000007UL)	// RW
#define SE_PORT_STATE			           (0x1843UL)
#define	SE_PORT_STATE_PRT_STA_	                 	(0x00000007UL)	// RW
#define SE_RESERVED				           (0x1844UL)
#define SE_PRI_TO_QUE		         	   (0x1845UL)
#define	SE_PRI_TO_QUE_ENT_7_	                   	(0x0000C000UL)	// RW
#define	SE_PRI_TO_QUE_ENT_6_	                   	(0x00003000UL)	// RW
#define	SE_PRI_TO_QUE_ENT_5_	                   	(0x00000C00UL)	// RW
#define	SE_PRI_TO_QUE_ENT_4_	                   	(0x00000300UL)	// RW
#define	SE_PRI_TO_QUE_ENT_3_	                   	(0x000000C0UL)	// RW
#define	SE_PRI_TO_QUE_ENT_2_	                   	(0x00000030UL)	// RW
#define	SE_PRI_TO_QUE_ENT_1_	                   	(0x0000000CUL)	// RW
#define	SE_PRI_TO_QUE_ENT_0_	                   	(0x00000003UL)	// RW
#define SE_PRT_MIR				           (0x1846UL)
#define	SE_PRT_MIR_SNF_PRT_	            		    (0x000000E0UL)	// RW
#define	SE_PRT_MIR_MIR_PRT_	            		    (0x0000001CUL)	// RW
#define	SE_PRT_MIR_RX_EN_	              		    (0x00000002UL)	// RW
#define	SE_PRT_MIR_TX_EN_	              		    (0x00000001UL)	// RW
#define SE_ING_PRT_TYP		        	   (0x1847UL)
#define	SE_ING_PRT_TYP_TYP_2_	                  	(0x00000030UL)	// RW
#define	SE_ING_PRT_TYP_TYP_1_	                  	(0x0000000CUL)	// RW
#define	SE_ING_PRT_TYP_TYP_0_	                   	(0x00000003UL)	// RW
#define SE_BCST_THRT		          	   (0x1848UL)
#define	SE_BCST_THRT_LVL2_EN_	                  	(0x04000000UL)	// RW
#define	SE_BCST_THRT_LVL2_	               (0x03FC0000UL)	// RW
#define	SE_BCST_THRT_LVL1_EN_	                  	(0x00020000UL)	// RW
#define	SE_BCST_THRT_LVL1_ 	            		    (0x0001FE00UL)	// RW
#define	SE_BCST_THRT_LVL0_EN_	                    (0x00000100UL)	// RW
#define	SE_BCST_THRT_LVL0_	             		    (0x000000FFUL)	// RW
#define SE_ADM_N_ACT		          	  (0x1849UL)
#define	SE_ADM_N_ACT_ADM_N_ACT_         		   (0x00000007UL)	// RW
#define SE_RATE_CFG				          (0x184AUL)
        #define	SE_RATE_CFG_PRI_H_PTN_	                 	(0x00000002UL)	// RW
        #define	SE_RATE_CFG_ING_RAT_EN_	                	(0x00000001UL)	// RW

#define SE_INGRSS_RATE_CMD		           (0x184BUL)
        #define	SE_INGRSS_RATE_RW_			                (0x00000080UL)	// RW
        #define	SE_INGRSS_RATE_TYPE_		                (0x00000060UL)	// RW
        #define	SE_INGRSS_RATE_CIR_ADDR_	                (0x0000001FUL)	// RW
#define SE_INGRSS_RATE_CMD_STS	          (0x184CUL)
        #define	SE_INGRSS_RATE_BSY_MSK_		               (0x00000001UL)	// RO/SC
#define SE_INGRSS_RATE_WR_DAT	          (0x184DUL)
#define	SE_INGRSS_RATE_WR_DAT_MSK_	                        (0x0000FFFFUL)	// RW
#define SE_INGRSS_RATE_RD_DAT	          (0x184EUL)
        #define	SE_INGRSS_RATE_RD_DAT_MSK_	                 (0x0000FFFFUL)	// RW
#define SE_FILTERED_CNT_0		          (0x1850UL)
#define SE_FILTERED_CNT_1		          (0x1851UL)
#define SE_FILTERED_CNT_2		          (0x1852UL)
#define SE_INGRSS_REGEN_TBL_0	          (0x1855UL)
        #define	SE_INGRSS_REGEN_MSK_		              (0x00FFFFFFUL)	// RW
        #define	SE_INGRSS_REGEN7_MSK_		              (0x00E00000UL)	// RW
        #define	SE_INGRSS_REGEN6_MSK_		              (0x001C0000UL)	// RW
        #define	SE_INGRSS_REGEN5_MSK_		              (0x00038000UL)	// RW
        #define	SE_INGRSS_REGEN4_MSK_		              (0x00007000UL)	// RW
        #define	SE_INGRSS_REGEN3_MSK_		              (0x00000E00UL)	// RW
        #define	SE_INGRSS_REGEN2_MSK_		              (0x000001C0UL)	// RW
        #define	SE_INGRSS_REGEN1_MSK_		              (0x00000038UL)	// RW
        #define	SE_INGRSS_REGEN0_MSK_		              (0x00000007UL)	// RW
#define SE_INGRSS_REGEN_TBL_1	           (0x1856UL)
#define SE_INGRSS_REGEN_TBL_2	           (0x1857UL)
#define SE_LRN_DISCRD_CNT_0		           (0x1858UL)
#define SE_LRN_DISCRD_CNT_1		           (0x1859UL)
#define SE_LRN_DISCRD_CNT_2		           (0x185AUL)


#define SE_IMR					           (0x1880UL)
#define	SE_IMR_INT_EN_		        		              (0x00000001UL)	// RW
#define SE_IPR					           (0x1881UL)
        #define	SE_IPR_DRP_REA1_	               		  (0x00007800UL)	// RW
        #define	SE_IPR_SRC_PRT1_	               		  (0x00000600UL)	// RW
        #define	SE_IPR_SET_1_		         		      (0x00000100UL)	// RW
        #define	SE_IPR_DRP_REA0_	               		  (0x000000F0UL)	// RW
        #define	SE_IPR_SRC_PRT0_	               		  (0x0000000CUL)	// RW
        #define	SE_IPR_SET_0_		         		      (0x00000002UL)	// RW
        #define	SE_IPR_INT_PEN_		               		  (0x00000001UL)	// RW


/****************************** BUFFER MANAGEMENT *******************************************/
#define BM_CFG					(0x1C00UL)
#define	BM_CFG_EGR_RATE2_EN_	                   	(0x00000010UL)	// RW
#define	BM_CFG_EGR_RATE1_EN_	                   	(0x00000008UL)	// RW
#define	BM_CFG_EGR_RATE0_EN_	                   	(0x00000004UL)	// RW
#define	BM_CFG_DRP_ON_YEL_	             		(0x00000002UL)	// RW
#define	BM_CFG_DRP_ON_RED_	          		(0x00000001UL)	// RW
#define BM_DRP_LVL				(0x1C01UL)
#define	BM_DRP_LVL_LVL_L_	              		(0x0000FF00UL)	// RW
#define	BM_DRP_LVL_LVL_H_	              		(0x000000FFUL)	// RW
#define BM_FC_INS_LVL		         	(0x1C02UL)
#define	BM_FC_INS_LVL_LVL_L_	                   	(0x0000FF00UL)	// RW
#define	BM_FC_INS_LVL_LVL_H_	                   	(0x000000FFUL)	// RW
#define BM_FC_RST_LVL		          	(0x1C03UL)
#define	BM_FC_RST_LVL_RST_L_	                   	(0x0001FE00UL)	// RW
#define	BM_FC_RST_LVL_RST_H_	                   	(0x000001FFUL)	// RW
#define BM_BCST_LVL				(0x1C04UL)
#define	BM_BCST_LVL_BCST_LVL_	                  	(0x000001FFUL)	// RW
#define BM_DRP_CNT_SRC_0	               	(0x1C05UL)
#define	BM_DRP_CNT_SRC_0_DRP_CNT_               	(0x000000FFUL)	// R0R
#define BM_DRP_CNT_SRC_1	               	(0x1C06UL)
#define	BM_DRP_CNT_SRC_1_DRP_CNT_               	(0x000000FFUL)	// R0R
#define BM_DRP_CNT_SRC_2	               	(0x1C07UL)
#define	BM_DRP_CNT_SRC_2_DRP_CNT_               	(0x000000FFUL)	// R0R
#define BM_RST_STS				(0x1C08UL)
#define	BM_RST_STS_BM_RDY_	             		(0x000000FFUL)	// R0
#define BM_WTBL_CMD				(0x1C09UL)
#define	BM_WTBL_CMD_RD_N_WR_	                   	(0x00000010UL)	// RW
#define	BM_WTBL_CMD_TBL_ADD_	                   	(0x0000000FUL)	// RW
#define BM_WTBL_WDAT		          	(0x1C0AUL)
#define	BM_WTBL_WDAT_WDAT_	             		(0x000003FFUL)	// RW
#define BM_WTBL_RDAT		          	(0x1C0BUL)
#define	BM_WTBL_RDAT_RDAT_	             		(0x000003FFUL)	// RW
#define BM_PRT_TYP				(0x1C0CUL)
        #define	BM_PRT_TYP_INS_NV_2_	                    (0x00200000UL)	// RW
        #define	BM_PRT_TYP_CHG_VID_2_	                    (0x00100000UL)	// RW
        #define	BM_PRT_TYP_CHG_PRI_2_                       (0x00080000UL)	// RW
        #define	BM_PRT_TYP_CHG_V_2_	                        (0x00040000UL)	// RW
        #define	BM_PRT_TYP_EGR_PRT_2_	                    (0x00030000UL)	// RW
        #define	BM_PRT_TYP_INS_NV_1_	                    (0x00002000UL)	// RW
        #define	BM_PRT_TYP_CHG_VID_1_	                    (0x00001000UL)	// RW
        #define	BM_PRT_TYP_CHG_PRI_1_	                    (0x00000800UL)	// RW
        #define	BM_PRT_TYP_CHG_V_1_	          	            (0x00000400UL)	// RW
        #define	BM_PRT_TYP_EGR_PRT_1_	                    (0x00000300UL)	// RW
        #define	BM_PRT_TYP_INS_NV_0_	                    (0x00000020UL)	// RW
        #define	BM_PRT_TYP_CHG_VID_0_	             	    (0x00000010UL)	// RW
        #define	BM_PRT_TYP_CHG_PRI_0_	                    (0x00000008UL)	// RW
        #define	BM_PRT_TYP_CHG_V_0_	            	        (0x00000004UL)	// RW
        #define	BM_PRT_TYP_EGR_PRT_0_	                   (0x00000003UL)	// RW

#define BM_EGRSS_RATE_00_01		(0x1C0DUL)
        #define	BM_EGRSS_RATE_MII_PQ1_		(0x03FFE000UL)	// RW
        #define	BM_EGRSS_RATE_MII_PQ0_		(0x00001FFFUL)	// RW
        #define BM_EGRSS_RATE_02_03		(0x1C0EUL)
        #define	BM_EGRSS_RATE_MII_PQ3_		(0x03FFE000UL)	// RW
        #define	BM_EGRSS_RATE_MII_PQ2_		(0x00001FFFUL)	// RW
        #define BM_EGRSS_RATE_10_11		(0x1C0FUL)
        #define	BM_EGRSS_RATE_P1_PQ1_		(0x03FFE000UL)	// RW
        #define	BM_EGRSS_RATE_P1_PQ0_		(0x00001FFFUL)	// RW
        #define BM_EGRSS_RATE_12_13		(0x1C10UL)
        #define	BM_EGRSS_RATE_P1_PQ3_		(0x03FFE000UL)	// RW
        #define	BM_EGRSS_RATE_P1_PQ2_		(0x00001FFFUL)	// RW
        #define BM_EGRSS_RATE_20_21		(0x1C11UL)
        #define	BM_EGRSS_RATE_P2_PQ1_		(0x03FFE000UL)	// RW
        #define	BM_EGRSS_RATE_P2_PQ0_		(0x00001FFFUL)	// RW
        #define BM_EGRSS_RATE_22_23		(0x1C12UL)
        #define	BM_EGRSS_RATE_P2_PQ3_		(0x03FFE000UL)	// RW
        #define	BM_EGRSS_RATE_P2_PQ2_		(0x00001FFFUL)	// RW
#define BM_VLAN_0				(0x1C13UL)
        #define	BM_VLAN_0_VLN_PRI_			(0x00007000UL)	// RW
        #define	BM_VLAN_0_VLN_ID_			(0x00000FFFUL)	// RW
#define BM_VLAN_1				(0x1C14UL)
        #define	BM_VLAN_1_VLN_PRI_			(0x00007000UL)	// RW
        #define	BM_VLAN_1_VLN_ID_			(0x00000FFFUL)	// RW
#define BM_VLAN_2				(0x1C15UL)
    #define	BM_VLAN_2_VLN_PRI_			(0x00007000UL)	// RW
#define	BM_VLAN_3_VLN_ID_			(0x00000FFFUL)	// RW
#define BM_RATE_DRP_CNT_SRC0	(0x1C16UL)
#define BM_RATE_DRP_CNT_SRC1	(0x1C17UL)
#define BM_RATE_DRP_CNT_SRC2	(0x1C18UL)
#define BM_IMR					(0x1C20UL)
        #define	BM_IMR_5_EN_				(0x00000020UL)	// RW
        #define	BM_IMR_4_EN_				(0x00000010UL)	// RW
        #define	BM_IMR_3_EN_				(0x00000008UL)	// RW
        #define	BM_IMR_2_EN_				(0x00000004UL)	// RW
        #define	BM_IMR_1_EN_				(0x00000002UL)	// RW
        #define	BM_IMR_0_EN_				(0x00000001UL)	// RW
#define BM_IPR					(0x1C21UL)
#define	BM_IPR_DRP_REA_				(0x00000038UL)	// ROR
#define	BM_IPR_SRC_PRT_				(0x00000006UL)	// ROR
#define	BM_IPR_INT_PEN_				(0x00000001UL)	// ROR


/****************************** MDIO (reserved)**********************************************/
#define MDIO_COMMAND			(0x2400UL) // RESERVED
#define MDIO_RDDATA				(0x2401UL) // RESERVED
#define MDIO_STATUS				(0x2402UL) // RESERVED
#define MDIO_CLK_SPEED			(0x2403UL) // RESERVED
#define MDIO_IMR				(0x2408UL) // RESERVED
#define MDIO_IPR				(0x2409UL) // RESERVED
#define MDIO_ISR				(0x240AUL) // RESERVED

#define PHY_CTL					(0x00UL)
#define PHY_STS					(0x01UL)
#define PHY_ID_MSB				(0x02UL)
#define PHY_ID_LSB				(0x03UL)
#define PHY_AN_ADV_1			(0x04UL)
#define PHY_AN_ABIL_1			(0x05UL)
#define PHY_AN_EXP				(0x06UL)
#define REG7					(0x07UL)
#define REG8					(0x08UL)
#define REG9					(0x09UL)
#define REG10					(0x0AUL)
#define REG11					(0x0BUL)
#define REG12					(0x0CUL)
#define REG13					(0x0DUL)
#define REG14					(0x0EUL)
#define PHY_EXT_STS				(0x0FUL)
#define PHY_SIL_REV_1			(0x10UL)
#define PHY_CNTL_STS_1			(0x11UL)
#define PHY_SPC_MODES_1			(0x12UL)
#define REG19					(0x13UL)
#define PHY_TST_CNTL_1			(0x14UL)
#define PHY_TST_READ1_1			(0x15UL)
#define PHY_TST_READ1_2			(0x16UL)
#define PHY_TST_WRITE_1			(0x17UL)
#define REG24					(0x18UL)
#define REG25					(0x19UL)
#define REG26					(0x1AUL)
#define PHY_SPC_CNTL_STS_IND	(0x1BUL)
#define PHY_SPC_TEST_ABIL_1		(0x1CUL)
#define PHY_INT_SRC_1			(0x1DUL)
#define PHY_INT_MSK_1			(0x1EUL)
#define PHY_SPC_CNTL_STS		(0x1FUL)

typedef struct SWITCH_REG_DEF{
        char *name;
        unsigned int index;
}SWITCH_REG_DEF;


SWITCH_REG_DEF SwitchRegDef [] = {

{" GLB_ID",GLB_ID},
{" GLB_RST",GLB_RST},
{" GLB_IMR",GLB_IMR},
{" GLB_IPR", GLB_IPR},
{" GLB_ISR",GLB_ISR},
////////////////////////////////////
//  MII port
////////////////////////////////////
{" MII_VER_ID", MII_VER_ID},
{"   MII_RX_CFG",MII_RX_CFG},
{"   MII_RX_UNDSZE_CNT", MII_RX_UNDSZE_CNT},
{"   MII_RX_64_CNT", MII_RX_64_CNT},
{"   MII_RX_65_TO_127_CNT", MII_RX_65_TO_127_CNT},
{"   MII_RX_128_TO_255_CNT", MII_RX_128_TO_255_CNT},
{"   MII_RX_256_TO_511_CNT", MII_RX_256_TO_511_CNT},
{"   MII_RX_512_TO_1023_CNT", MII_RX_512_TO_1023_CNT},
{"   MII_RX_1024_TO_MAX_CNT", MII_RX_1024_TO_MAX_CNT},
{"   MII_RX_OVRSZE_CNT", MII_RX_OVRSZE_CNT},
{"   MII_RX_PKTOK_CNT", MII_RX_PKTOK_CNT},
{"   MII_RX_CRCERR_CNT",MII_RX_CRCERR_CNT},
{"   MII_RX_MULCST_CNT", MII_RX_MULCST_CNT},
{"   MII_RX_BRDCST_CNT",MII_RX_BRDCST_CNT},
{"   MII_RX_PAUSE_CNT",MII_RX_PAUSE_CNT},
{"   MII_RX_PKTLEN_CNT",MII_RX_PKTLEN_CNT},
{"   MII_RX_FRAG_CNT",MII_RX_FRAG_CNT},
{"	 MII_RX_JABB_CNT", MII_RX_JABB_CNT},
{"	 MII_RX_ALIGN_CNT", MII_RX_ALIGN_CNT},
{"	 MII_RX_GOOD_PKTLEN_CNT", MII_RX_GOOD_PKTLEN_CNT},
{"	 MII_RX_SYMBL_CNT", MII_RX_SYMBL_CNT},
{"	 MII_RX_CTLFRM_CNT", MII_RX_CTLFRM_CNT},
{"   MII_TX_CFG", MII_TX_CFG},
{"   MII_TX_FC_STNGS", MII_TX_FC_STNGS},
{"   MII_TX_UNDRUN_CNT", MII_TX_UNDRUN_CNT},
{"   MII_TX_DEFER_CNT", MII_TX_DEFER_CNT},
{"   MII_TX_PAUSE_CNT", MII_TX_PAUSE_CNT},
{"   MII_TX_PKTOK_CNT",MII_TX_PKTOK_CNT},
{"   MII_TX_64_CNT",MII_TX_64_CNT},
{"   MII_TX_65_TO_127_CNT",MII_TX_65_TO_127_CNT},
{"   MII_TX_128_TO_255_CNT",MII_TX_128_TO_255_CNT},
{"   MII_TX_256_TO_511_CNT",MII_TX_256_TO_511_CNT},
{"   MII_TX_512_TO_1023_CNT",MII_TX_512_TO_1023_CNT},
{"   MII_TX_1024_TO_MAX_CNT", MII_TX_1024_TO_MAX_CNT},
{"   MII_TX_UNDSZE_CNT",MII_TX_UNDSZE_CNT},
{"   MII_TX_PKTLEN_CNT",MII_TX_PKTLEN_CNT },
{"	 MII_TX_BRDCST_CNT",MII_TX_BRDCST_CNT },
{"   MII_TX_MULCST_CNT",MII_TX_MULCST_CNT},
{"	 MII_TX_LATECOL_CNT",MII_TX_LATECOL_CNT},
{"	 MII_TX_EXCCOL_CNT", MII_TX_EXCCOL_CNT},
{"	 MII_TX_SNGLECOL_CNT",MII_TX_SNGLECOL_CNT},
{"	 MII_TX_MULTICOL_CNT", MII_TX_MULTICOL_CNT},
{"   MII_TX_TOTALCOL_CNT",MII_TX_TOTALCOL_CNT},
{"   MII_IMR",MII_IMR},
{"   MII_IPR",MII_IPR},
////////////////////////////////////
//   port 1
////////////////////////////////////
{" PORT_1_VER_ID", MII_VER_ID + 0x400},
{"   PORT_1_RX_CFG",MII_RX_CFG + 0x400},
{"   PORT_1_RX_UNDSZE_CNT", MII_RX_UNDSZE_CNT + 0x400},
{"   PORT_1_RX_64_CNT", MII_RX_64_CNT + 0x400},
{"   PORT_1_RX_65_TO_127_CNT", MII_RX_65_TO_127_CNT + 0x400},
{"   PORT_1_RX_128_TO_255_CNT", MII_RX_128_TO_255_CNT + 0x400},
{"   PORT_1_RX_256_TO_511_CNT", MII_RX_256_TO_511_CNT + 0x400},
{"   PORT_1_RX_512_TO_1023_CNT", MII_RX_512_TO_1023_CNT + 0x400},
{"   PORT_1_RX_1024_TO_MAX_CNT", MII_RX_1024_TO_MAX_CNT + 0x400},
{"   PORT_1_RX_OVRSZE_CNT", MII_RX_OVRSZE_CNT + 0x400},
{"   PORT_1_RX_PKTOK_CNT", MII_RX_PKTOK_CNT + 0x400},
{"   PORT_1_RX_CRCERR_CNT",MII_RX_CRCERR_CNT + 0x400},
{"   PORT_1_RX_MULCST_CNT", MII_RX_MULCST_CNT + 0x400},
{"   PORT_1_RX_BRDCST_CNT",MII_RX_BRDCST_CNT + 0x400},
{"   PORT_1_RX_PAUSE_CNT",MII_RX_PAUSE_CNT + 0x400},
{"   PORT_1_RX_PKTLEN_CNT",MII_RX_PKTLEN_CNT + 0x400},
{"   PORT_1_RX_FRAG_CNT",MII_RX_FRAG_CNT + 0x400},
{"	 PORT_1_RX_JABB_CNT", MII_RX_JABB_CNT+0x400},
{"	 PORT_1_RX_ALIGN_CNT", MII_RX_ALIGN_CNT+0x400},
{"	 PORT_1_RX_GOOD_PKTLEN_CNT", MII_RX_GOOD_PKTLEN_CNT+0x400},
{"	 PORT_1_RX_SYMBL_CNT", MII_RX_SYMBL_CNT+0x400},
{"	 PORT_1_RX_CTLFRM_CNT", MII_RX_CTLFRM_CNT+0x400},
{"   PORT_1_TX_CFG", MII_TX_CFG+400 + 0x400},
{"   PORT_1_TX_FC_STNGS", MII_TX_FC_STNGS + 0x400},
{"   PORT_1_TX_UNDRUN_CNT", MII_TX_UNDRUN_CNT + 0x400},
{"   PORT_1_TX_DEFER_CNT", MII_TX_DEFER_CNT + 0x400},
{"   PORT_1_TX_PAUSE_CNT", MII_TX_PAUSE_CNT + 0x400},
{"   PORT_1_TX_PKTOK_CNT",MII_TX_PKTOK_CNT + 0x400},
{"   PORT_1_TX_64_CNT",MII_TX_64_CNT + 0x400},
{"   PORT_1_TX_65_TO_127_CNT",MII_TX_65_TO_127_CNT + 0x400},
{"   PORT_1_TX_128_TO_255_CNT",MII_TX_128_TO_255_CNT + 0x400},
{"   PORT_1_TX_256_TO_511_CNT",MII_TX_256_TO_511_CNT + 0x400},
{"   PORT_1_TX_512_TO_1023_CNT",MII_TX_512_TO_1023_CNT + 0x400},
{"   PORT_1_TX_1024_TO_MAX_CNT", MII_TX_1024_TO_MAX_CNT + 0x400},
{"   PORT_1_TX_UNDSZE_CNT",MII_TX_UNDSZE_CNT + 0x400},
{"   PORT_1_TX_PKTLEN_CNT",MII_TX_PKTLEN_CNT + 0x400},
{"	 PORT_1_TX_BRDCST_CNT",MII_TX_BRDCST_CNT + 0x400 },
{"   PORT_1_TX_MULCST_CNT",MII_TX_MULCST_CNT + 0x400},
{"	 PORT_1_TX_LATECOL_CNT",MII_TX_LATECOL_CNT + 0x400},
{"	 PORT_1_TX_EXCCOL_CNT", MII_TX_EXCCOL_CNT + 0x400},
{"	 PORT_1_TX_SNGLECOL_CNT",MII_TX_SNGLECOL_CNT + 0x400},
{"	 PORT_1_TX_MULTICOL_CNT", MII_TX_MULTICOL_CNT + 0x400},
{"   PORT_1_TX_TOTALCOL_CNT",MII_TX_TOTALCOL_CNT + 0x400},
{"   PORT_1_IMR",MII_IMR + 0x400},
{"   PORT_1_IPR",MII_IPR + 0x400},
 ////////////////////////
// Port 2
////////////////////////////
{" PORT_2_VER_ID", MII_VER_ID + 0x800},
{"   PORT_2_RX_CFG",MII_RX_CFG + 0x800},
{"   PORT_2_RX_UNDSZE_CNT", MII_RX_UNDSZE_CNT + 0x800},
{"   PORT_2_RX_64_CNT", MII_RX_64_CNT + 0x800},
{"   PORT_2_RX_65_TO_127_CNT", MII_RX_65_TO_127_CNT + 0x800},
{"   PORT_2_RX_128_TO_255_CNT", MII_RX_128_TO_255_CNT + 0x800},
{"   PORT_2_RX_256_TO_511_CNT", MII_RX_256_TO_511_CNT + 0x800},
{"   PORT_2_RX_512_TO_1023_CNT", MII_RX_512_TO_1023_CNT + 0x800},
{"   PORT_2_RX_1024_TO_MAX_CNT", MII_RX_1024_TO_MAX_CNT + 0x800},
{"   PORT_2_RX_OVRSZE_CNT", MII_RX_OVRSZE_CNT + 0x800},
{"   PORT_2_RX_PKTOK_CNT", MII_RX_PKTOK_CNT + 0x800},
{"   PORT_2_RX_CRCERR_CNT",MII_RX_CRCERR_CNT + 0x800},
{"   PORT_2_RX_MULCST_CNT", MII_RX_MULCST_CNT + 0x800},
{"   PORT_2_RX_BRDCST_CNT",MII_RX_BRDCST_CNT + 0x800},
{"   PORT_2_RX_PAUSE_CNT",MII_RX_PAUSE_CNT + 0x800},
{"   PORT_2_RX_PKTLEN_CNT",MII_RX_PKTLEN_CNT + 0x800},
{"   PORT_2_RX_FRAG_CNT",MII_RX_FRAG_CNT + 0x800},
{"	 PORT_2_RX_JABB_CNT", MII_RX_JABB_CNT+0x800},
{"	 PORT_2_RX_ALIGN_CNT", MII_RX_ALIGN_CNT+0x800},
{"	 PORT_2_RX_GOOD_PKTLEN_CNT", MII_RX_GOOD_PKTLEN_CNT+0x800},
{"	 PORT_2_RX_SYMBL_CNT", MII_RX_SYMBL_CNT+0x800},
{"	 PORT_2_RX_CTLFRM_CNT", MII_RX_CTLFRM_CNT+0x800},
{"   PORT_2_TX_CFG", MII_TX_CFG + 0x800},
{"   PORT_2_TX_FC_STNGS", MII_TX_FC_STNGS + 0x800},
{"   PORT_2_TX_UNDRUN_CNT", MII_TX_UNDRUN_CNT + 0x800},
{"   PORT_2_TX_DEFER_CNT", MII_TX_DEFER_CNT + 0x800},
{"   PORT_2_TX_PAUSE_CNT", MII_TX_PAUSE_CNT + 0x800},
{"   PORT_2_TX_PKTOK_CNT",MII_TX_PKTOK_CNT + 0x800},
{"   PORT_2_TX_64_CNT",MII_TX_64_CNT + 0x800},
{"   PORT_2_TX_65_TO_127_CNT",MII_TX_65_TO_127_CNT + 0x800},
{"   PORT_2_TX_128_TO_255_CNT",MII_TX_128_TO_255_CNT + 0x800},
{"   PORT_2_TX_256_TO_511_CNT",MII_TX_256_TO_511_CNT + 0x800},
{"   PORT_2_TX_512_TO_1023_CNT",MII_TX_512_TO_1023_CNT + 0x800},
{"   PORT_2_TX_1024_TO_MAX_CNT", MII_TX_1024_TO_MAX_CNT + 0x800},
{"   PORT_2_TX_UNDSZE_CNT",MII_TX_UNDSZE_CNT + 0x800},
{"   PORT_2_TX_PKTLEN_CNT",MII_TX_PKTLEN_CNT+ 0x800},
{"	 PORT_2_TX_BRDCST_CNT",MII_TX_BRDCST_CNT + 0x800 },
{"   PORT_2_TX_MULCST_CNT",MII_TX_MULCST_CNT + 0x800},
{"	 PORT_2_TX_LATECOL_CNT",MII_TX_LATECOL_CNT + 0x800},
{"	 PORT_2_TX_EXCCOL_CNT", MII_TX_EXCCOL_CNT + 0x800},
{"	 PORT_2_TX_SNGLECOL_CNT",MII_TX_SNGLECOL_CNT + 0x800},
{"	 PORT_2_TX_MULTICOL_CNT", MII_TX_MULTICOL_CNT + 0x800},
{"   PORT_2_TX_TOTALCOL_CNT",MII_TX_TOTALCOL_CNT + 0x800},
{"   PORT_2_IMR",MII_IMR + 0x800},
{"   PORT_2_IPR",MII_IPR + 0x800}
};
#define SWITCH_MAX_REG_INDEX    (sizeof(SwitchRegDef)/sizeof(SwitchRegDef[0]) )    // pump it if adding more register
 typedef struct switchMibCounters_s {
    unsigned long   etherStatsFragments            ; //   MII_RX_UNDSZE_CNT
    unsigned long   etherStatsUndersisePkts		   ; // MII_RX_UNDSZE_CNT
    unsigned long   etherStatsPkts64Octets         ; //   MII_RX_64_CNT", MII_RX_64_CNT
    unsigned long   etherStatsPkts65to127Octets    ; //   MII_RX_65_TO_127_CNT
    unsigned long   etherStatsPkts128to255Octets   ; //   MII_RX_128_TO_255_CNT
    unsigned long   etherStatsPkts256to511Octets   ; //   MII_RX_256_TO_511_CNT
    unsigned long   etherStatsPkts512to1023Octets  ; //   MII_RX_512_TO_1023_CNT
    unsigned long   etherStatsPkts1024to1518Octets ; //   MII_RX_1024_TO_MAX_CNT
    unsigned long   etherStatsOversizePkts         ; //   MII_RX_OVRSZE_CNT
    unsigned long   ifInPkts                       ; //   MII_RX_PKTOK_CNT
    unsigned long   ifInErrors                     ; //   MII_RX_CRCERR_CNT
    unsigned long 	etherStatsRxJabbCnt			   ; // MII_RX_JABB_CNT
//    unsigned long 	etherStatsRxAlignCnt			; // MII_RX_ALIGN_CNT
    unsigned long   etherStatsRxMulticastPkts        ; //   MII_RX_MULCST_CNT
    unsigned long   etherStatsRxBroadcastPkts        ; //   MII_RX_BRDCST_CNT
    unsigned long   etherMacControlPkts            ; //   MII_RX_CTLFRM_CNT
    unsigned long   etherStatsRxPauseFrms          ; //   MII_RX_PAUSE_CNT
    unsigned long long   ifInOctets                 ; //   MII_RX_PKTLEN_L_CNT
    //unsigned long   ifInOctetsHigh                 ; //   MII_RX_PKTLEN_H_CNT
    unsigned long 	etherStatsTxMulitcastPkts    ; // MII_TX_MULCST_CNT
    unsigned long   etherStatsTxBroadcastPkts    ; // MII_TX_BRDCST_CNT

    unsigned long   ifOutUnderRun                ; //    MII_TX_UNDRUN_CNT
    unsigned long   etherDeferredTransmitted     ; //  MII_TX_DEFER_CNT
    unsigned long   etherPauseTransmitted        ; //  MII_TX_PAUSE_CNT
    unsigned long   ifOutPkts                    ; //  MII_TX_PKTOK_CNT

    unsigned long   ifOutUnderSize               ; // MII_TX_UNDSZE_CNT
    unsigned long long   ifOutOctets               ; // MII_TX_PKTLEN_L_CNT
    //unsigned long   ifOutOctetsHigh              ; // MII_TX_PKTLEN_H_CNT
    unsigned long   etherStatsAllignmentErrors    ; //MII_RX_ALIGN_CNT
    unsigned long   etherStatsFCSErrors			  ; // NOT SEPERATE COUNTER
    unsigned long   etherStatsSingleCollisionFrms ; // MII_TX_SNGLECOL_CNT
    unsigned long   etherStatsMultCollisionFrms;   // MII_TX_MULTICOL_CNT
    unsigned long   etherStatsSQETestErrors; // NOT Implemented
    unsigned long   etherStatsLateCollisionFrms; // MII_TX_LATECOL_CNT
    unsigned long   etherStatsExcessCollisionFrms; //MII_TX_EXCCOL_CNT
    unsigned long   etherStatsIntMacTxErrors; // not Implemented
    unsigned long   etherStatsCarrierSenseErrors; // CarrierSense Errors
    unsigned long   etherStatsIntMacRxErrors ; // not Implemented
    unsigned long   etherStatsSymbolErrors; // MII_RX_SYMBL_CNT
    unsigned long   etherStatsTotCollisionCnt; // MII_TX_TOTALCOL_CNT
    unsigned long   etherStatsDropEvents; // Reads from BM_DRP_CNT_SRC , and BM_RATE_DRP_CNT_SRC)
    unsigned long   SwitchLearnDiscrdCnt; //Reads from the the switchRegs (SWE_LRN_DISCRD_CNT_MII, SWE_LRN_DISCRD_CNT_1, and 2 ) */
    unsigned long   SwitchBMDropCnt; //Reads from the SwitchRegs to calculate the bUffer Manager Drop Count */
    unsigned long   SwitchFilteredCnt; //Reads from the SwitchRegs Ingressed Filtered Count */
    unsigned long SwitchBMRateDropCnt; // Reads from the BM_RATE_DRP_CNT_SRc
 } SwitchMibCounters;
 // SwitchMibCounters       switchMibCounter[PHY_NUMBER];
#endif

//
