#usage: port.pri port priority
#will write to SWE_INGRSS_REGEN_TBL,
#mapping all rx priorities to priority (arg 2)

if [ $# -ne 2 ]; then
  echo usage: port.pri port priority
  exit
elif [ $1 -gt 2 ]; then
  echo values for port must be 0, 1, or 2
  exit
fi

port=$1
pri=$2

SWE_INGRSS_REGEN_TBL_0=1855
DFLT_REG_VAL=FAC688

reg_addr=`expr $SWE_INGRSS_REGEN_TBL_0 + $port`		#neighboring addresses

case $pri in 
0) reg_val="0"
   ;;
1) reg_val="249249"
   ;;
2) reg_val="492492"
   ;;
3) reg_val="6DB6DB"
   ;;
4) reg_val="924924"
   ;;
5) reg_val="B6DB6D"
   ;;
6) reg_val="DB6DB6"
   ;;
7) reg_val="FFFFFF"
   ;;
-)
   reg_val=$DFLT_REG_VAL	#reset to default
   ;;
*) echo invalid priority value
   echo values must be between 0-7 inclusive, or \'-\' to reset to default
   exit
esac

setreg $reg_addr $reg_val
