# usage: dfsrv.map dscp pri
# dscp = diffserv code point (values 0-63)
# pri = priority value (0-7)

VALID_ARGS=0			# script will fail unless args are OK
DFSRV_TBL_CMD=1811		# hex addr of diffserve tbl cmd reg
DFSRV_TBL_WR=1812		# hex addr of diffserve tbl write reg
DFSRV_TBL_RD=1813		# hex addr of diffserve tbl read reg
DFSRV_TBL_CMD_STAT=1814		# hex addr of diffserve tbl cmd status reg
DFSRV_READ_BIT=7		# bit to set in diffserv tbl cmd reg to read val

export DEBUG_SCRIPTS=yes	# needed for regval=`setreg...` in this script

if [ $# -ne 1 ]; then
    echo  usage: dfsrv.rd dscp
elif [ $1 -gt 63 ] || [ $1 -lt 0 ]; then
    echo arg 1: diffserv value must be between 0 and 63
else
    VALID_ARGS=1
    DSCP=$1
    DSCP_HEX=`int2hex $DSCP`
fi

if [ $VALID_ARGS -eq 0 ]; then
    exit
fi

#get pri for this DSCP and display it

SET_CMD_RD=`bset $DSCP $DFSRV_READ_BIT`   #val to set cmd reg to for reading

regval=`setreg $DFSRV_TBL_CMD $SET_CMD_RD | awk '{print $NF}'`
dscp=`bclr $regval $DFSRV_READ_BIT | awk -f $CONFIG_SCRIPTS_UTILDIR/hex2int`

#wait while busy...
while [ `getreg2 $DFSRV_CMD_STATUS | cut -c 7` -gt 0 ]
do
echo .
done

pri=`getreg2 $DFSRV_TBL_RD | cut -c 8`

echo priority set to $pri for DSCP $dscp
