#!/bin/ash

# These are simple Netperf TCP_STREAM & UDP_STREAM tests using packet sizes 64, 512, and 1472.
# To run this script you must have the netperf binary located at the sqa/x86
# path on your test generator Linux PC and the device under test. You must also have the netserver
# binary running on both the test generator and the device under test before starting this script.
# Generally, the TCP_STREAM results will be higher than UDP_STREAM results unless your driver has
# been tuned for optimum UDP performance with your particular system. This script should be run from
# the test generator and the device under test so that traffic is tested in both directions. Run the
# test in one direction only then try running it bi-directionally to stress your system some more.
# Press CTRL-C to exit this script.
#

# ********************************************************************
# ********************************************************************

COUNTER=0
TARGET_IP=10.0.30.1
NETPERF=netperf

#while [ 1 ]
#do {

date >> npoutput
date
echo ============================================== >> npoutput
echo COUNTER=$COUNTER, SECONDS=$SECONDS >> npoutput
echo COUNTER=$COUNTER, SECONDS=$SECONDS
echo ============================================== >> npoutput
echo >> npoutput
echo
#echo Netperf Sanity check to see if test is wired properly
#echo
#echo >> npoutput

#echo run netperf -H $TARGET_IP -t TCP_STREAM
#$NETPERF -H $TARGET_IP -t TCP_STREAM

# BEGIN TESTING WITH NETPERF

echo Starting TCP/UDP Throughput Regression Tests. Check ""npoutput"" file for test results
echo Starting TCP/UDP Throughput Regression Tests >> npoutput

echo regression check TCP throughput with ascending packet sizes >> npoutput
echo regression check TCP throughput with ascending packet sizes
echo run netperf -H $TARGET_IP -t TCP_STREAM -l 10 -- -m 64 >> npoutput
$NETPERF -H $TARGET_IP -t TCP_STREAM -l 10 -- -m 64 >> npoutput
echo ----------------------------------------------------------- >> npoutput
echo -----------------------------------------------------------
sleep 1

echo regression check TCP throughput with ascending packet sizes >> npoutput
echo regression check TCP throughput with ascending packet sizes
echo run netperf -H $TARGET_IP -t TCP_STREAM -l 10 -- -m 512 >> npoutput
$NETPERF -H $TARGET_IP -t TCP_STREAM -l 10 -- -m 512 >> npoutput
echo ----------------------------------------------------------- >> npoutput
echo -----------------------------------------------------------
sleep 1

echo regression check TCP throughput with ascending packet sizes >> npoutput
echo regression check TCP throughput with ascending packet sizes
echo run netperf -H $TARGET_IP -t TCP_STREAM -l 10 -- -m 1472 >> npoutput
$NETPERF -H $TARGET_IP -t TCP_STREAM -l 10 -- -m 1472 >> npoutput
echo ----------------------------------------------------------- >> npoutput
echo -----------------------------------------------------------
sleep 1

echo regression check UDP throughput with ascending packet size >> npoutput
echo regression check UDP throughput with ascending packet size
echo run netperf -H $TARGET_IP -t UDP_STREAM -l 10 -- -m 64 >> npoutput
$NETPERF -H $TARGET_IP -t UDP_STREAM -l 10 -- -m 64 >> npoutput
echo ----------------------------------------------------------- >> npoutput
echo -----------------------------------------------------------
sleep 1

echo regression check UDP throughput with ascending packet size >> npoutput
echo regression check UDP throughput with ascending packet size
echo run netperf -H $TARGET_IP -t UDP_STREAM -l 10 -- -m 512 >> npoutput
$NETPERF -H $TARGET_IP -t UDP_STREAM -l 10 -- -m 512 >> npoutput
echo ----------------------------------------------------------- >> npoutput
echo -----------------------------------------------------------
sleep 1

echo regression check UDP throughput with ascending packet size >> npoutput
echo regression check UDP throughput with ascending packet size
echo run netperf -H $TARGET_IP -t UDP_STREAM -l 10 -- -m 1472 >> npoutput
$NETPERF -H $TARGET_IP -t UDP_STREAM -l 10 -- -m 1472 >> npoutput
echo ----------------------------------------------------------- >> npoutput
echo -----------------------------------------------------------
sleep 1

echo
echo >> npoutput
echo Ended TCP/UDP Throughput Regression Tests.
echo Ended TCP/UDP Throughput Regression Tests. Check ""npoutput"" file for test results >> npoutput
date
date >> npoutput
echo ----------------------------------------------------------- >> npoutput
echo -----------------------------------------------------------
sleep 1

#COUNTER=$(( $COUNTER+1 ))
#};

#done
